SystemOrganization addCategory: #'Orca-Cache'!
SystemOrganization addCategory: #'Orca-Server'!
SystemOrganization addCategory: #'Orca-Applications'!
SystemOrganization addCategory: #'Orca-Examples-ClassBrowser'!
SystemOrganization addCategory: #'Orca-Examples-Workspace'!
SystemOrganization addCategory: #'Orca-Widgets'!
SystemOrganization addCategory: #'Orca-Examples-BallGame'!
SystemOrganization addCategory: #'Orca-Stubs'!
SystemOrganization addCategory: #'Orca-Tests'!
SystemOrganization addCategory: #'Orca-Translator'!
SystemOrganization addCategory: #'Orca-Examples-System-Status'!
SystemOrganization addCategory: #'Orca-Installer'!
SystemOrganization addCategory: #'Orca-RemoteObjects'!

!Character methodsFor: '*Orca' stamp: 'ag 3/1/2011 16:03'!
definitionLine
	
	^ S2JSqueakAstToJsAst charFunction asString, '(', (S2JAbstractPrinter asJSString: self asString), ')'! !

Object subclass: #OCAbstractCodeFactory
	instanceVariableNames: 'codeCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

OCAbstractCodeFactory class
	instanceVariableNames: 'instance'!

!OCAbstractCodeFactory commentStamp: 'ag 12/16/2010 12:46' prior: 0!
S2JCodeFactory readAllCodeInImage.

S2JCodeFactory clearCache.

S2JCodeFactory codeCache size. 84964. 64386. " 62492 !!!! ".

S2JCodeFactory codeFor: 'a doit-snippet squeak code'.

S2JCodeFactory  codeForClass: Object.

S2JCodeFactory codeForMethod: #asString of: Object.
!

OCAbstractCodeFactory class
	instanceVariableNames: 'instance'!

!OCAbstractCodeFactory class methodsFor: 'cache' stamp: 'ag 3/28/2011 10:26'!
clearCaches
	
	self subclassesDo: [ :cl | cl clearCache ].! !

!OCAbstractCodeFactory class methodsFor: 'converting' stamp: 'ag 1/5/2011 22:12'!
converterClass
	
	self subclassResponsibility! !

!OCAbstractCodeFactory class methodsFor: 'singleton' stamp: 'ag 12/16/2010 11:44'!
destroyInstance
	
	instance := nil.! !

!OCAbstractCodeFactory class methodsFor: 'singleton' stamp: 'ag 12/13/2010 15:43'!
doesNotUnderstand: aMessage
	"removes need to call instance every time the code-factory is accessed"
	
	^ self instance perform: aMessage selector withArguments: aMessage arguments! !

!OCAbstractCodeFactory class methodsFor: 'configuration' stamp: 'lw 3/28/2011 13:25'!
doesNotUnderstandClass

	^ '_DoesNotUnderstandClass_'! !

!OCAbstractCodeFactory class methodsFor: 'singleton' stamp: 'ag 12/16/2010 11:09'!
instance
	
	instance ifNil: [ instance := self new ].
	^ instance! !

!OCAbstractCodeFactory methodsFor: 'private' stamp: 'LT 3/16/2011 12:32:24.791'!
cacheCodeFor: anObject producedBy: aBlock
	
	^ (self cacheObjectFor: anObject producedBy: aBlock) javaScriptCode! !

!OCAbstractCodeFactory methodsFor: 'private' stamp: 'sec 2/21/2011 19:06'!
cacheObjectFor: anObject producedBy: aBlock
	"cacheObject* returns the value in the dictionary, not the javascript-code (this is done by cacheCodeFor*)"
	
	| result |
	result := self codeCache at: anObject ifAbsent: [ nil ].
	result
		ifNil: [
			result := aBlock value.
			[ result update ] on: Error do: [
				result := S2JCompilationError from: anObject inFactory: self. result update ].
			self codeCache at: anObject put: result ]
		ifNotNil: [
			result hasChanged ifTrue: [ result update ]].
	^ result! !

!OCAbstractCodeFactory methodsFor: 'private' stamp: 'LT 3/16/2011 12:21:11.649'!
cacheObjectForClass: aClassOrClassname
	"cacheObject* returns the value in the dictionary, not the javascript-code (this is done by cacheCodeFor*)"
	
	| cl |
	cl := self class converterClass classNamed: aClassOrClassname.
	^ self
		cacheObjectFor: cl
		producedBy: [ S2JTranslatedClass from: cl inFactory: self ]! !

!OCAbstractCodeFactory methodsFor: 'private' stamp: 'LT 3/16/2011 12:20:07.366'!
cacheObjectForMethod: aCompiledMethod
	"cacheObject* returns the value in the dictionary, not the javascript-code (this is done by cacheCodeFor*)"
	
	^ self
		cacheObjectFor: aCompiledMethod
		producedBy: [
			S2JTranslatedMethod from: aCompiledMethod inFactory: self ]! !

!OCAbstractCodeFactory methodsFor: 'cache' stamp: 'LT 3/16/2011 12:24:21.722'!
clearCache
	
	self codeCache removeAll.! !

!OCAbstractCodeFactory methodsFor: 'accessing' stamp: 'ag 12/13/2010 14:30'!
codeCache
	^ codeCache! !

!OCAbstractCodeFactory methodsFor: 'accessing' stamp: 'ag 12/13/2010 14:30'!
codeCache: anObject
	codeCache := anObject! !

!OCAbstractCodeFactory methodsFor: 'javascript code' stamp: 'LT 3/16/2011 12:20:28.281'!
codeFor: aString
	"A simple DoIt-code-snippet"
	
	^ self
		cacheCodeFor: aString
		producedBy: [ S2JTranslatedDoIt from: aString inFactory: self ]! !

!OCAbstractCodeFactory methodsFor: 'javascript code' stamp: 'LT 3/16/2011 12:32:24.802'!
codeForClass: aClassOrClassName
	"A JS-Code-String representing the whole class. Without a DoIt code-snippet etc."
	
	^ (self cacheObjectForClass: aClassOrClassName) javaScriptCode! !

!OCAbstractCodeFactory methodsFor: 'javascript code' stamp: 'LT 3/16/2011 12:20:44.212'!
codeForClasses: anArrayOfClasses
	"An JS-code-string representing all classes in anArrayOfClasses"
	
	^ self
		cacheCodeFor: anArrayOfClasses
		producedBy: [ S2JTranslatedClasses from: anArrayOfClasses inFactory: self ]! !

!OCAbstractCodeFactory methodsFor: 'javascript code' stamp: 'LT 3/16/2011 12:32:24.814'!
codeForCompiledMethod: aCompiledMethod
	"An association from the function-name to the function-declaration-code"
	
	^ (self cacheObjectForMethod: aCompiledMethod) javaScriptCode! !

!OCAbstractCodeFactory methodsFor: 'javascript code' stamp: 'ag 1/5/2011 20:13'!
codeForMethod: aMethodSelector of: aClassOrClassName
	
	^ self codeForCompiledMethod:
		(self class converterClass method: aMethodSelector of: aClassOrClassName)! !

!OCAbstractCodeFactory methodsFor: 'private' stamp: 'ag 12/16/2010 11:47'!
compareCacheKey: o1 to: o2
	"CompiledMethods are considered equal, if they represent the same selector in the same class.
	Even after recompilation of a method, the old instance of CompiledMethod will be kept in the dictionary."
	
	o1 class = o2 class ifFalse: [ ^ false ].
	^ o1 class = CompiledMethod
		ifTrue: [ o1 methodClass = o2 methodClass and: [ o1 selector = o2 selector ] ]
		ifFalse: [ o1 = o2 ]! !

!OCAbstractCodeFactory methodsFor: 'accessing-derived' stamp: 'lw 3/28/2011 13:47'!
converterClass

	^ self class converterClass! !

!OCAbstractCodeFactory methodsFor: 'private' stamp: 'ag 1/3/2011 22:19'!
hashCodeFor: anObject
	
	^ anObject class = CompiledMethod
		ifTrue: [ 7 * anObject methodClass hash + anObject selector hash]
		ifFalse: [ anObject hash ]! !

!OCAbstractCodeFactory methodsFor: 'initialization' stamp: 'LT 3/16/2011 12:24:15.75'!
initialize
	
	super initialize.
	self codeCache: PluggableDictionary new.
	self codeCache
		equalBlock: [ :o1 :o2 | self compareCacheKey: o1 to: o2 ];
		hashBlock: [ :object | self hashCodeFor: object ].! !

!OCAbstractCodeFactory methodsFor: 'cache' stamp: 'ag 2/1/2011 14:04'!
invalidateMethod: aSelector of: anObject
	
	^ self invalidateObject: (self class converterClass method: aSelector of: anObject)! !

!OCAbstractCodeFactory methodsFor: 'cache' stamp: 'ag 2/1/2011 13:51'!
invalidateObject: anObject
	
	^ self codeCache removeKey: anObject! !

!OCAbstractCodeFactory methodsFor: 'cache' stamp: 'ag 2/1/2011 13:51'!
isObjectCached: anObject
	
	^ self codeCache includesKey: anObject! !

!OCAbstractCodeFactory methodsFor: 'javascript code' stamp: 'ag 1/9/2011 13:58'!
printCodeFor: aCachedObject to: aFilename
	"Print the code for an object, that is already in the cache, to a new (or overridden) file aFilename.
	Return nil, if object already in cache, return the printed code if successfull."
	
	^ self class converterClass
		print: (self cacheCodeFor: aCachedObject producedBy: [ ^ nil ])
		to: aFilename! !

!OCAbstractCodeFactory methodsFor: 'javascript code' stamp: 'ag 1/6/2011 21:03'!
readAllCodeInImage
	"Read each method in the image. This will not throw an error, just skip methods, that cannot be read."
	
	self class converterClass allMethodsDoAndReport: [ :eachMethod |
		self codeForCompiledMethod: eachMethod ].! !

OCAbstractCodeFactory subclass: #OCCodeFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

!OCCodeFactory commentStamp: 'ag 12/16/2010 12:46' prior: 0!
S2JCodeFactory readAllCodeInImage.

S2JCodeFactory clearCache.

S2JCodeFactory codeCache size. 84964. 64386. " 62492 !!!! ".

S2JCodeFactory codeFor: 'a doit-snippet squeak code'.

S2JCodeFactory  codeForClass: Object.

S2JCodeFactory codeForMethod: #asString of: Object.
!

!OCCodeFactory class methodsFor: 'converting' stamp: 'ag 1/5/2011 22:12'!
converterClass
	
	^ S2JPrinter! !

OCAbstractCodeFactory subclass: #OCPrettyCodeFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

!OCPrettyCodeFactory class methodsFor: 'converting' stamp: 'ag 1/6/2011 20:49'!
converterClass
	
	^ S2JPrettyPrinter! !

Object subclass: #OCClient
	instanceVariableNames: 'revision application serverObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OCClient class methodsFor: 'configuration' stamp: 'SW 1/25/2011 12:00'!
defaultRevision

	^ 1! !

!OCClient methodsFor: 'convenience' stamp: 'SW 1/17/2011 12:25'!
adaptRevision

	self revision: self application repository revision.! !

!OCClient methodsFor: 'accessing' stamp: 'LT 1/17/2011 12:16:26.766'!
application
	^ application! !

!OCClient methodsFor: 'accessing' stamp: 'LT 1/17/2011 12:16:26.778'!
application: anObject
	application := anObject! !

!OCClient methodsFor: 'client handling' stamp: 'SW 1/17/2011 15:35'!
identifier

	self subclassResponsibility ! !

!OCClient methodsFor: 'convenience' stamp: 'SW 1/17/2011 12:25'!
increaseRevision

	self revision: (self revision + 1).
! !

!OCClient methodsFor: 'initialization' stamp: 'lw 4/5/2011 11:50'!
initialize

	self revision: self class defaultRevision.
	self serverObjects: Dictionary new.! !

!OCClient methodsFor: 'initialization' stamp: 'SW 1/17/2011 12:42'!
isAMethodInvokation: aMessage
	 	
	^ aMessage beginsWith: 'INVOKE: '! !

!OCClient methodsFor: 'initialization' stamp: 'HK 1/5/2011 16:52'!
isAlive 

	self subclassResponsibility.! !

!OCClient methodsFor: 'convenience' stamp: 'SW 1/18/2011 15:35'!
isBehind

	^ self revision < self application repository revision ! !

!OCClient methodsFor: 'convenience' stamp: 'SW 1/18/2011 15:36'!
isBehindFor: aRepository

	^ self revision < aRepository revision.! !

!OCClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:17'!
isCometClient

	^ self subclassResponsibility.! !

!OCClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:17'!
isWebSocketClient

	^ self subclassResponsibility.! !

!OCClient methodsFor: 'initialization' stamp: 'SW 1/18/2011 14:56'!
receive: aMessage
	"Send aMessage from server to client. The client should receive that message."
	
	 ^ self subclassResponsibility ! !

!OCClient methodsFor: 'accessing' stamp: 'HK 12/15/2010 22:35'!
revision
	^ revision! !

!OCClient methodsFor: 'accessing' stamp: 'HK 12/15/2010 22:35'!
revision: anObject
	revision := anObject! !

!OCClient methodsFor: 'initialization' stamp: 'SW 1/18/2011 11:23'!
sent: aMessage

	"Send aMessage from client to server. The server should receive that message."
	
	 ^ self subclassResponsibility ! !

!OCClient methodsFor: 'accessing' stamp: 'lw 4/5/2011 11:50'!
serverObjects
	^ serverObjects! !

!OCClient methodsFor: 'accessing' stamp: 'lw 4/5/2011 11:50'!
serverObjects: anObject
	serverObjects := anObject! !

!OCClient methodsFor: 'client handling' stamp: 'LT 1/17/2011 12:13:49.516'!
update

	self subclassResponsibility! !

OCClient subclass: #OCCometClient
	instanceVariableNames: 'identifier timeStampOfLatestRequest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OCCometClient class methodsFor: 'configuration' stamp: 'SW 1/25/2011 12:16'!
HTTPStatusCodeTimeOut
	
	^ 408! !

!OCCometClient class methodsFor: 'configuration' stamp: 'lw 1/25/2011 17:24'!
defaultMaximumAge

	^ Duration minutes: 10 ! !

!OCCometClient class methodsFor: 'configuration' stamp: 'SW 1/18/2011 15:40'!
defaultMillisecondsToWait

	^ 500! !

!OCCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 16:47'!
checkLivelinessDelayed

	[ (Delay forDuration: self class defaultMaximumAge) wait. 
	self isAlive ifFalse: [
		self application removeClient: self ]] fork.! !

!OCCometClient methodsFor: 'accessing' stamp: 'HK 12/15/2010 14:34'!
identifier
	^ identifier! !

!OCCometClient methodsFor: 'accessing' stamp: 'HK 12/15/2010 14:34'!
identifier: anObject
	identifier := anObject! !

!OCCometClient methodsFor: 'accessing' stamp: 'SW 1/25/2011 11:14'!
initialize 
	
	super initialize.
	self timeStampOfLatestRequest: TimeStamp now! !

!OCCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 16:11'!
isAlive

	^ (TimeStamp now - self timeStampOfLatestRequest < self class defaultMaximumAge )! !

!OCCometClient methodsFor: 'convenience' stamp: 'SW 1/25/2011 11:46'!
isCometClient

	^ true! !

!OCCometClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:18'!
isWebSocketClient

	^ false.! !

!OCCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 15:57'!
receive: aMessage


! !

!OCCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 16:03'!
sent: aMessage

	self timeStampOfLatestRequest: TimeStamp now.
	self application processClientData: aMessage! !

!OCCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 15:59'!
timeStampOfLatestRequest
	^ timeStampOfLatestRequest! !

!OCCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 15:59'!
timeStampOfLatestRequest: anObject
	timeStampOfLatestRequest := anObject! !

!OCCometClient methodsFor: 'accessing' stamp: 'SW 1/25/2011 12:16'!
update

	self timeStampOfLatestRequest: TimeStamp now.
	[ self isBehind ] whileFalse:
		[ self isAlive ifFalse:
			[ self application removeClient: self.
			^ self application answerWithStatusCode: self class HTTPStatusCodeTimeOut ]. 
		self wait ].
	self checkLivelinessDelayed.	
	^ self application answerNewContentTo: self! !

!OCCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 14:57'!
wait

	self waitForMilliseconds: self class defaultMillisecondsToWait.! !

!OCCometClient methodsFor: 'accessing' stamp: 'SW 1/18/2011 14:57'!
waitForMilliseconds: milliseconds

	(Delay forMilliseconds: milliseconds) wait.! !

OCClient subclass: #OCWebSocketClient
	instanceVariableNames: 'socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OCWebSocketClient class methodsFor: 'instance creation' stamp: 'HK 12/15/2010 21:46'!
newWithSocket: aWebSocket

	^ self basicNew socket: aWebSocket; initialize.! !

!OCWebSocketClient methodsFor: 'convenience' stamp: 'SW 1/17/2011 15:34'!
close

	self isAlive ifTrue: [ self socket close ].
	self application  removeClient: self.! !

!OCWebSocketClient methodsFor: 'configuration' stamp: 'SW 1/17/2011 12:36'!
defaultReceiveBlock

	
	^ [ :message |
		self receivePost: message.
		"S2JDispatcher updateContentWith: message.
		S2JWebSocketHandler updateAllClientsExcept: self "		
		].! !

!OCWebSocketClient methodsFor: 'convenience' stamp: 'SW 1/17/2011 15:35'!
identifier
	
	 ^ 'WebSocket'! !

!OCWebSocketClient methodsFor: 'initialization' stamp: 'SW 1/18/2011 11:23'!
initialize

	super initialize.
	self socket receiveBlock: [:aMessage | self sent: aMessage ]! !

!OCWebSocketClient methodsFor: 'convenience' stamp: 'HK 1/5/2011 16:53'!
isAlive
	
	^ self socket isOpen and: [ self socket connection stream notNil ].! !

!OCWebSocketClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:18'!
isCometClient

	^ false.! !

!OCWebSocketClient methodsFor: 'convenience' stamp: 'HK 12/15/2010 16:18'!
isWebSocketClient

	^ true.! !

!OCWebSocketClient methodsFor: 'convenience' stamp: 'SW 1/31/2011 10:12'!
receive: aMessage

	[ self socket send: aMessage asString ] on: Error do: [ self application removeClient: self ].! !

!OCWebSocketClient methodsFor: 'convenience' stamp: 'SW 1/18/2011 15:01'!
sent: aMessage

	self application processClientData: aMessage! !

!OCWebSocketClient methodsFor: 'accessing' stamp: 'HK 12/14/2010 10:20'!
socket
	^ socket! !

!OCWebSocketClient methodsFor: 'accessing' stamp: 'HK 12/14/2010 10:20'!
socket: anObject
	socket := anObject! !

!OCWebSocketClient methodsFor: 'convenience' stamp: 'SW 1/18/2011 11:03'!
update

	 [ self isBehind ] whileTrue: [self increaseRevision. 
		self receive: (self application repository contentAtRevision: self revision) ]
		! !

Object subclass: #OCContentRepository
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OCContentRepository methodsFor: 'management' stamp: 'ag 1/12/2011 19:54'!
addContent: javascriptCode
	
	^ self repository add: javascriptCode! !

!OCContentRepository methodsFor: 'management' stamp: 'ag 1/12/2011 19:53'!
contentAtRevision: aRevision

	^ self repository
		at: aRevision
		ifAbsent: [ nil ]! !

!OCContentRepository methodsFor: 'management' stamp: 'ag 1/12/2011 19:54'!
initialize
	
	self
		repository: OrderedCollection new;
		addContent: ''.! !

!OCContentRepository methodsFor: 'management' stamp: 'SW 1/18/2011 15:36'!
latestContent
	
	^ self contentAtRevision: self revision.! !

!OCContentRepository methodsFor: 'accessing' stamp: 'HK 1/11/2011 16:44'!
repository
	^ repository! !

!OCContentRepository methodsFor: 'accessing' stamp: 'HK 1/11/2011 16:44'!
repository: anObject
	repository := anObject! !

!OCContentRepository methodsFor: 'management' stamp: 'SW 1/18/2011 15:36'!
revision
	
	^ self repository size! !

Object subclass: #OCInstaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Installer'!

!OCInstaller class methodsFor: 'configuration' stamp: 'hk 3/29/2011 11:29'!
enableDebugging

	Utilities debugSwazooErrors: true.
	S2JTranslatedClass enableAllPrintUpdates.! !

!OCInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 13:21'!
install

	self
		installPrerequisites;
		installDependencies;
		refetchPackages;
		setupPreferences;
		setupFramework.! !

!OCInstaller class methodsFor: 'addons' stamp: 'hk 3/29/2011 13:21'!
installAddons

	"self
		installRefactoringBrowser;
		installSwaLint;
		installShout;
		installOCompletion."! !

!OCInstaller class methodsFor: 'setup' stamp: 'hk 3/28/2011 10:23'!
installCryptography

	Gofer new
		squeaksource: 'Cryptography';
		package: 'Cryptography';
		load.! !

!OCInstaller class methodsFor: 'setup' stamp: 'srv 4/5/2011 15:18'!
installDependencies

	self
		installSport;
		installGrease;
		installOMeta;
		installSwazoo;
		installCryptography;
		installOmniBrowser;
		installJson.! !

!OCInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 09:59'!
installGofer
	
	self
		loadPackages: { 'Gofer'. 'Gofer-Core'. 'Gofer-Tests' }
		inRepository: (MCHttpRepository
			location: 'http://source.lukas-renggli.ch/gofer'
			user: ''
			password: '').! !

!OCInstaller class methodsFor: 'setup' stamp: 'srv 4/5/2011 15:11'!
installGrease

	Gofer new
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfGrease';
		load.
		
	(Smalltalk at: #ConfigurationOfGrease) loadLatestVersion.! !

!OCInstaller class methodsFor: 'setup' stamp: 'hk 3/28/2011 10:23'!
installJson

	Gofer new
		squeaksource: 'JSON';
		package: 'JSON';
		load.! !

!OCInstaller class methodsFor: 'addons' stamp: 'hk 3/28/2011 11:05'!
installOCompletion

	Gofer new
		squeaksource: 'OCompletion';
		package: 'Ocompletion';
		load.! !

!OCInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 10:48'!
installOMeta

	Gofer new
		squeaksource: 'OMeta';
		package: 'OMeta2-Preload';
		load.
	
	Gofer new
		squeaksource: 'OMeta';
		package: 'OMeta2-Postload';
		fetch.! !

!OCInstaller class methodsFor: 'addons' stamp: 'srv 4/5/2011 15:10'!
installOmniBrowser

	Gofer new
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfOmniBrowser';
		load.
		
	(Smalltalk at: #ConfigurationOfOmniBrowser) project latestVersion load.! !

!OCInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 09:59'!
installPrerequisites

	self installGofer.! !

!OCInstaller class methodsFor: 'addons' stamp: 'hk 3/29/2011 13:18'!
installRefactoringBrowser

	Gofer new
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfRefactoringBrowser';
		load.
		
	ConfigurationOfRefactoringBrowser project latestVersion load.! !

!OCInstaller class methodsFor: 'addons' stamp: 'hk 3/29/2011 13:17'!
installShout

	Gofer new
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfShout';
		load.
		
	ConfigurationOfShout project latestVersion load.! !

!OCInstaller class methodsFor: 'setup' stamp: 'hk 3/28/2011 10:23'!
installSport

	Gofer new
		squeaksource: 'SPort';
		package: 'Sport';
		load.! !

!OCInstaller class methodsFor: 'addons' stamp: 'hk 3/29/2011 13:03'!
installSwaLint

	Gofer new
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfSwaLint';
		load.
		
	ConfigurationOfSwaLint load.! !

!OCInstaller class methodsFor: 'setup' stamp: 'hk 3/28/2011 10:22'!
installSwazoo

	Gofer new
		squeaksource: 'Swazoo';
		package: 'Swazoo';
		version: 'Swazoo-2.3beta2.2';
		load.! !

!OCInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 09:59'!
loadPackages: aStringCollection inRepository: anMCRepository
	
	| repo index versionList |
	repo := MCFileRepositoryInspector
		repository: anMCRepository
		workingCopy: nil.
	repo packageSelection: 0.
	versionList := repo versionList.
	index := 1.
	[ (aStringCollection anySatisfy: [ :each | (versionList at: index) asString beginsWith: each asString ])
		or: [ index >= repo versionList size ] ] whileFalse: [ index := index + 1 ].
	repo versionSelection: index.
	repo load.! !

!OCInstaller class methodsFor: 'update' stamp: 'hk 3/29/2011 10:05'!
refetchPackages
	
	self
		loadPackages: { 'Squeak2JS' }
		inRepository: self repository.! !

!OCInstaller class methodsFor: 'configuration' stamp: 'hk 3/29/2011 10:01'!
repository

	^ S2JMonticelloStatistics workingCopy repositoryGroup repositories detect:
		[ :first | first isKindOf: MCHttpRepository ]! !

!OCInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 10:48'!
setupDispatcher

	S2JDispatcher
		install;
		start.! !

!OCInstaller class methodsFor: 'setup' stamp: 'hk 3/28/2011 16:55'!
setupFileDirectory

	| chooser directory |
	chooser := FileChooser new.
	directory := chooser
		initializeAsSystemWindow;
		open;
		directory.
	S2JFileRequestHandler rootDirectory: directory pathName.! !

!OCInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 12:07'!
setupFramework

	self
		setupMimeDatabase;
		setupFileDirectory;
		setupDispatcher;
		enableDebugging.! !

!OCInstaller class methodsFor: 'setup' stamp: 'hk 3/28/2011 17:01'!
setupMimeDatabase

	MIMEDocument resetMIMEdatabase.! !

!OCInstaller class methodsFor: 'setup' stamp: 'hk 3/29/2011 16:18'!
setupPreferences

	SystemBrowser default: (Smalltalk at: #OBSystemBrowserAdaptor).

	Preferences
		enable: #swapMouseButtons;
		enable: #infiniteUndo;
		enable: #multipleTextUndo.! !

!OCInstaller class methodsFor: 'update' stamp: 'hk 3/28/2011 11:16'!
updateGofer

	Gofer upgrade.! !

OCInstaller subclass: #OCSilentInstaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Installer'!

!OCSilentInstaller class methodsFor: 'setup' stamp: 'robi 4/5/2011 18:41'!
setupFileDirectory
	" by not setting a file directory, orca uses the default ressources directory"
! !

Object subclass: #OCNodeNilObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OCNodeNilObject methodsFor: 'nil object selector handling' stamp: 'lw 4/6/2011 09:25'!
add: anObject
	" to ensure not looking up the selector in the superclasses even without doing nothing"! !

!OCNodeNilObject methodsFor: 'nil object selector handling' stamp: 'lw 4/6/2011 09:25'!
addAllWhitoutNils: anObject
	" to ensure not looking up the selector in the superclasses even without doing nothing"! !

!OCNodeNilObject methodsFor: 'nil object selector handling' stamp: 'lw 4/5/2011 18:08'!
doesNotUnderstand: aMessage

	(S2JNode canUnderstand: aMessage selector) ifFalse: [ super doesNotUnderstand: aMessage ]! !

Object subclass: #OCSerializationTestObject
	instanceVariableNames: 'otherObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OCSerializationTestObject methodsFor: 'accessing' stamp: 'ag 3/1/2011 16:50'!
otherObject
	^ otherObject! !

!OCSerializationTestObject methodsFor: 'accessing' stamp: 'ag 3/1/2011 16:50'!
otherObject: anObject
	otherObject := anObject! !

Object subclass: #OCServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Stubs'!

Object subclass: #OCShape
	instanceVariableNames: 'canvas graphics color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OCShape subclass: #OCCircle
	instanceVariableNames: 'position radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OCCircle subclass: #OCBall
	instanceVariableNames: 'speed direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-BallGame'!

!OCBall methodsFor: 'logic' stamp: 'ag 4/5/2011 10:28'!
bounceIfNeeded
	
	(self position x > self canvas width or: 
	[self position x < 0])
		ifTrue: [
			self direction: 
				(self direction x * -1) @ self direction y ].
	
	(self position y > self canvas height or: 
	[self position y < 0])
		ifTrue: [
			self direction: 
				self direction x @ (self direction y * -1) ].! !

!OCBall methodsFor: 'accessing' stamp: 'sec 1/5/2011 20:48'!
direction
	^ direction! !

!OCBall methodsFor: 'accessing' stamp: 'sec 1/5/2011 20:48'!
direction: anObject
	direction := anObject! !

!OCBall methodsFor: 'initialize-release' stamp: 'ag 1/24/2011 17:12'!
initialize
	
	super initialize.
	self speed: 2.
	self direction: 1@1.! !

!OCBall methodsFor: 'accessing' stamp: 'sec 1/5/2011 20:48'!
speed
	^ speed! !

!OCBall methodsFor: 'accessing' stamp: 'lw 2/2/2011 23:31'!
speed: anObject

	speed := anObject
! !

!OCBall methodsFor: 'logic' stamp: 'ag 3/1/2011 11:18'!
step
	
	super step.
	self position: self position + (self direction * self speed).
	self bounceIfNeeded.! !

!OCCircle methodsFor: 'graphics' stamp: 'ag 4/5/2011 10:27'!
drawOn: aGraphics
	"CTK library: http://canvastoolkit.codeplex.com/"
	
	aGraphics setColor value: self color.
	aGraphics fillCircle
		value: self position x
		value: self position y
		value: self radius.! !

!OCCircle methodsFor: 'initialization' stamp: 'LT 2/21/2011 15:30:24.69'!
initialize
	
	super initialize.
	self
		color: '#ff0000';
		radius: 10;
		position: 1@1.! !

!OCCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.683'!
position
	^ position! !

!OCCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.695'!
position: anObject
	position := anObject! !

!OCCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.704'!
radius
	^ radius! !

!OCCircle methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:14:18.712'!
radius: anObject
	radius := anObject! !

!OCCircle methodsFor: 'graphics' stamp: 'ag 4/5/2011 10:28'!
step
	
	self drawOn: self graphics.! !

!OCShape methodsFor: 'accessing' stamp: 'sec 12/22/2010 12:03'!
canvas
	^ canvas! !

!OCShape methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:33:58.38'!
canvas: anObject
	canvas := anObject! !

!OCShape methodsFor: 'accessing' stamp: 'ag 1/12/2011 10:51'!
color
	^ color! !

!OCShape methodsFor: 'accessing' stamp: 'ag 1/12/2011 10:51'!
color: anObject
	color := anObject! !

!OCShape methodsFor: 'accessing' stamp: 'ag 4/5/2011 10:27'!
graphics
	^ graphics! !

!OCShape methodsFor: 'accessing' stamp: 'ag 4/5/2011 10:27'!
graphics: anObject
	graphics := anObject! !

OCShape subclass: #OCWorld
	instanceVariableNames: 'bounds elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-BallGame'!

OCWorld subclass: #OCBallGame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-BallGame'!

!OCBallGame commentStamp: 'sec 1/4/2011 10:22' prior: 0!
usage:
S2JCodeFactory clearCache.
S2JBouncingBallsApp startWebApp.!

!OCBallGame class methodsFor: 'start' stamp: 'ag 1/24/2011 20:42'!
start
	
	^ self new run! !

!OCBallGame methodsFor: 'graphics' stamp: 'ag 4/5/2011 10:30'!
addBall
	
	^ self elements
		add: 
			(S2JBall new
				canvas: self canvas;
				graphics: self graphics;
				yourself)! !

!OCBallGame methodsFor: 'initialization' stamp: 'ag 3/29/2011 14:07'!
initialize
	
	super initialize.
	self addBall.! !

!OCWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.324'!
bounds
	^ bounds! !

!OCWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.336'!
bounds: anObject
	bounds := anObject! !

!OCWorld methodsFor: 'graphics' stamp: 'ag 4/5/2011 10:29'!
clear
	
	self graphics setColor value: self color.
	self graphics fillRect
			value: self bounds origin x
			value: self bounds origin y
			value: self bounds corner x
			value: self bounds corner y.! !

!OCWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.346'!
elements
	^ elements! !

!OCWorld methodsFor: 'accessing' stamp: 'LT 12/21/2010 18:22:07.352'!
elements: anObject
	elements := anObject! !

!OCWorld methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:23'!
initialize
	
	super initialize.
	self color: '#0000ff'.
	
	self
		canvas: (Js Document getElementById value: #ballCanvas);
		elements: OrderedCollection new;
		bounds: (Rectangle origin: (0@0) corner: (self canvas width @ self canvas height));
		graphics: (Js Global ctk Graphics jsNew: self canvas);
		clear.! !

!OCWorld methodsFor: 'graphics' stamp: 'ag 3/29/2011 13:40'!
run
	
	Js Global setInterval
		value: [ self step ]
		value: 3.! !

!OCWorld methodsFor: 'graphics' stamp: 'ag 1/12/2011 10:55'!
step
	
	self clear.
	self elements do: [ :each | each step].! !

Object subclass: #OCSlotObject
	instanceVariableNames: 'slots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Stubs'!

!OCSlotObject class methodsFor: 'instance creation' stamp: 'ag 3/31/2011 13:29'!
newFrom: anArray
	
	^ self new
			slots: anArray;
			yourself! !

!OCSlotObject methodsFor: 'accessing' stamp: 'ag 3/31/2011 13:24'!
definitionLine
	
	^ '{}'! !

!OCSlotObject methodsFor: 'accessing' stamp: 'sw 3/31/2011 13:38'!
fillInstVars: codeLines guardedBy: alreadySerialized
	"This classes instance variables are ignored, the slots are the only thing, that counts."
	
	self slots do: [ :slot | | slotvalue | 
		slotvalue := slot value.
		slotvalue serializeToJavaScript: codeLines guardedBy: alreadySerialized.
		codeLines addLast: 
			(alreadySerialized at: self), '.', slot key, 
			'=', (alreadySerialized at: slotvalue) ].
	codeLines addLast: '_unboxSlotObject(', (alreadySerialized at: self), ')'.! !

!OCSlotObject methodsFor: 'initializing' stamp: 'sw 3/31/2011 11:06'!
initialize

	super initialize.
	self slots: Array new.! !

!OCSlotObject methodsFor: 'accessing' stamp: 'sw 3/31/2011 11:06'!
slots
	^ slots! !

!OCSlotObject methodsFor: 'accessing' stamp: 'sw 3/31/2011 11:06'!
slots: anObject
	slots := anObject! !

Object subclass: #OCTranslatedObject
	instanceVariableNames: 'squeakObject javaScriptCode codeFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

OCTranslatedObject subclass: #OCCompilationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

!OCCompilationError class methodsFor: 'instance creation' stamp: 'ag 3/29/2011 11:23'!
from: anObject inFactory: aFactory
	
	Transcript cr; show: 'Compilation error. Failed on: ', anObject asString.
	^ super from: anObject inFactory: aFactory! !

!OCCompilationError methodsFor: 'converting' stamp: 'sec 2/21/2011 18:57'!
doUpdate

	self error: 'Cannot translate: ', self squeakObject asString.! !

!OCCompilationError methodsFor: 'converting' stamp: 'sec 2/21/2011 18:56'!
hasChanged

	^true! !

OCTranslatedObject subclass: #OCTranslatedClass
	instanceVariableNames: 'instMethods classMethods instVars superclass classInstVars classVars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

!OCTranslatedClass methodsFor: 'converting' stamp: 'ag 1/5/2011 22:01'!
allMethodsOf: aSourceClass
	
	^ aSourceClass methodDict values collect: [ :method | 
		self codeFactory cacheObjectForMethod: method ]! !

!OCTranslatedClass methodsFor: 'accessing-derived' stamp: 'lw 3/28/2011 17:59'!
calledFunctions 

	^ self instMethods, self classMethods 
		inject: Dictionary new 
		into: [ :aDictionary :aMethod | aDictionary union: aMethod calledFunctions ].! !

!OCTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classInstVars
	
	^ classInstVars! !

!OCTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classInstVars: anObject
	
	classInstVars := anObject! !

!OCTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classMethods
	
	^ classMethods! !

!OCTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classMethods: anObject
	
	classMethods := anObject! !

!OCTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
classVars
	
	^ classVars! !

!OCTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:59'!
classVars: anObject
	
	classVars := anObject! !

!OCTranslatedClass methodsFor: 'converting' stamp: 'LT 3/16/2011 12:31:57.541'!
doUpdate
	"First memorize the fields, then do the actual conversion. Errors during the conversion will happen only once,
	the old version of the javascriptObject will be kept if that happens.
	TODO Bad: this is kind of the same code like in S2JAbstractPrinter class >> convertClass:to:retrievingFrom: and #hasChanged in this class"
	
	self
		superclass: self squeakObject superclass name;
		instMethods: (self allMethodsOf: self squeakObject);
		classMethods: (self allMethodsOf: self squeakObject class);
		instVars: self squeakObject instVarNames;
		classInstVars: self squeakObject class instVarNames;
		classVars: self squeakObject classVarNames;
		javaScriptCode: (
			self converterClass
				convertClass: self squeakObject
				retrievingFrom: [ :method | "Here the CodeFactory is plugged to the Printer"
					self codeFactory codeForCompiledMethod: method ]).! !

!OCTranslatedClass methodsFor: 'converting' stamp: 'ag 1/10/2011 19:36'!
hasChanged
	
	^ 
	((self haveMethodsChanged: self instMethods from: self squeakObject)
	or: [ self haveMethodsChanged: self classMethods from: self squeakObject class ]
	or: [ self superclass ~= self squeakObject superclass name ]
	or: [ self instVars ~= self squeakObject instVarNames ]
	or: [ self classInstVars ~= self squeakObject class instVarNames ])
	or: [ self classVars ~= self squeakObject classVarNames ]! !

!OCTranslatedClass methodsFor: 'converting' stamp: 'ag 2/1/2011 14:05'!
haveMethodsChanged: originalMethods from: originalClass
	"Check #hasChanged on each S2JCompiledMethod and check, whether there are more methods in the class now."
	
	^ originalMethods isNil or: 
		[ (originalMethods anySatisfy: [ :method | 
			(self codeFactory isObjectCached: method squeakObject) not or: 
			[ method hasChanged ] ]) or:
		[ originalClass methodDict size ~= originalMethods size ]]! !

!OCTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:57'!
instMethods
	
	^ instMethods! !

!OCTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:57'!
instMethods: anObject
	
	instMethods := anObject! !

!OCTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
instVars
	
	^ instVars! !

!OCTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
instVars: anObject
	
	instVars := anObject! !

!OCTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
superclass
	
	^ superclass! !

!OCTranslatedClass methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:58'!
superclass: aString
	
	superclass := aString! !

!OCTranslatedClass methodsFor: 'converting' stamp: 'ag 1/6/2011 16:24'!
updateMessage
	
	^ 'class ', self squeakObject name! !

OCTranslatedObject subclass: #OCTranslatedClasses
	instanceVariableNames: 'translatedClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

!OCTranslatedClasses methodsFor: 'converting' stamp: 'lw 3/28/2011 14:46'!
addDoesNotUnderstandClass

	self javaScriptCode: (self converterClass doesNotUndestandClasswithMethods: self calledFunctions), ';
', self javaScriptCode.! !

!OCTranslatedClasses methodsFor: 'accessing-derived' stamp: 'lw 3/28/2011 18:03'!
calledFunctions 

	^ self translatedClasses 
		inject: Dictionary new 
		into: [ :aDictionary :aMethod | aDictionary union: aMethod calledFunctions ].! !

!OCTranslatedClasses methodsFor: 'converting' stamp: 'lw 3/28/2011 13:25'!
doUpdate
	"Call convertClasses: of the converterClass and memorize the result. Plug the codeFactory to the converterClass (via the block).
	Actually, the compiledClasses should always stay the same objects, but just in case we refill the Set.
	Might happen, that one single object is removed from the cache."
	
	self translatedClasses removeAll.
	self javaScriptCode: (
		self converterClass
			convertClasses: self squeakObject
			retrievingFrom: [ :class | "Here the CodeFactory is plugged to the Printer"
				self translatedClasses add: (self codeFactory cacheObjectForClass: class).
				self codeFactory codeForClass: class ]).
	(self squeakObject includes: ProtoObject) 
		ifTrue: [ self addDoesNotUnderstandClass ]! !

!OCTranslatedClasses methodsFor: 'converting' stamp: 'lw 3/28/2011 12:31'!
hasChanged
	
	^ self translatedClasses isNil or:
		[ self translatedClasses anySatisfy: [ :each |
			(self codeFactory isObjectCached: each squeakObject) not
			or: [ each hasChanged ] ]]! !

!OCTranslatedClasses methodsFor: 'initialization' stamp: 'lw 3/28/2011 12:32'!
initialize
	
	super initialize.
	self translatedClasses: Set new.! !

!OCTranslatedClasses methodsFor: 'accessing' stamp: 'lw 3/28/2011 12:31'!
translatedClasses
	^ translatedClasses! !

!OCTranslatedClasses methodsFor: 'accessing' stamp: 'lw 3/28/2011 12:32'!
translatedClasses: aSet
	translatedClasses := aSet! !

!OCTranslatedClasses methodsFor: 'converting' stamp: 'ag 1/6/2011 16:25'!
updateMessage
	
	^ 'classes ', self squeakObject asString.! !

OCTranslatedObject subclass: #OCTranslatedDoIt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

!OCTranslatedDoIt methodsFor: 'converting' stamp: 'LT 3/16/2011 12:31:57.566'!
doUpdate
	
	self javaScriptCode: 
		(self converterClass convertDoIt: self squeakObject).! !

!OCTranslatedDoIt methodsFor: 'converting' stamp: 'ag 12/14/2010 00:33'!
hasChanged
	"DoIt-code does not change"
	
	^ false! !

OCTranslatedObject subclass: #OCTranslatedMethod
	instanceVariableNames: 'calledFunctions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Cache'!

!OCTranslatedMethod methodsFor: 'accessing' stamp: 'LT 3/16/2011 12:34:23.999'!
calledFunctions
	^ calledFunctions! !

!OCTranslatedMethod methodsFor: 'accessing' stamp: 'LT 3/16/2011 12:34:24.011'!
calledFunctions: anObject
	calledFunctions := anObject! !

!OCTranslatedMethod methodsFor: 'converting' stamp: 'ag 1/19/2011 15:58'!
currentSqueakObject
	
	^ self converterClass
		method: self squeakObject selector
		of: self squeakObject methodClass
		ifAbsent: [ nil ]! !

!OCTranslatedMethod methodsFor: 'converting' stamp: 'lw 3/28/2011 16:45'!
doUpdate
	"Additionally to converting the current code, store the current instance of CompiledMethod"
	
	| calledFunctionsToResult |
	self squeakObject: self currentSqueakObject.
	calledFunctionsToResult := self converterClass convertTranslatedMethod: self.
	self javaScriptCode: calledFunctionsToResult value.
	self calledFunctions: calledFunctionsToResult key.! !

!OCTranslatedMethod methodsFor: 'converting' stamp: 'ag 12/17/2010 00:15'!
hasChanged
	"This is the main point of cache-validation. The instance-equality of the CompiledMethod is used.
	If the method-code changed, the method is recompiled. If the method is recompiled, there will be a new instance of CompiledMethod."
	
	^ (self squeakObject == self currentSqueakObject) not! !

!OCTranslatedMethod methodsFor: 'converting' stamp: 'ag 1/6/2011 16:27'!
updateMessage
	
	^ 'method ', self squeakObject methodClass name, ' >> ', self squeakObject selector! !

!OCTranslatedObject class methodsFor: 'printing updates' stamp: 'LT 3/16/2011 12:21:38.113'!
disableAllPrintUpdates
	
	S2JTranslatedObject withAllSubclassesDo: [ :eachClass |
		eachClass enablePrintUpdates ].! !

!OCTranslatedObject class methodsFor: 'printing updates' stamp: 'ag 1/6/2011 16:31'!
disablePrintUpdates
	
	Smalltalk
		at: self updatesKey
		put: false.! !

!OCTranslatedObject class methodsFor: 'printing updates' stamp: 'LT 3/16/2011 12:21:38.127'!
enableAllPrintUpdates
	
	S2JTranslatedObject withAllSubclassesDo: [ :eachClass |
		eachClass enablePrintUpdates ].! !

!OCTranslatedObject class methodsFor: 'printing updates' stamp: 'ag 1/6/2011 16:32'!
enablePrintUpdates
	
	Smalltalk
		at: self updatesKey
		put: true.! !

!OCTranslatedObject class methodsFor: 'instance creation' stamp: 'ag 3/29/2011 11:23'!
from: aSqueakObject inFactory: aCodeFactory
	
	^ self new
		squeakObject: aSqueakObject;
		codeFactory: aCodeFactory;
		yourself! !

!OCTranslatedObject class methodsFor: 'printing updates' stamp: 'ag 1/6/2011 16:32'!
printUpdates
	
	^ (Smalltalk
		at: self updatesKey
		ifAbsent: [ nil ])
			== true! !

!OCTranslatedObject class methodsFor: 'printing updates' stamp: 'ag 1/10/2011 19:34'!
updatesKey
	"The key used in the global Smalltalk dictionary to store the per-class setting to print updates."
	
	^ ('S2JPrintCacheUpdates-', self name) asSymbol! !

!OCTranslatedObject methodsFor: 'accessing' stamp: 'ag 1/5/2011 21:44'!
codeFactory
	
	^ codeFactory! !

!OCTranslatedObject methodsFor: 'accessing' stamp: 'ag 1/5/2011 21:44'!
codeFactory: aCodeFactory
	
	codeFactory := aCodeFactory! !

!OCTranslatedObject methodsFor: 'converting' stamp: 'lw 3/28/2011 13:49'!
converterClass
	"Convenience for subclasses"
	
	^ self codeFactory converterClass! !

!OCTranslatedObject methodsFor: 'converting' stamp: 'ag 1/6/2011 11:21'!
doUpdate
	"Update converted contents from the current state of the squeak-object."
	
	self subclassResponsibility! !

!OCTranslatedObject methodsFor: 'converting' stamp: 'ag 12/13/2010 22:41'!
hasChanged
	"Return true, if the source squeak-object has changed, since it has last been updated."
	
	self subclassResponsibility! !

!OCTranslatedObject methodsFor: 'accessing' stamp: 'LT 3/16/2011 12:32:24.779'!
javaScriptCode
	
	^ javaScriptCode! !

!OCTranslatedObject methodsFor: 'accessing' stamp: 'LT 3/16/2011 12:31:57.533'!
javaScriptCode: anObject
	
	javaScriptCode := anObject! !

!OCTranslatedObject methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:34'!
squeakObject
	
	^ squeakObject! !

!OCTranslatedObject methodsFor: 'accessing' stamp: 'ag 12/14/2010 00:34'!
squeakObject: anObject
	
	squeakObject := anObject! !

!OCTranslatedObject methodsFor: 'converting' stamp: 'ag 1/6/2011 16:24'!
update
	"To track the updates easily, they are printed to Transript, if activated"
	
	| message |
	message := self updateMessage.
	(message notNil and: [self class printUpdates]) ifTrue: [
		Transcript cr; show: 'Updating ', message].
	^ self doUpdate! !

!OCTranslatedObject methodsFor: 'converting' stamp: 'ag 1/6/2011 16:23'!
updateMessage
	"Return something else than nil to print it to Transcript on updates."
	
	^ nil! !

Object subclass: #OCWidget
	instanceVariableNames: 'node children extent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OCWidget subclass: #OCAccordion
	instanceVariableNames: 'autoHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCAccordion class methodsFor: 'configuration' stamp: 'hk 3/8/2011 09:58'!
defaultCssId

	 ^ 'accordion'! !

!OCAccordion class methodsFor: 'configuration' stamp: 'hk 3/8/2011 10:08'!
hasAutoHeight

	^ false! !

!OCAccordion methodsFor: 'accessing' stamp: 'hk 3/8/2011 10:04'!
add: aWidget named: aString
	
	| link heading container |
	link := S2JAnchor named: aString.
	heading := S2JHeading new add: link; yourself.
	container := (S2JContainer vertical) add: aWidget.
	self
		add: heading;
		add: container.! !

!OCAccordion methodsFor: 'accessing' stamp: 'hk 3/8/2011 10:07'!
autoHeight
	^ autoHeight! !

!OCAccordion methodsFor: 'accessing' stamp: 'hk 3/8/2011 10:07'!
autoHeight: anObject
	autoHeight := anObject! !

!OCAccordion methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
enableAccordion
	
	(Js @ ('#', self class defaultCssId)) accordion value: self parameters.! !

!OCAccordion methodsFor: 'initialization' stamp: 'hk 3/8/2011 10:08'!
initialize 

	super initialize.
	self autoHeight: self class hasAutoHeight.
	self cssId: self class defaultCssId.! !

!OCAccordion methodsFor: 'initialization' stamp: 'hk 3/8/2011 09:49'!
onLoad

	self enableAccordion.
	super onLoad.! !

!OCAccordion methodsFor: 'initialization' stamp: 'hk 3/8/2011 10:10'!
parameters

	^ { #autoHeight -> self autoHeight . #navigation -> true } asObject! !

OCWidget subclass: #OCChart
	instanceVariableNames: 'chart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OCChart class methodsFor: 'configuration' stamp: 'hk 3/9/2011 10:38'!
defaultCssId

	^ self subclassResponsibility! !

!OCChart methodsFor: 'accessing' stamp: 'hk 3/7/2011 22:48'!
chart
	^ chart! !

!OCChart methodsFor: 'accessing' stamp: 'hk 3/7/2011 22:48'!
chart: anObject
	chart := anObject! !

!OCChart methodsFor: 'initialization' stamp: 'hk 3/9/2011 11:01'!
initialize 

	super initialize.
	self
		cssId: self class defaultCssId;
		width: '100%';
		height: '400px'.! !

!OCChart methodsFor: 'initialization' stamp: 'ag 4/5/2011 15:59'!
initializeWithData: json

	self chart loadJSON value: json.! !

!OCChart methodsFor: 'rendering' stamp: 'LT 4/4/2011 15:04:18.9'!
onShowTip: aTip for: anElement
	| label value |
		
	label := anElement name.
	value := anElement value.
	aTip innerHTML: label, ': ', value.
	aTip style backgroundColor: 'white'.! !

!OCChart methodsFor: 'configuration' stamp: 'hk 3/8/2011 09:41'!
parameters

	^ self subclassResponsibility! !

OCChart subclass: #OCStackedChart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

OCStackedChart subclass: #OCAreaChart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OCAreaChart class methodsFor: 'configuration' stamp: 'hk 3/7/2011 22:25'!
defaultCssId

	^ 'area'! !

!OCAreaChart methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:44'!
initializeWithData: json

	self chart: (Js jit AreaChart jsNew: self parameters).
	super initializeWithData: json.! !

!OCAreaChart methodsFor: 'initialization' stamp: 'hk 3/30/2011 11:18'!
onLoad

	| escapedJson json |
	escapedJson := [ S2JMonticelloStatistics jsonDataAt: #commitsByWeek ] onServer value.
	json := Js Global eval value: escapedJson.
	self initializeWithData: json.! !

OCStackedChart subclass: #OCBarChart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OCBarChart class methodsFor: 'configuration' stamp: 'hk 3/8/2011 09:45'!
defaultCssId

	^ 'bar'! !

!OCBarChart methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:44'!
initializeWithData: json
	
	self chart: (Js jit BarChart jsNew: self parameters).
	super initializeWithData: json.! !

!OCBarChart methodsFor: 'initialization' stamp: 'sw 3/30/2011 14:31'!
onLoad

	| escapedJson json |
	escapedJson := [ S2JMonticelloStatistics jsonDataAt: #commitsByWeekDay ] onServer value.
	json := Js Global eval value: escapedJson.
	self initializeWithData: json.! !

!OCBarChart methodsFor: 'configuration' stamp: 'LT 4/4/2011 16:56:40.684'!
parameters

	^ super parameters
		orientation: 'vertical';
		barsOffset: 20;
		yourself! !

OCBarChart subclass: #OCCommitsByHour
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OCCommitsByHour class methodsFor: 'configuration' stamp: 'SW 3/16/2011 16:18'!
defaultCssId

	^ 'commitsByHour'! !

!OCCommitsByHour methodsFor: 'initialization' stamp: 'LT 4/5/2011 10:44:20.718'!
onLoad

	| escapedJson json |
	escapedJson := [ S2JMonticelloStatistics jsonDataAt: #commitsByHour ] onServer value.
	json := Js Global eval value: escapedJson.
	self initializeWithData: json.! !

!OCStackedChart methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:21:19.284'!
label

	^  {#type -> 'HTML'.
		#size -> 13.
		#family -> 'Arial'.
		#color -> 'black' } asObject! !

!OCStackedChart methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:05:32.517'!
parameters

	^ {#injectInto -> self class defaultCssId.
		#animate -> true.
		#Margin -> { #top -> 5 . #left -> 5 . #right -> 5 . #bottom -> 5 } asObject.
		#labelOffset -> 10.
		#showAggregates -> true.
		#showLabels -> true.
		#type -> 'stacked:gradient'.
		#Label -> self label.
		#Tips -> self tips.
		#filterOnClick -> true.
		#restoreOnRightClick -> true} asObject
		
! !

!OCStackedChart methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:06:28.541'!
tips

	^ {#enable -> true.
	    #onShow -> [ :tip :element | self onShowTip: tip for: element ] } asObject! !

OCChart subclass: #OCTreeGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OCTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:49'!
classMethodsOf: aClass
	
	^ aClass class methodDict! !

!OCTreeGraph class methodsFor: 'configuration' stamp: 'SW 2/23/2011 11:47'!
defaultCssId 

	^ 'treegraph'! !

!OCTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:49'!
instanceMethodsOf: aClass

	^ aClass methodDict! !

!OCTreeGraph class methodsFor: 'json' stamp: 'SW 3/16/2011 14:47'!
jsonData

	^ '(', (Json render: (self treeFor: S2JBasicApp)), ')'! !

!OCTreeGraph class methodsFor: 'configuration' stamp: 'SW 2/23/2011 12:32'!
jsonObjectFrom: aString

	^ JsonObject new
		at: #id put: aString;
		at: #name put: aString;
		yourself.
	! !

!OCTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:49'!
linesOfCodeForClass: aClass

	| sum |
	sum := 0.
	(self methodsOf: aClass) do: [ :each |
		sum := sum + (self linesOfCodeForMethod: each value) ].
	^ sum! !

!OCTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:50'!
linesOfCodeForClassNamed: aString

	| class |
	Transcript show: aString.
	class := Smalltalk classNamed: aString.
	^ class
		ifNil: [ 0 ]
		ifNotNil: [ self linesOfCodeForClass: class]! !

!OCTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:50'!
linesOfCodeForMethod: aMethod

	^ aMethod decompileString lineCount! !

!OCTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:50'!
methodsOf: aClass

	| methods |
	methods := self instanceMethodsOf: aClass.
	methods addAll: (self classMethodsOf: aClass).
	^ methods! !

!OCTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:50'!
metricsForClassNamed: aString

	| class |
	Transcript show: aString.
	class := Smalltalk classNamed: aString.
	^ OrderedCollection
		with: (self linesOfCodeForClass: class)
		with: (self numberOfMethodsOf: class)! !

!OCTreeGraph class methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:13:56.332'!
node	

	^ {#overridable -> true.
		#type -> 'rectangle'.
		#color -> '#CDEB8B'.
		#width -> 200.
		#height -> 30.
		#lineWidth -> 5.
		#align -> 'center'.
		#CanvasStyles -> { #strokeStyle -> '#ffc' . #lineWidth -> 2 } asObject.
		} asObject! !

!OCTreeGraph class methodsFor: 'metrics' stamp: 'SW 3/16/2011 14:50'!
numberOfMethodsOf: aClass

	^ (self methodsOf: aClass) size
! !

!OCTreeGraph class methodsFor: 'configuration' stamp: 'ag 4/5/2011 17:44'!
transition 
	
	^ Js jit Trans Quart easeInOut! !

!OCTreeGraph class methodsFor: 'json' stamp: 'SW 3/16/2011 14:47'!
treeFor: aClass

	| jsonObject  collection |
	jsonObject := S2JTreeGraph jsonObjectFrom: aClass name.
	aClass subclasses ifNotEmpty:
		[ collection := OrderedCollection new.
		aClass subclassesDo: [ :each |
			collection add: (self treeFor: each) ].
		jsonObject at: #children put: (Array newFrom: collection) ].
	^ jsonObject.! !

!OCTreeGraph methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:45'!
initializeWithData: json

	self chart: (Js jit ST jsNew: self parameters).
	super initializeWithData: json.
	self chart compute value.
	self chart onClick value: self chart root.! !

!OCTreeGraph methodsFor: 'rendering' stamp: 'hk 3/1/2011 12:26'!
metricsDialogNamed: aString with: aCollection

	| loc nom linesPerMethod |
	loc := aCollection first.
	nom := aCollection second.
	linesPerMethod := (loc / nom) roundTo: 0.1.
	
	^ S2JDialog new
		title: aString;
		text: 'LoC: ', loc asString, ', NoM: ', nom asString, ', L/M: ', linesPerMethod asString;
		yourself! !

!OCTreeGraph methodsFor: 'configuration' stamp: 'LT 4/4/2011 15:12:18.211'!
onBeforePlotNode: aNode

	| textLength width |
	textLength := Js Global number value: (aNode id length).
	width := textLength * 12.
	"perform since we can not use a $ in a selector directly yet"
	aNode data perform: #'$width:' with: width.
	aNode data perform: #'$height:' with: 25.! !

!OCTreeGraph methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:19:39.391'!
onClick: aNode

	self chart onClick value: aNode id.! !

!OCTreeGraph methodsFor: 'configuration' stamp: 'LT 4/4/2011 17:07:49.179'!
onCreateLabel: aLabel for: aNode
	
	aLabel id: (aNode id).
	aLabel innerHTML: (aNode name).
	aLabel onclick: [ self onClick: aNode ].
	
	aLabel style
		cursor: 'pointer';
		font: '10px';
		padding: '5px';
		width: '190px';
		height: '20px';
		border: '1px solid #888'! !

!OCTreeGraph methodsFor: 'initialization' stamp: 'LT 4/5/2011 10:44:39.758'!
onLoad

	| escapedJson json |
	escapedJson := [ S2JTreeGraph jsonData ] onServer value.
	json := Js Global eval value: escapedJson.
	self initializeWithData: json.! !

!OCTreeGraph methodsFor: 'configuration' stamp: 'ag 4/5/2011 16:48'!
parameters

	^ {#orientation -> 'left'.
	      #injectInto -> self class defaultCssId.
		#duration -> 300.
		#transition -> self class transition.
		#levelDistance -> 50.
		#offsetX -> 0.
		#Navigation -> { #enable ->  true. #panning -> true } asObject.
		#Node -> self class node.
		#Edge -> { #type ->  'arrow' . #overridable -> true . #color -> 'lightblue' } asObject.	
		#onCreateLabel -> [ :label :mynode | self onCreateLabel: label for: mynode ] 
		} asObject! !

!OCTreeGraph methodsFor: 'rendering' stamp: 'LT 4/4/2011 15:10:20.069'!
showDialogFor: aNode

	| className metrics |
	className := (Js Global string value: (aNode name)).
	metrics := [ :name | S2JTreeGraph metricsForClassNamed: name ]
		onServer value: className.
	(self metricsDialogNamed: className with: metrics)
		addToWorld;
		initializeDialog.! !

OCWidget subclass: #OCClassBrowser
	instanceVariableNames: 'packageList protocolList classList methodList saveButton codeBox sideSelector spinner searchBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OCClassBrowser class methodsFor: 'configuration' stamp: 'hk 3/9/2011 12:38'!
defaultCssId

	^ 'browser'! !

!OCClassBrowser methodsFor: 'initialization' stamp: 'sw 3/30/2011 11:34'!
addElements

	| lists classContainer all window |
	classContainer := (S2JContainer vertical
		add: self classList;
		add: self sideSelector).

	lists := (S2JContainer horizontal
		add: self packageList;
		add: classContainer;
		add: self protocolList;
		add: self methodList;
		yourself).
	all := S2JContainer vertical
		add: self searchBox;
		add: lists;
		add: self codeBox;
		add: self saveButton;
		yourself.
	
	window := (S2JWindow newTitled: 'Class Browser') add: all.
	
	self
		add: window;
		addToWorld.
		
	self spinner addToWorld.! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'ag 1/17/2011 18:18'!
classList
	^ classList! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'robi 1/17/2011 19:17'!
classList: anObject
	classList := anObject! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'LT 1/26/2011 15:33:01.404'!
codeBox

	^ codeBox! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'LT 1/26/2011 15:33:17.874'!
codeBox: aS2JCodeBox

	codeBox := aS2JCodeBox! !

!OCClassBrowser methodsFor: 'initialization' stamp: 'hk 1/26/2011 16:51'!
createButtons

	self saveButton: (S2JSaveButton newOn: self).! !

!OCClassBrowser methodsFor: 'initialization' stamp: 'hk 3/9/2011 14:55'!
createPanes
	
	self codeBox: (S2JCodeBox newOn: self).
	self methodList: (S2JMethodPane newOn: self).
	self protocolList: (S2JProtocolPane newOn: self).
	self classList: ((S2JClassPane newOn: self) extent: 200 @ 260).
	self packageList: (S2JPackagePane newOn: self).
	self sideSelector: (S2JSideSelector newOn: self).! !

!OCClassBrowser methodsFor: 'initialization' stamp: 'sec 2/28/2011 15:21'!
createSearchBox

	self searchBox: (S2JSmartSearch newOn: self).! !

!OCClassBrowser methodsFor: 'initialization' stamp: 'SW 1/31/2011 13:59'!
createSpinner
	
	self spinner: S2JLoader new.				! !

!OCClassBrowser methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:26'!
initialize

	super initialize.
	self
		cssId: self class defaultCssId;
		createSpinner;
		createSearchBox;
		createButtons;
		createPanes; 
		addElements.! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'ag 1/17/2011 18:18'!
methodList
	^ methodList! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'ag 1/17/2011 18:18'!
methodList: anObject
	methodList := anObject! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'LT 1/24/2011 14:20:34.638'!
packageList
	^ packageList! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'LT 1/24/2011 14:20:34.649'!
packageList: anObject
	packageList := anObject! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'sec 1/25/2011 14:12'!
protocolList
	^ protocolList! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'sec 1/25/2011 14:12'!
protocolList: anObject
	protocolList := anObject! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'LT 1/26/2011 10:43:15.463'!
saveButton
	^ saveButton! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'LT 1/26/2011 10:43:15.474'!
saveButton: anObject
	saveButton := anObject! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'LT 2/23/2011 15:42:05.456'!
searchBox
	^ searchBox! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'LT 2/23/2011 15:42:05.464'!
searchBox: anObject
	searchBox := anObject! !

!OCClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 14:29:01.489'!
selectCategory: aString

	self protocolList select: aString.
	self methodList updateForClass: (self classList selectedClassName) in: aString.! !

!OCClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 11:09:13.282'!
selectClass: aString

	self classList 
		select: aString;
		updateForClass.! !

!OCClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 10:47:19.703'!
selectPackage: aString

	self packageList select: aString.
	self classList updateForPackage: aString.! !

!OCClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 15:18:09.263'!
selectSelector: aString

	self methodList select: aString.
	self codeBox updateFor: aString of: self classList selectedClassName.! !

!OCClassBrowser methodsFor: 'searching' stamp: 'LT 3/1/2011 15:03:07.737'!
selectSide: isClassSide

	isClassSide
		ifTrue: [self sideSelector switchToClassside]
		ifFalse: [self sideSelector switchToInstanceside]! !

!OCClassBrowser methodsFor: 'initialization' stamp: 'LT 1/26/2011 16:54:08.361'!
showSide 

	self protocolList update.
	self codeBox displayClassDefinition.! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'sec 1/25/2011 18:05'!
sideSelector
	^ sideSelector! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'sec 1/25/2011 18:05'!
sideSelector: anObject
	sideSelector := anObject! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'SW 1/31/2011 13:03'!
spinner
	^ spinner! !

!OCClassBrowser methodsFor: 'accessing' stamp: 'SW 1/31/2011 13:03'!
spinner: anObject
	spinner := anObject! !

OCWidget subclass: #OCConfirm
	instanceVariableNames: 'message block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCConfirm class methodsFor: 'configuration' stamp: 'hk 3/21/2011 14:09'!
defaultMessage

	^ 'Are you sure?'! !

!OCConfirm methodsFor: 'accessing' stamp: 'hk 3/21/2011 13:27'!
block
	^ block! !

!OCConfirm methodsFor: 'accessing' stamp: 'hk 3/21/2011 13:27'!
block: anObject
	block := anObject! !

!OCConfirm methodsFor: 'accessing' stamp: 'hk 4/5/2011 14:59'!
confirm

	| isConfirmed |
	isConfirmed := Js Global confirm value: self message.
	isConfirmed ifTrue: [ self block value ].! !

!OCConfirm methodsFor: 'accessing' stamp: 'hk 3/21/2011 14:10'!
message
	message ifNil: [ message := self class defaultMessage ].
	^ message! !

!OCConfirm methodsFor: 'accessing' stamp: 'hk 3/21/2011 13:27'!
message: anObject
	message := anObject! !

OCWidget subclass: #OCContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCContainer class methodsFor: 'instance creation' stamp: 'hk 1/25/2011 14:46'!
horizontal

	^ S2JHorizontalContainer new! !

!OCContainer class methodsFor: 'configuration' stamp: 'hk 1/24/2011 10:43'!
htmlElementType

	^ 'div'! !

!OCContainer class methodsFor: 'configuration' stamp: 'hk 4/5/2011 16:43'!
start

	S2JTabHost new
		add: (S2JTextArea new) named: 'TextArea A';
		add: (S2JTextArea new) named: 'TextArea B';
		addToWorld.! !

!OCContainer class methodsFor: 'instance creation' stamp: 'hk 1/24/2011 16:56'!
vertical

	^ S2JVerticalContainer new! !

!OCContainer methodsFor: 'rendering' stamp: 'hk 3/8/2011 11:20'!
add: element

	super add: element.
	element beRelative! !

OCContainer subclass: #OCHorizontalContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCHorizontalContainer methodsFor: 'initialization' stamp: 'hk 1/31/2011 15:09'!
initialize
	
	super initialize.
	self cssClass: 'horizontal'.
! !

OCContainer subclass: #OCVerticalContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCVerticalContainer methodsFor: 'initialization' stamp: 'sw 4/5/2011 13:34'!
initialize
	
	super initialize.
	self cssClass: 'vertical'. ! !

OCWidget subclass: #OCControls
	instanceVariableNames: 'restartButton clearCacheButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OCControls methodsFor: 'initialization' stamp: 'SW 3/16/2011 14:37'!
addElements

	| panel |
	panel := S2JVerticalContainer new
		add: self restartButton;
		add: self clearCacheButton.
	self add: panel.! !

!OCControls methodsFor: 'initialization' stamp: 'SW 3/16/2011 14:36'!
addTexts
	
	self add: (S2JHeading new
		text: 'Here you can control the S2J Engine!! Please be aware of delays when forcing restart or clearing the cache!!';
			yourself).! !

!OCControls methodsFor: 'accessing' stamp: 'SW 2/7/2011 14:31'!
clearCacheButton
	^ clearCacheButton! !

!OCControls methodsFor: 'accessing' stamp: 'SW 2/7/2011 14:31'!
clearCacheButton: anObject
	clearCacheButton := anObject! !

!OCControls methodsFor: 'initialization' stamp: 'ag 4/6/2011 13:00'!
createButtons
	
	self restartButton: (
		S2JButton new
			text: 'Force restart of WebServer';
			onClickDo: [ :event | S2JDispatcher forcedRestart ] onServer).
	
	self	 clearCacheButton: (
		S2JButton new
			text: 'Clear Cache of Translator';
			onClickDo: [ :event |
				S2JConfirm new 
					block: [ S2JPrettyCodeFactory clearCache ] onServer;
					confirm ];
			yourself).! !

!OCControls methodsFor: 'initialization' stamp: 'SW 3/16/2011 14:36'!
initialize 
	
	super initialize.
	self
		createButtons;
		addTexts;
		addElements.! !

!OCControls methodsFor: 'accessing' stamp: 'SW 2/7/2011 14:31'!
restartButton
	^ restartButton! !

!OCControls methodsFor: 'accessing' stamp: 'SW 2/7/2011 14:31'!
restartButton: anObject
	restartButton := anObject! !

OCWidget subclass: #OCDialog
	instanceVariableNames: 'paragraph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCDialog class methodsFor: 'configuration' stamp: 'hk 2/28/2011 15:01'!
defaultCssId

	^ 'dialog'! !

!OCDialog methodsFor: 'initialization' stamp: 'hk 2/28/2011 16:05'!
initialize
	
	super initialize.
	self cssId: self class defaultCssId.
	self paragraph: S2JParagraph new.
	self add: self paragraph.
! !

!OCDialog methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
initializeDialog

	(Js @ ('#', self class defaultCssId)) dialog
		value: self parameters.! !

!OCDialog methodsFor: 'initialization' stamp: 'hk 3/6/2011 22:14'!
onLoad

	self initializeDialog.
	super onLoad.! !

!OCDialog methodsFor: 'accessing' stamp: 'hk 2/28/2011 14:59'!
paragraph
	^ paragraph! !

!OCDialog methodsFor: 'accessing' stamp: 'hk 2/28/2011 14:59'!
paragraph: anObject
	paragraph := anObject! !

!OCDialog methodsFor: 'accessing' stamp: 'LT 4/4/2011 17:17:11.31'!
parameters

	^ { #autoOpen -> true.
		#show -> 'clip'.
		#hide -> 'clip' } asObject
! !

!OCDialog methodsFor: 'accessing' stamp: 'hk 2/28/2011 15:00'!
text

	^ self paragraph text! !

!OCDialog methodsFor: 'accessing' stamp: 'hk 2/28/2011 15:00'!
text: aString

	self paragraph text: aString.! !

!OCDialog methodsFor: 'accessing' stamp: 'LT 4/4/2011 17:25:30.699'!
title
	
	^ self node title! !

!OCDialog methodsFor: 'accessing' stamp: 'LT 4/4/2011 17:25:22.373'!
title: aString

	self node title: aString.! !

OCWidget subclass: #OCImage
	instanceVariableNames: 'source description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCImage class methodsFor: 'configuration' stamp: 'SW 1/31/2011 12:40'!
htmlElementType

	^ 'img'! !

!OCImage methodsFor: 'accessing' stamp: 'SW 1/31/2011 12:41'!
description
	^ description! !

!OCImage methodsFor: 'accessing' stamp: 'sw 3/29/2011 13:49'!
description: anObject

	description := anObject.
	self node alt: anObject.
	! !

!OCImage methodsFor: 'initialization' stamp: 'hk 2/1/2011 12:29'!
initialize 
	
	super initialize.
	self
		source: '';
		description: ''.! !

!OCImage methodsFor: 'accessing' stamp: 'SW 1/31/2011 12:41'!
source
	^ source! !

!OCImage methodsFor: 'accessing' stamp: 'sw 3/29/2011 13:49'!
source: anObject

	source := anObject.
	self node src: anObject.! !

OCWidget subclass: #OCInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OCInput subclass: #OCButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCButton methodsFor: 'initialization' stamp: 'sw 3/29/2011 14:25'!
initialize 
	
	super initialize.
	self node type: 'button'! !

OCButton subclass: #OCjQueryButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OCjQueryButton subclass: #OCSaveButton
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OCSaveButton class methodsFor: 'instance creation' stamp: 'LT 1/26/2011 10:40:51.535'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OCSaveButton methodsFor: 'accessing' stamp: 'LT 1/26/2011 10:41:10.614'!
browser
	^ browser! !

!OCSaveButton methodsFor: 'accessing' stamp: 'LT 1/26/2011 10:41:10.624'!
browser: anObject
	browser := anObject! !

!OCSaveButton methodsFor: 'save source' stamp: 'sec 3/23/2011 18:38'!
compileSource: source of: className 

	[ :cls :src | (Smalltalk classNamed: cls) compile: src ] onServer 
		value: className 
		value: source.! !

!OCSaveButton methodsFor: 'save source' stamp: 'LT 2/23/2011 13:51:50.717'!
evaluateClassDefinition: aString

	[ :def | Compiler evaluate: def ] onServer value: aString.! !

!OCSaveButton methodsFor: 'initialization' stamp: 'hk 3/23/2011 14:04'!
initialize

	super initialize.
	self
		text: 'Save';
		onClickDo: [ self save ].! !

!OCSaveButton methodsFor: 'save source' stamp: 'LT 4/4/2011 15:12:53.677'!
isInputValidWith: source and: className

	| errorText |
	errorText := ''.
	"does anyone know how to do newline in JS?"
	source isEmpty ifTrue: [errorText := 'No source input.', [ String cr ] onServer value].
	className isEmpty ifTrue: [errorText := errorText, 'No class selected.'].
	errorText isEmpty ifFalse: [Js Global js alert: errorText].
	^ errorText isEmpty! !

!OCSaveButton methodsFor: 'save source' stamp: 'LT 2/23/2011 14:20:13.047'!
save

	| source |
	source := self browser codeBox text.
	(self browser methodList currentSelection isEmpty)  
		ifTrue: [self evaluateClassDefinition: source]
		ifFalse: 
			[ |className|
			className := self browser classList selectedClassName.
			(self isInputValidWith: source and: className)
				ifTrue: [ self compileSource: source of: className]]
	! !

!OCjQueryButton methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:29'!
onLoad
	
	(Js @ 'input:button') button value.! !

!OCInput class methodsFor: 'instance creation' stamp: 'LT 2/23/2011 15:38:05.444'!
doing: aBlock withText: aString
	
	^ self new
		onClickDo: aBlock;
		text: aString;
		yourself! !

!OCInput class methodsFor: 'configuration' stamp: 'LT 2/23/2011 15:32:03.601'!
htmlElementType
	
	^ 'input'! !

!OCInput class methodsFor: 'instance creation' stamp: 'hk 3/28/2011 15:33'!
onClick: aBlock
	
	^ self new onClickDo: aBlock; yourself! !

!OCInput methodsFor: 'rendering' stamp: 'sw 3/30/2011 15:00'!
disable
	
	self node disabled: true! !

!OCInput methodsFor: 'rendering' stamp: 'sw 3/30/2011 15:00'!
enable
	
	self node disabled: false! !

!OCInput methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:28'!
onClickDo: aBlockClosure

	self node onclick: aBlockClosure.! !

!OCInput methodsFor: 'accessing' stamp: 'LT 4/4/2011 17:30:12.227'!
text
	
	^ self node value
	! !

!OCInput methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:27'!
text: aString
	
	self node value: aString
	! !

OCInput subclass: #OCSmartSearch
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OCSmartSearch class methodsFor: 'searching' stamp: 'LT 3/1/2011 14:49:51.707'!
classNameFor: aMethodReference

	| classname |
	classname := aMethodReference classSymbol asString.
	(aMethodReference classIsMeta) ifTrue: [ classname := classname, ' class' ].
	^ classname! !

!OCSmartSearch class methodsFor: 'instance creation' stamp: 'LT 2/24/2011 21:20:33.501'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OCSmartSearch class methodsFor: 'searching' stamp: 'sw 3/31/2011 10:16'!
search: aString
	
	| searchString |
	searchString := aString trimBoth.
	^ (searchString first isUppercase) 
		ifTrue: [self searchForClass: searchString]
		ifFalse: [self searchForSelector: searchString]! !

!OCSmartSearch class methodsFor: 'searching' stamp: 'sw 3/31/2011 14:28'!
searchForClass: aString

	^ Smalltalk allClasses 
			select: [ :each | each name includesSubstring: aString caseSensitive: false]
			thenCollect: [ :each | 
				{#label -> each name.
				#value -> each name.
				#package -> each category. 
				#class -> each name. 
				#selector -> nil.
				#category -> nil.
				#classside -> false} asObject ]! !

!OCSmartSearch class methodsFor: 'searching' stamp: 'lw 3/1/2011 18:54'!
searchForSelector: aString
	^ (SystemNavigation new allImplementorsOf: aString asSymbol) asArray
		collect: [ :each | 
			| className methodName |
			className := self classNameFor: each.
			methodName := (className , '>>' , each methodSymbol asString).
			{#label -> methodName.
			#value -> methodName.
			#package -> (Smalltalk classNamed: each classSymbol) category.
			#class -> each classSymbol.
			#selector -> each methodSymbol.
			#category -> ((Smalltalk classNamed: className) organization categoryOfElement: each methodSymbol).
			#classside -> each classIsMeta} asObject ]! !

!OCSmartSearch methodsFor: 'accessing' stamp: 'LT 2/24/2011 21:24:26.831'!
browser
	^ browser! !

!OCSmartSearch methodsFor: 'accessing' stamp: 'LT 2/24/2011 21:24:26.844'!
browser: anObject
	browser := anObject! !

!OCSmartSearch methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:35'!
enableAutocomplete

	| widget |
	self cssId: 'smartSearch'.
	widget := Js @ '#smartSearch'.
	widget autocomplete
		value:
			{
			(#appendTo -> ('#', S2JWindow defaultCssId)).
			(#select -> [ :event :ui | self handleSelection: ui ]) .
			(#source
				-> [ :request :response | 
					| matches |
					matches := [ :input | S2JSmartSearch search: input ] onServer value: (request term).
					response value: matches asArray ]).
			(#minLength -> 3).
			(#delay -> 500)} asObject! !

!OCSmartSearch methodsFor: 'initialization' stamp: 'hk 4/5/2011 11:55'!
handleSelection: ui

	self browser
		selectPackage: ui item package;
		selectSide: ui item classside;
		selectClass: ui item class.
	(self isSearchForSelector: ui)
		ifFalse: [ 
			(self browser)
				selectCategory: ui item category;
				selectSelector: ui item selector ].! !

!OCSmartSearch methodsFor: 'initialization' stamp: 'hk 4/5/2011 12:00'!
isSearchForSelector: ui

	^ ui item selector isNil! !

!OCSmartSearch methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:25'!
onLoad 

	self enableAutocomplete.
	super onLoad.! !

OCWidget subclass: #OCListItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCListItem class methodsFor: 'configuration' stamp: 'SW 2/21/2011 14:03'!
htmlElementType

	^ 'li'! !

OCListItem subclass: #OCTab
	instanceVariableNames: 'associatedWidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCTab class methodsFor: 'instance creation' stamp: 'SW 3/16/2011 13:45'!
newFor: aWidget named: aString
	
	^ self new
		associatedWidget: aWidget;
		add: (S2JAnchor referencing: aWidget named: aString);
		yourself! !

!OCTab methodsFor: 'accessing' stamp: 'SW 3/16/2011 11:01'!
associatedWidget
	^ associatedWidget! !

!OCTab methodsFor: 'accessing' stamp: 'SW 3/16/2011 11:01'!
associatedWidget: anObject
	associatedWidget := anObject! !

OCWidget subclass: #OCLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCLoader class methodsFor: 'configuration' stamp: 'hk 2/1/2011 15:27'!
defaultImage

	^ 'http://localhost:8887/play/file/images/loader.gif'! !

!OCLoader class methodsFor: 'configuration' stamp: 'hk 2/1/2011 12:31'!
htmlElementType

	^ 'div'! !

!OCLoader methodsFor: 'initialization' stamp: 'hk 2/1/2011 15:53'!
initialize

	| image |
	super initialize.
	
	image := S2JImage new
		source: self class defaultImage;
	 	description: 'Loading'.
	self cssClass: 'loader'.
	self add: (S2JParagraph new add: image; yourself).
	self hide.! !

!OCLoader methodsFor: 'initialization' stamp: 'sw 3/29/2011 14:51'!
show 

	self node style display: 'table'.! !

OCWidget subclass: #OCMonticelloStatistics
	instanceVariableNames: ''
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/9/2011 11:50'!
afternoonCommitsOf: versionInfos

	^ self filterCommits: versionInfos with: [ :each |
		each time notNil
		and: [ each time hours >= 12 ]
		and: [ each time hours < 18 ]]! !

!OCMonticelloStatistics class methodsFor: 'accessing' stamp: 'hk 3/9/2011 10:40'!
cache
	Cache ifNil: [ Cache := Dictionary new ].
	^ Cache! !

!OCMonticelloStatistics class methodsFor: 'accessing' stamp: 'hk 3/9/2011 10:39'!
cache: anObject
	Cache := anObject! !

!OCMonticelloStatistics class methodsFor: 'caching' stamp: 'hk 3/9/2011 10:53'!
cache: data as: aKey

	self cache
		at: aKey
		put: (self latestRevision -> data).! !

!OCMonticelloStatistics class methodsFor: 'caching' stamp: 'hk 3/22/2011 20:48'!
calculateAndCacheFor: aKey

	| data |
	aKey = #commitsByWeek ifTrue: [ data := self commitsByWeek ].
	aKey = #commitsByWeekDay ifTrue: [ data := self commitsByWeekDay ].
	aKey = #commitsByHour ifTrue: [ data := self commitsByHour ].
	self cache: data as: aKey.
	^ data! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 18:30'!
commitsAtHour: anHour

	^ self versionInfos select:
		[ :each |
			each time notNil and:
				[ each time hour = anHour ]]! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'SW 3/16/2011 16:17'!
commitsByHour

	| values |
	values := OrderedCollection new.
	
	0 to: 23 do: [ :hour | | amount record |
		amount := (S2JMonticelloStatistics commitsAtHour: hour) size.
		record := self jsonObjectLabeled: hour withValues: { amount }.
		values add: record ].
	
	^ self jsonObjectLabeled: { 'hour' . 'amount'} withValues: values! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 23:03'!
commitsByTimeSpan: aTimeSpan

	| result date |
	result := OrderedCollection new.
	date := self firstDate - 1 day.
	[ date <= Date today ] whileTrue:
		[ date := date + aTimeSpan.
		result add: (date -> ((self commitsUntil: date) size)) ].
	^ result! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'SW 3/16/2011 14:42'!
commitsByWeek

	| values increment sum |
	values := OrderedCollection new.
	sum := 0.
	(self commitsByTimeSpan: 1 week) do: [ :each | | date record |
		date := each key asString.
		increment := each value - sum.
		record := self jsonObjectLabeled: date withValues: { sum . increment }.
		sum := each value.
		values add: record ].
	
	^ self jsonObjectLabeled: { 'previous commits' . 'increment'} withValues: values! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/9/2011 12:00'!
commitsByWeekDay

	| values |
	values := OrderedCollection new.
	self dayNames do: [ :each | | daily morning afternoon evening nightly record |
		daily := self commitsOnWeekDay: each.
		morning := (self morningCommitsOf: daily) size.
		afternoon := (self afternoonCommitsOf: daily) size.
		evening := (self eveningCommitsOf: daily) size.
		nightly := (self nightlyCommitsOf: daily) size.
		record := self jsonObjectLabeled: each withValues: { morning . afternoon .evening . nightly }.
		values add: record ].
	
	^ self jsonObjectLabeled: { 'morning' . 'afternoon' . 'evening' . 'nightly' } withValues: values! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/9/2011 11:49'!
commitsOnWeekDay: aWeekDay

	 ^ self versionInfos select:
		[ :each |
			each time notNil and:
				[ each date weekday = aWeekDay ]]! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 21:54'!
commitsUntil: aDate

	^ S2JMonticelloStatistics versionInfos select: [ :each | each date <= aDate ]! !

!OCMonticelloStatistics class methodsFor: 'configuration' stamp: 'hk 3/9/2011 12:08'!
dayNames

	| nonIsoCompliantWeek sunday |
	nonIsoCompliantWeek := Week dayNames.
	sunday := nonIsoCompliantWeek first.
	^ (nonIsoCompliantWeek
		copyWithout: sunday)
		copyWith: sunday! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/9/2011 11:58'!
eveningCommitsOf: versionInfos

	^ self filterCommits: versionInfos with: [ :each |
		each time notNil
		and: [ each time hours >= 18 ]]! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 18:03'!
extractRevisionFrom: aVersionInfo

	| versionName segments revision |
	versionName := aVersionInfo name.
	segments := versionName subStrings: '.'.
	(segments size < 2) ifTrue: [ ^ nil ].
	revision := segments last trimLeft: [ :char | char isDigit not ].
	^ revision asNumber! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/9/2011 11:46'!
filterCommits: versionInfos with: aBlock

	^ versionInfos select: aBlock! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 21:54'!
firstDate

	^ (self versionInfos at: 1) date! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 18:08'!
insert: aVersionInfo into: aDictionary

	aDictionary
		at: (self extractRevisionFrom: aVersionInfo)
		put: aVersionInfo.! !

!OCMonticelloStatistics class methodsFor: 'caching' stamp: 'hk 3/9/2011 10:50'!
isCached: aKey

	(self cache includesKey: aKey)
		ifFalse: [ ^ false ]
		ifTrue:
			[ | association |
			association := self cache at: aKey.
			^ association key == self latestRevision ]! !

!OCMonticelloStatistics class methodsFor: 'rendering' stamp: 'SW 3/16/2011 13:50'!
jsonDataAt: aKey

	| data |
	(self isCached: aKey)
		ifTrue: [ data := (self cache at: aKey) value ]
		ifFalse: [ data := self calculateAndCacheFor: aKey ].

	^ '(', (Json render: data), ')'
	
! !

!OCMonticelloStatistics class methodsFor: 'rendering' stamp: 'SW 3/16/2011 14:43'!
jsonObjectLabeled: aLabel withValues: values

	^ JsonObject new
		at: #label put: aLabel;
		at: #values put: values;
		yourself! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 17:59'!
latestRevision

	^ self extractRevisionFrom: self latestVersionInfo! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 17:34'!
latestVersionInfo

	^ self workingCopy ancestry ancestors first! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/9/2011 11:48'!
morningCommitsOf: versionInfos

	^ self filterCommits: versionInfos with: [ :each |
		each time notNil
		and: [ each time hours >= 6 ]
		and: [ each time hours < 12 ]]! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/9/2011 11:50'!
nightlyCommitsOf: versionInfos

	^ self filterCommits: versionInfos with: [ :each |
		each time notNil
		and: [ each time hours >= 0 ]
		and: [ each time hours < 6 ]]! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 17:32'!
package

	^ MCPackage allInstances detect: [ :first | first name = self packageName ]
! !

!OCMonticelloStatistics class methodsFor: 'configuration' stamp: 'hk 3/7/2011 17:33'!
packageName

	^ 'Squeak2JS'! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 18:10'!
versionInfos

	| current result |
	result := Dictionary new.
	current := self latestVersionInfo.
	self insert: current into: result.
	[ current ancestors notEmpty ] whileTrue: [
		current := current ancestors first.
		self insert: current into: result. ].
	^ result! !

!OCMonticelloStatistics class methodsFor: 'statistics' stamp: 'hk 3/7/2011 17:33'!
workingCopy

	^ self package workingCopy
! !

!OCMonticelloStatistics methodsFor: 'initialization' stamp: 'SW 3/15/2011 17:04'!
addCommitDistribution

	| heading |
	
	heading := (S2JHeading new text: 'Weekly commits per day').
	heading marginTop: 70.
	self add: heading .
	self add: S2JBarChart new.
	

		
	! !

!OCMonticelloStatistics methodsFor: 'initialization' stamp: 'SW 3/16/2011 16:18'!
addCommitsByHour

	| heading |
	
	heading := (S2JHeading new text: 'Commits per hour').
	heading marginTop: 70.
	self add: heading .
	self add: S2JCommitsByHour new.
	

		
	! !

!OCMonticelloStatistics methodsFor: 'initialization' stamp: 'SW 3/15/2011 16:55'!
addOverviewOfCommits

	self add: (S2JHeading new text: 'Overview of commits').
	self add: S2JAreaChart new.
	
		
! !

!OCMonticelloStatistics methodsFor: 'initialization' stamp: 'SW 3/16/2011 16:17'!
initialize

	super initialize.	
	
	self
		addOverviewOfCommits;
		addCommitDistribution;
		addCommitsByHour.! !

OCWidget subclass: #OCNamedWidget
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCNamedWidget methodsFor: 'accessing' stamp: 'hk 2/1/2011 14:18'!
name
	^ name! !

!OCNamedWidget methodsFor: 'accessing' stamp: 'hk 2/1/2011 14:18'!
name: anObject
	name := anObject! !

OCNamedWidget subclass: #OCRadioButton
	instanceVariableNames: 'caption value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCRadioButton class methodsFor: 'configuration' stamp: 'hk 2/1/2011 10:51'!
htmlElementType

	^ 'input'! !

!OCRadioButton class methodsFor: 'instance creation' stamp: 'hk 3/6/2011 22:29'!
withCaption: aCaption andValue: aValue

	^ self new
		caption: aCaption;
		value: aValue;
		cssId: aValue;
		refreshMarkup! !

!OCRadioButton methodsFor: 'accessing' stamp: 'hk 2/1/2011 10:54'!
caption
	^ caption! !

!OCRadioButton methodsFor: 'accessing' stamp: 'hk 2/1/2011 10:54'!
caption: anObject
	caption := anObject! !

!OCRadioButton methodsFor: 'convenience' stamp: 'sw 3/29/2011 15:51'!
check

	self node checked: 'checked'.! !

!OCRadioButton methodsFor: 'initialization' stamp: 'sw 3/29/2011 15:51'!
initialize 

	super initialize.
	self node type: 'radio'.! !

!OCRadioButton methodsFor: 'convenience' stamp: 'sw 3/29/2011 15:51'!
isChecked

	^ self node checked! !

!OCRadioButton methodsFor: 'initialization' stamp: 'sw 3/29/2011 15:52'!
refreshMarkup

	self node value: self value.
	self node name: self name.! !

!OCRadioButton methodsFor: 'accessing' stamp: 'hk 2/1/2011 10:56'!
value
	^ value! !

!OCRadioButton methodsFor: 'accessing' stamp: 'hk 2/1/2011 10:56'!
value: anObject
	value := anObject! !

OCNamedWidget subclass: #OCRadioGroup
	instanceVariableNames: 'radioButtons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OCRadioGroup subclass: #OCButtonSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCButtonSet class methodsFor: 'configuration' stamp: 'hk 3/6/2011 22:45'!
defaultCssId

	^ 'buttonSet'! !

!OCButtonSet methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
enableButtonSet
	
	(Js @ ('#', self class defaultCssId)) buttonset value! !

!OCButtonSet methodsFor: 'initialization' stamp: 'hk 3/6/2011 22:49'!
initialize

	super initialize.
	self cssId: self class defaultCssId.! !

!OCButtonSet methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:24'!
onLoad

	self enableButtonSet.! !

OCButtonSet subclass: #OCSideSelector
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OCSideSelector class methodsFor: 'defaults' stamp: 'hk 3/9/2011 14:56'!
classside

	^ 'class'! !

!OCSideSelector class methodsFor: 'defaults' stamp: 'LT 3/1/2011 15:02:14.51'!
instanceside

	^ 'instance'! !

!OCSideSelector class methodsFor: 'instance creation' stamp: 'sec 1/26/2011 14:33'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OCSideSelector methodsFor: 'accessing' stamp: 'sec 1/25/2011 17:52'!
browser
	^ browser! !

!OCSideSelector methodsFor: 'accessing' stamp: 'sec 1/25/2011 17:52'!
browser: anObject
	browser := anObject! !

!OCSideSelector methodsFor: 'initialization' stamp: 'hk 3/9/2011 15:01'!
initialize

	super initialize.
	self name: 'side-selector'.
	self addButtonNamed: self class instanceside.
	self addButtonNamed: self class classside.
	self onChange: [ self browser showSide ].! !

!OCSideSelector methodsFor: 'initialization' stamp: 'sw 4/4/2011 15:16'!
switchToClassside 

	self select: self class classside ! !

!OCSideSelector methodsFor: 'initialization' stamp: 'sw 4/4/2011 15:16'!
switchToInstanceside 

	self select: self class instanceside! !

!OCRadioGroup class methodsFor: 'configuration' stamp: 'hk 2/1/2011 10:49'!
htmlElementType

	^ 'div'! !

!OCRadioGroup class methodsFor: 'instance creation' stamp: 'hk 2/1/2011 11:10'!
newNamed: aName

	^ self new name: aName! !

!OCRadioGroup methodsFor: 'rendering' stamp: 'hk 3/9/2011 14:52'!
add: aRadioButton

	self children ifEmpty: [ aRadioButton check ].
	self addLabelFor: aRadioButton.
	aRadioButton
		name: self name;
		refreshMarkup.
	super add: aRadioButton.
	self radioButtons add: aRadioButton.! !

!OCRadioGroup methodsFor: 'rendering' stamp: 'hk 3/2/2011 16:52'!
addButtonNamed: aString

	self add: (S2JRadioButton withCaption: aString andValue: aString).! !

!OCRadioGroup methodsFor: 'rendering' stamp: 'hk 3/6/2011 22:25'!
addLabelFor: aRadioButton

	| label |
	label := S2JLabel for: aRadioButton.
	super add: label.! !

!OCRadioGroup methodsFor: 'accessing' stamp: 'ag 4/5/2011 17:59'!
currentSelection

	^ ((Js @ '.radio') find value: ':checked') first value! !

!OCRadioGroup methodsFor: 'initialization' stamp: 'hk 3/9/2011 14:49'!
initialize

	super initialize.
	self cssClass: 'radio'.
	self radioButtons: OrderedCollection new.! !

!OCRadioGroup methodsFor: 'rendering' stamp: 'sw 3/29/2011 15:52'!
onChange: aBlock

	self radioButtons do: [ :each | each node onclick: aBlock ].! !

!OCRadioGroup methodsFor: 'accessing' stamp: 'hk 3/9/2011 14:48'!
radioButtons
	^ radioButtons! !

!OCRadioGroup methodsFor: 'accessing' stamp: 'hk 3/9/2011 14:48'!
radioButtons: anObject
	radioButtons := anObject! !

!OCRadioGroup methodsFor: 'accessing' stamp: 'sw 4/4/2011 16:44'!
select: aString

	self radioButtons do: [:each |
		each value = aString 
			ifTrue: [ each check ]
		]! !

OCWidget subclass: #OCSelectList
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OCSelectList subclass: #OCBrowserPane
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OCBrowserPane class methodsFor: 'instance creation' stamp: 'sec 1/25/2011 16:07'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OCBrowserPane methodsFor: 'accessing' stamp: 'sec 1/25/2011 15:29'!
browser
	^ browser! !

!OCBrowserPane methodsFor: 'accessing' stamp: 'sec 1/25/2011 15:29'!
browser: anObject
	browser := anObject! !

!OCBrowserPane methodsFor: 'initialization' stamp: 'sec 1/25/2011 15:53'!
initialize
	
	super initialize.
	self
		position: 0 @ 0;
		extent: 200 @ 300.! !

!OCBrowserPane methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:40'!
update
	
	self clear.! !

OCBrowserPane subclass: #OCClassPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OCClassPane methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:29'!
clear

	super clear.
	self browser protocolList clear.! !

!OCClassPane methodsFor: 'rendering' stamp: 'sw 3/30/2011 16:56'!
selectedClassName

	| className |
	className := self currentSelection.
	(self browser sideSelector currentSelection = 'class') ifTrue: [className := className, ' class'].
	^ className! !

!OCClassPane methodsFor: 'rendering' stamp: 'sw 4/5/2011 09:17'!
updateForClass

	self browser protocolList update.
	self browser codeBox displayClassDefinition! !

!OCClassPane methodsFor: 'rendering' stamp: 'sw 3/30/2011 16:15'!
updateForPackage: aPackageName
	
	| packageClassNames |
	self browser spinner show.
	self browser saveButton disable.
	self update.
	packageClassNames := [ :name | Smalltalk allClasses 
			select: [ :each | each category asString = name ]
			thenCollect: [ :eachClass | eachClass name asString ] ]
		onServer value: aPackageName.
	packageClassNames do: 
		[ :each | self
			addString: each 
			onClickDo: 
				[ self updateForClass ]].
	self browser spinner hide.! !

OCBrowserPane subclass: #OCMethodPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OCMethodPane methodsFor: 'rendering' stamp: 'LT 1/26/2011 10:54:45.028'!
clear

	super clear.
	self browser codeBox clear.! !

!OCMethodPane methodsFor: 'rendering' stamp: 'LT 2/23/2011 14:43:30.445'!
updateForClass: aClassName in: aProtocolName

	|selectors|
	self browser spinner show.
	self update.
	self browser saveButton disable.
	selectors := [ :className :category || selectorNames class |
			class := Smalltalk classNamed: className.
			selectorNames := class organization
				listAtCategoryNamed: category.
			selectorNames collect: [ :each | each asString ]
		] onServer value: aClassName value: aProtocolName.
	selectors do: [ :selector |
			self
				addString: selector asString
				onClickDo: [ self browser codeBox updateFor: selector of: aClassName]].
	self browser spinner hide.! !

OCBrowserPane subclass: #OCPackagePane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OCPackagePane methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:53'!
clear

	super clear.
	self browser classList clear.! !

!OCPackagePane methodsFor: 'initialization' stamp: 'sec 1/25/2011 15:27'!
initialize

	super initialize.
	self update.! !

!OCPackagePane methodsFor: 'rendering' stamp: 'LT 2/23/2011 14:44:24.622'!
update
	
	| allCategoryNames |
	self browser spinner show.
	super update.
	allCategoryNames := [ Smalltalk organization categories
			collect: [ :each | each asString ] ]
		onServer value.
	allCategoryNames do: 
		[ :each | 
			self
				addString: each
				onClickDo: [ self browser classList updateForPackage: each ]].
	self browser spinner hide.			! !

OCBrowserPane subclass: #OCProtocolPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OCProtocolPane methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:29'!
clear

	super clear.
	self browser methodList clear.! !

!OCProtocolPane methodsFor: 'rendering' stamp: 'sw 3/31/2011 09:02'!
update
	
	| allCategoryNames className |
	self browser spinner show.
	super update.	
	className := self browser classList selectedClassName.
	allCategoryNames := [ :class  |
			(Smalltalk classNamed: class) 
				organization categories 
				collect: [ :each | each asString ] ]
		onServer value: className.
	allCategoryNames do: 
		[ :eachCategory | 
			self
				addString: eachCategory
				onClickDo: [ self browser methodList updateForClass: className in: eachCategory ]].
	self browser spinner hide.! !

!OCSelectList class methodsFor: 'configuration' stamp: 'lw 1/13/2011 10:38'!
htmlElementType
	^ 'select'! !

!OCSelectList methodsFor: 'rendering' stamp: 'ag 1/18/2011 14:36'!
addOption: aString
	
	^ self addOption: aString value: aString onClickDo: []! !

!OCSelectList methodsFor: 'rendering' stamp: 'robi 1/17/2011 19:39'!
addOption: aString value: aValueString
	
	^ self addOption: aString value: aValueString defaultSelected: false selected: false! !

!OCSelectList methodsFor: 'rendering' stamp: 'LT 1/18/2011 22:15:50.369'!
addOption: anOption value: aValue defaultSelected: isDefaultSelected selected: isSelected
	"Just to have the full HTML-Option-API reflected here."
	
	^self add: (S2JListOption new text: anOption; yourself).! !

!OCSelectList methodsFor: 'rendering' stamp: 'sw 3/29/2011 15:48'!
addOption: aString value: anotherString onClickDo: aBlock
	
	| anOption |
	anOption := self addOption: aString value: anotherString defaultSelected: false selected: false.
	anOption node onclick: [aBlock value: aString].
	^anOption! !

!OCSelectList methodsFor: 'rendering' stamp: 'LT 1/18/2011 21:13:49.638'!
addString: aString

	^ self addString: aString onClickDo: []! !

!OCSelectList methodsFor: 'rendering' stamp: 'sec 2/25/2011 22:29'!
addString: aString onClickDo: aBlock

	^self addOption: aString value: aString onClickDo: aBlock! !

!OCSelectList methodsFor: 'rendering' stamp: 'sw 3/29/2011 15:48'!
collapse

	self node size: '1'.
	self node height: '20px'.! !

!OCSelectList methodsFor: 'rendering' stamp: 'sw 3/30/2011 17:12'!
currentSelection

	^ self node value! !

!OCSelectList methodsFor: 'rendering' stamp: 'LT 1/18/2011 21:12:22.393'!
fillWith: anOrderedCollection
	
	
	
	
"	| text |
	text := anArrayString.
	S2JText new 
		addToWorld;
		text: text;
		position: 10 @ 200."! !

!OCSelectList methodsFor: 'initialization' stamp: 'sw 3/30/2011 13:13'!
initialize
	
	super initialize.
	self node size: 2! !

!OCSelectList methodsFor: 'initialization' stamp: 'sw 3/29/2011 15:50'!
onChange: aBlock

	self node onchange: aBlock! !

!OCSelectList methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:49'!
options

	^ self node getElementsByTagName value: 'option'! !

!OCSelectList methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:47'!
select: aString

	self options do: [ :each | (aString = (each text))  ifTrue: [ each selected: true ]]! !

OCWidget subclass: #OCSystemStatus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OCSystemStatus methodsFor: 'initialization' stamp: 'SW 3/16/2011 14:45'!
addGraph

	self add: S2JTreeGraph new.! !

!OCSystemStatus methodsFor: 'initialization' stamp: 'SW 3/16/2011 14:02'!
addTexts
	
	self add: (S2JHeading new text: 'Application hierarchy').! !

!OCSystemStatus methodsFor: 'initialization' stamp: 'SW 3/16/2011 14:45'!
initialize 
	
	super initialize.
	self
		addTexts;
		addGraph.! !

OCWidget subclass: #OCSystemStatusTabHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OCSystemStatusTabHolder methodsFor: 'initialization' stamp: 'SW 3/16/2011 14:40'!
addTabs

	| tabs |
	tabs := S2JTabHost new
		add: (S2JMonticelloStatistics new) named: 'Monticello Statistics';
		add: (S2JSystemStatus new) named: 'Class hierachy';
		add: (S2JControls new) named: 'System control'.
	self add: tabs.! !

!OCSystemStatusTabHolder methodsFor: 'initialization' stamp: 'SW 3/16/2011 14:40'!
initialize 
	
	super initialize.
	self addTabs.
! !

OCWidget subclass: #OCTabHost
	instanceVariableNames: 'tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCTabHost class methodsFor: 'configuration' stamp: 'SW 2/21/2011 11:15'!
defaultCssId

	 ^ 'tabs'! !

!OCTabHost methodsFor: 'accessing' stamp: 'hk 4/5/2011 16:44'!
add: aWidget named: aString
	
	self ensureIdOf: aWidget.
	self tabs add: (S2JTab newFor: aWidget named: aString).
	self add: aWidget.! !

!OCTabHost methodsFor: 'accessing' stamp: 'hk 4/5/2011 16:51'!
ensureIdOf: aWidget

	aWidget cssId ifEmpty:
		[ | number |
		number := self children size.
		aWidget cssId: self class defaultCssId, '-', number asString. ]! !

!OCTabHost methodsFor: 'initialization' stamp: 'SW 2/21/2011 14:01'!
initialize 

	super initialize.
	self tabs: S2JUnorderedList new.
	self add: self tabs.
	self cssId: self class defaultCssId.
! !

!OCTabHost methodsFor: 'initialization' stamp: 'ag 4/6/2011 13:09'!
initializeTabs

	Js Global setTimeout
		value: [ (Js @ ('#', self class defaultCssId)) tabs value ] "Cannot give the tabs function directly, must encapsulate into extra anonymous block."
		value: 500.! !

!OCTabHost methodsFor: 'initialization' stamp: 'hk 3/6/2011 22:12'!
onLoad

	self initializeTabs.
	super onLoad.! !

!OCTabHost methodsFor: 'accessing' stamp: 'SW 2/21/2011 11:07'!
tabs
	^ tabs! !

!OCTabHost methodsFor: 'accessing' stamp: 'SW 2/21/2011 11:07'!
tabs: anObject
	tabs := anObject! !

OCWidget subclass: #OCTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCTable class methodsFor: 'configuration' stamp: 'SW 2/8/2011 10:37'!
htmlElementType
	
	^ 'table'! !

!OCTable methodsFor: 'accessing' stamp: 'SW 2/8/2011 10:46'!
addRowWith: aString
	self add: (S2JTableRow new put: aString).
! !

!OCTable methodsFor: 'accessing' stamp: 'SW 2/8/2011 10:50'!
addRowWith: aString with: anotherString

	| row |
	row:=(S2JTableRow new) 
			put: aString;
			put: anotherString.			
		
	self add: row.
! !

OCWidget subclass: #OCTableRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCTableRow class methodsFor: 'configuration' stamp: 'SW 2/8/2011 10:40'!
htmlElementType
	
	^ 'tr'! !

!OCTableRow methodsFor: 'rendering' stamp: 'SW 2/8/2011 10:48'!
put: aString
	
	self add: (S2JTableCell new text: aString)! !

OCWidget subclass: #OCText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OCText subclass: #OCAnchor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCAnchor class methodsFor: 'configuration' stamp: 'SW 2/21/2011 11:41'!
htmlElementType 
	
	^ 'a'! !

!OCAnchor class methodsFor: 'instance creation' stamp: 'hk 3/8/2011 09:57'!
named: aName

	^ self new
		text: aName;
		target: '#';
		yourself 
! !

!OCAnchor class methodsFor: 'instance creation' stamp: 'SW 2/21/2011 14:16'!
referencing: aTarget named: aName

	^ self new
		text: aName;
		target: aTarget;
		yourself 
! !

!OCAnchor methodsFor: 'accessing' stamp: 'ag 4/5/2011 17:51'!
target: aTarget

	aTarget isString 
		ifTrue: [ self node href: aTarget ]
		ifFalse: [ self node href: '#', aTarget cssId ].! !

OCText subclass: #OCHeading
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCHeading class methodsFor: 'configuration' stamp: 'hk 3/8/2011 09:53'!
htmlElementType

	^ 'h3'! !

OCText subclass: #OCLabel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCLabel class methodsFor: 'instance creation' stamp: 'hk 3/6/2011 22:26'!
for: aRadioButton

	^ self new
		text: aRadioButton caption;
		htmlFor: aRadioButton! !

!OCLabel class methodsFor: 'configuration' stamp: 'hk 2/1/2011 14:31'!
htmlElementType

	^ 'label'! !

!OCLabel methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:40'!
htmlFor: aRadioButton

	self node htmlFor: aRadioButton cssId.! !

OCText subclass: #OCListOption
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCListOption class methodsFor: 'configuration' stamp: 'LT 1/18/2011 22:11:51.562'!
htmlElementType
	^'option'! !

!OCListOption methodsFor: 'initialization' stamp: 'sw 3/29/2011 15:41'!
initialize

"	self node: (Option jsNew : { ''. ''. false. false })."
	super initialize ! !

!OCListOption methodsFor: 'rendering' stamp: 'sw 3/29/2011 15:25'!
text: aString
	
	self node innerHTML: aString.
	self node value: aString.
	^self! !

OCText subclass: #OCParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCParagraph class methodsFor: 'configuration' stamp: 'hk 2/1/2011 15:41'!
htmlElementType
	
	^ 'p'! !

OCText subclass: #OCTableCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCTableCell class methodsFor: 'configuration' stamp: 'SW 2/8/2011 10:40'!
htmlElementType
	
	^ 'td'! !

!OCText methodsFor: 'rendering' stamp: 'hk 2/28/2011 15:40'!
clear

	super clear.
	self text: ''! !

!OCText methodsFor: 'initialization' stamp: 'hk 4/4/2011 10:25'!
initialize
	
	super initialize.
	self text: ''.! !

!OCText methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:39'!
text

	^ self node value! !

!OCText methodsFor: 'accessing' stamp: 'hk 4/4/2011 15:13'!
text: aString
	
	self node innerHTML: aString.
	self node value: aString.! !

OCText subclass: #OCTextArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

OCTextArea subclass: #OCTabbyTextArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCTabbyTextArea class methodsFor: 'configuration' stamp: 'hk 4/4/2011 16:44'!
scriptSource

	^ 'http://teddevito.com/demos/js/jquery.textarea.js'! !

!OCTabbyTextArea methodsFor: 'initialization' stamp: 'hk 4/4/2011 16:45'!
initialize

	| script |
	super initialize.
	script := Js Document createElement value: 'script'.
	script
		src: self class scriptSource;
		type: 'text/javascript'.
	self node appendChild value: script.! !

!OCTabbyTextArea methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
onLoad
	
	self withDisposableId: [ (Js @ ('#', self cssId)) tabby value ].! !

!OCTextArea class methodsFor: 'configuration' stamp: 'robi 1/17/2011 19:41'!
htmlElementType
	
	^ 'textarea'! !

!OCTextArea class methodsFor: 'instance creation' stamp: 'hk 1/26/2011 11:26'!
with: aString

	^ self new text: aString; yourself! !

!OCTextArea methodsFor: 'rendering' stamp: 'hk 4/4/2011 15:12'!
beReadOnly

	self node setAttribute value: 'readonly' value: 'readonly'.! !

OCWidget subclass: #OCUnorderedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCUnorderedList class methodsFor: 'configuration' stamp: 'SW 2/21/2011 11:32'!
htmlElementType 

	^ 'ul'! !

!OCWidget class methodsFor: 'configuration' stamp: 'SW 2/7/2011 14:46'!
htmlElementType
	
	^ 'div'! !

!OCWidget class methodsFor: 'configuration' stamp: 'robi 1/26/2011 12:00'!
start
	" this method will only be invoked in case you use your widget as a start app"
	^ self new addToWorld! !

!OCWidget methodsFor: 'rendering' stamp: 'hk 3/30/2011 11:30'!
add: anObject

	self children add: anObject.
	self node appendChild value: anObject node.
	^ anObject! !

!OCWidget methodsFor: 'rendering' stamp: 'sec 1/25/2011 15:18'!
addAll: aCollection

	aCollection do: [ :each | self add: each ].! !

!OCWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 17:11'!
addToWorld
	"Add this widget to a root-div-element."
		
	(Js Document getElementById value: 'container')
		appendChild value: self node.
	self onLoad.! !

!OCWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:33'!
beRelative

	self node style position: 'relative'.
	self node style top: '0'.
	self node style left: '0'! !

!OCWidget methodsFor: 'accessing' stamp: 'LT 1/18/2011 21:53:58.821'!
children
	^ children! !

!OCWidget methodsFor: 'accessing' stamp: 'LT 1/18/2011 21:53:58.832'!
children: anObject
	children := anObject! !

!OCWidget methodsFor: 'rendering' stamp: 'sw 3/31/2011 14:51'!
clear
	
	self children do: [ :each | self node removeChild value:  (each node ) ].
	self children removeAll.! !

!OCWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:14'!
cssClass: aString

	self node className: aString! !

!OCWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 13:51'!
cssId

	^ self node id
	! !

!OCWidget methodsFor: 'rendering' stamp: 'sw 3/30/2011 13:07'!
cssId: aString

	self node id: aString! !

!OCWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:29'!
extent
	
	^ Point x: (self node width) y: (self node height)! !

!OCWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:32'!
extent: anObject
	
	extent := anObject.
	self node style height: anObject y asString , 'px'. 
	self node style width: anObject x asString , 'px'! !

!OCWidget methodsFor: 'convenience' stamp: 'hk 4/5/2011 12:52'!
generateCssId

	self clientSideResposibility.! !

!OCWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:36'!
height: aHeight
	
	self node style height: aHeight.! !

!OCWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:23'!
hide 

	self node style display: 'none'! !

!OCWidget methodsFor: 'initialization' stamp: 'sw 3/29/2011 14:11'!
initialize
	
	self
		node: (Js Document createElement value: self class htmlElementType);
		children: OrderedCollection new.! !

!OCWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:37'!
marginBottom: aHeight
	
	self node style marginBottom: aHeight asString, 'px'! !

!OCWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:37'!
marginTop: aHeight
	
	self node style marginTop: aHeight asString, 'px'! !

!OCWidget methodsFor: 'accessing' stamp: 'lw 1/13/2011 10:35'!
node
	^ node! !

!OCWidget methodsFor: 'accessing' stamp: 'ag 1/18/2011 09:45'!
node: anObject
	"Must not be set after initialization"
	
	node := anObject! !

!OCWidget methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:21'!
onLoad

	self children ifNil: [ ^ self ].
	self children do: [ :each | each onLoad ].! !

!OCWidget methodsFor: 'accessing' stamp: 'hk 2/1/2011 11:31'!
pathFor: aFile

	^ self app uniquePath, '/', aFile! !

!OCWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:38'!
position: anObject
	
	self node style position: 'absolute'.
	self node style top: anObject y asString, 'px'.
	self node style left: anObject x asString , 'px'.! !

!OCWidget methodsFor: 'accessing' stamp: 'sw 3/29/2011 14:38'!
show 

	self node style display: 'block'.! !

!OCWidget methodsFor: 'rendering' stamp: 'sw 3/29/2011 14:38'!
width: aWidth
	
	self node style width: aWidth.! !

!OCWidget methodsFor: 'convenience' stamp: 'hk 4/5/2011 10:53'!
withDisposableId: aBlock

	| oldId |
	oldId := self cssId.
	self cssId: self generateCssId.
	aBlock value.
	self cssId: oldId.! !

OCWidget subclass: #OCWindow
	instanceVariableNames: 'title content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Widgets'!

!OCWindow class methodsFor: 'configuration' stamp: 'hk 3/7/2011 15:30'!
defaultCssClasses

	^ 'ui-dialog ui-widget ui-widget-content ui-corner-all ui-draggable'! !

!OCWindow class methodsFor: 'configuration' stamp: 'hk 3/4/2011 12:55'!
defaultCssId

	^ 'window'! !

!OCWindow class methodsFor: 'configuration' stamp: 'hk 3/4/2011 13:16'!
defaultEffect

	^ 'blind'! !

!OCWindow class methodsFor: 'instance creation' stamp: 'hk 3/4/2011 11:57'!
newTitled: aString

	^ self basicNew title: aString; initialize! !

!OCWindow methodsFor: 'rendering' stamp: 'hk 3/8/2011 11:12'!
add: aWidget

	self content add: aWidget.! !

!OCWindow methodsFor: 'accessing' stamp: 'hk 3/4/2011 13:19'!
content
	^ content! !

!OCWindow methodsFor: 'accessing' stamp: 'hk 3/4/2011 13:19'!
content: anObject
	content := anObject! !

!OCWindow methodsFor: 'initialization' stamp: 'sw 4/6/2011 08:45'!
initialize

	super initialize.
	self
		cssClass: self class defaultCssClasses;
		cssId: self class defaultCssId;
		width: 'auto'.
	self
		initializeContentArea;
		initializeTitleBar.
! !

!OCWindow methodsFor: 'initialization' stamp: 'hk 3/8/2011 11:19'!
initializeContentArea

	self content: (S2JText new cssClass: 'ui-widget-content'; yourself).
	super add: self content.! !

!OCWindow methodsFor: 'initialization' stamp: 'hk 3/4/2011 12:58'!
initializeTitleBar

	| titleBar |
	titleBar := S2JText new
		text: self title;
		cssClass: 'ui-dialog-titlebar ui-widget-header ui-corner-all ui-helper-clearfix'.
	titleBar add: ((S2JButton doing: [ self toggle ] withText: 'toggle') cssClass: 'ui-icon ui-icon-triangle-2-n-s').
	self add: titleBar! !

!OCWindow methodsFor: 'initialization' stamp: 'ag 4/5/2011 17:51'!
makeDraggable

	(Js @ ('#',  self class defaultCssId)) draggable value! !

!OCWindow methodsFor: 'initialization' stamp: 'hk 4/5/2011 13:23'!
onLoad

	self makeDraggable.
	self content onLoad.! !

!OCWindow methodsFor: 'accessing' stamp: 'hk 3/4/2011 11:49'!
title
	^ title! !

!OCWindow methodsFor: 'accessing' stamp: 'hk 3/4/2011 11:49'!
title: anObject
	title := anObject! !

!OCWindow methodsFor: 'animation' stamp: 'ag 4/5/2011 17:39'!
toggle
	
	(Js @ '#window .ui-widget-content') toggle
		value: self class defaultEffect
		value: {} asObject
		value: 500.! !

OCWidget subclass: #OCWorkspace
	instanceVariableNames: 'smalltalkCodeBox javascriptCodeBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-Workspace'!

OCWorkspace subclass: #OCCodeBox
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OCCodeBox class methodsFor: 'instance creation' stamp: 'LT 1/26/2011 17:04:37.953'!
newOn: aBrowser

	^self basicNew
		browser: aBrowser;
		initialize;
		yourself.! !

!OCCodeBox methodsFor: 'accessing' stamp: 'LT 1/26/2011 17:04:49.802'!
browser
	^ browser! !

!OCCodeBox methodsFor: 'accessing' stamp: 'LT 1/26/2011 17:04:49.812'!
browser: anObject
	browser := anObject! !

!OCCodeBox methodsFor: 'initialization' stamp: 'lw 3/2/2011 16:21'!
createButtonsForInput: aNode

	^ S2JContainer horizontal! !

!OCCodeBox methodsFor: 'rendering' stamp: 'LT 2/23/2011 13:55:43.357'!
displayClassDefinition

	| definition className |
	self browser saveButton enable.
	className := self browser classList selectedClassName.
	className isEmpty
		ifFalse: 
			[definition := [ :cls | (Smalltalk classNamed: cls) definition ] onServer value: className.
			self text: definition]! !

!OCCodeBox methodsFor: 'initialization' stamp: 'hk 1/26/2011 17:02'!
initialize 

	super initialize.
	self
		extent: 800 @ 300;
		yourself.! !

!OCCodeBox methodsFor: 'rendering' stamp: 'sec 2/22/2011 17:40'!
translate: aSmalltalkSnippet

	^
	[ :smalltalkCode | | assoc |
		[ assoc := S2JPrettyPrinter convertMethod: smalltalkCode. assoc key, ' = ', assoc value ] on: Error do: [ '' ]
		] onServer value: aSmalltalkSnippet.! !

!OCCodeBox methodsFor: 'rendering' stamp: 'LT 3/1/2011 16:17:26.873'!
updateFor: aMethodname of: aClassname

	self browser spinner show.
	self clear.
	self browser saveButton enable.
	self text: (
		[ :methodName :classname |
		((Smalltalk classNamed: classname) methodDict at: methodName asSymbol) getSource asString ]
			onServer
				value: aMethodname
				value: aClassname).
	self browser spinner hide.! !

!OCWorkspace class methodsFor: 'configuration' stamp: 'hk 4/4/2011 14:40'!
emptyBoxString

	^ 'nothing yet'! !

!OCWorkspace class methodsFor: 'configuration' stamp: 'robi 1/26/2011 13:12'!
htmlElementType
	
	^ 'div'! !

!OCWorkspace methodsFor: 'initialization' stamp: 'hk 4/4/2011 10:26'!
addElements

	self add: 
		(S2JContainer vertical
			add: (S2JContainer horizontal
				add: self smalltalkCodeBox;
				add: self javascriptCodeBox);
			add: (self createButtonsForInput: self smalltalkCodeBox);
			yourself).! !

!OCWorkspace methodsFor: 'initialization' stamp: 'hk 4/5/2011 14:54'!
bindInput: anInputTextWidget toOutput: anOutputTextWidget
	
	anInputTextWidget node onkeyup: [ :event | | shouldUpdate |
		shouldUpdate := #(32 13 9 46 190) includes: event keyCode.
		shouldUpdate ifTrue:
			[ self
				updateOutput: anOutputTextWidget
				fromInput: anInputTextWidget ]].! !

!OCWorkspace methodsFor: 'initialization' stamp: 'sec 2/28/2011 17:31'!
clear

	self smalltalkCodeBox clear.! !

!OCWorkspace methodsFor: 'initialization' stamp: 'hk 4/4/2011 10:49'!
createButtonsForInput: anInputWidget
	
	^ S2JContainer horizontal addAll: {
		S2JButton doing: [ self printContentOf: anInputWidget ] withText: 'Print'.
		S2JButton doing: [ self doIt: anInputWidget text ] withText: 'Do it' }! !

!OCWorkspace methodsFor: 'initialization' stamp: 'hk 4/4/2011 16:51'!
createJsCodeBox

	^ S2JTextArea new
		extent: 600 @ 400;
		beReadOnly;
		yourself.! !

!OCWorkspace methodsFor: 'initialization' stamp: 'hk 4/4/2011 16:51'!
createStCodeBox

	^ S2JTabbyTextArea new
		extent: 600 @ 400;
		yourself.! !

!OCWorkspace methodsFor: 'logic' stamp: 'hk 3/31/2011 14:29'!
doIt: aSmalltalkSnippet

	^ Js Global eval value: (self translate: aSmalltalkSnippet).! !

!OCWorkspace methodsFor: 'accessing' stamp: 'hk 3/31/2011 14:30'!
extent

	^ self smalltalkCodeBox extent + self javascriptCodeBox extent! !

!OCWorkspace methodsFor: 'accessing' stamp: 'hk 4/4/2011 10:26'!
extent: newExtent

	self smalltalkCodeBox extent: (newExtent x * 0.5 @ newExtent y).
	self javascriptCodeBox extent: (newExtent x * 0.5 @ newExtent y).! !

!OCWorkspace methodsFor: 'initialization' stamp: 'hk 4/4/2011 16:50'!
initialize

	super initialize.
	self smalltalkCodeBox: self createStCodeBox.
	self javascriptCodeBox: self createJsCodeBox.
	self
		addElements;
		bindInput: self smalltalkCodeBox
		toOutput: self javascriptCodeBox.! !

!OCWorkspace methodsFor: 'accessing' stamp: 'sec 2/22/2011 12:28'!
javascriptCodeBox
	^ javascriptCodeBox! !

!OCWorkspace methodsFor: 'accessing' stamp: 'sec 2/22/2011 12:28'!
javascriptCodeBox: anObject
	javascriptCodeBox := anObject! !

!OCWorkspace methodsFor: 'logic' stamp: 'hk 4/4/2011 10:52'!
printContentOf: anInputWidget

	| stCode |
	stCode := anInputWidget text..
	anInputWidget text: stCode, ' ', (self translate: stCode).! !

!OCWorkspace methodsFor: 'accessing' stamp: 'sec 2/22/2011 12:25'!
smalltalkCodeBox
	^ smalltalkCodeBox! !

!OCWorkspace methodsFor: 'accessing' stamp: 'sec 2/22/2011 12:25'!
smalltalkCodeBox: anObject
	smalltalkCodeBox := anObject! !

!OCWorkspace methodsFor: 'initialization' stamp: 'hk 3/31/2011 14:31'!
text

	^ self smalltalkCodeBox text! !

!OCWorkspace methodsFor: 'initialization' stamp: 'sec 2/22/2011 12:36'!
text: aString

	self smalltalkCodeBox text: aString.
	self updateOutput: self javascriptCodeBox fromInput: self smalltalkCodeBox.! !

!OCWorkspace methodsFor: 'initialization' stamp: 'LT 3/1/2011 16:26:10.452'!
translate: aSmalltalkSnippet

	^
	[ :smalltalkCode |
		[ S2JPrettyCodeFactory codeFor: smalltalkCode ] on: Error do: [ '' ]
		] onServer value: aSmalltalkSnippet.! !

!OCWorkspace methodsFor: 'initialization' stamp: 'hk 4/4/2011 14:40'!
updateOutput: aJavascriptCodeBox fromInput: aSmalltalkCodeBox

	| jsCode stCode |
	stCode := aSmalltalkCodeBox text.
	jsCode := aJavascriptCodeBox text
		ifEmpty: self class emptyBoxString.
	jsCode := (self translate: stCode)
		ifEmpty: self class emptyBoxString.
	aJavascriptCodeBox text: jsCode.! !

!Object methodsFor: '*Orca' stamp: 'hk 4/5/2011 12:51'!
clientSideResposibility

	self error: thisContext sender selector printString, ' is only implemented on client side' ! !

!String methodsFor: '*Orca' stamp: 'ag 3/1/2011 16:23'!
definitionLine
	
	^ S2JSqueakAstToJsAst stringFunction asString, '(', (S2JAbstractPrinter asJSString: self), ')'! !

!String methodsFor: '*Orca' stamp: 'sw 3/30/2011 14:24'!
jsEval

	^ Js Global eval value: self! !

!HTTPConnection methodsFor: '*Orca' stamp: 'LT 1/26/2011 14:39:01.244'!
interact
	"We refine this to bring up the debugger when an error occurs inside the Swazoo."



	"longer description is below method"
	| interactionBlock |
	interactionBlock := 
		[[	[ [true] whileTrue: 
				[self getAndDispatchMessages.
				Processor yield] 
			]
			on: Error
			do: [:ex | 
				
				((Smalltalk at: #S2JDebugSwazooInternalErrors ifAbsent: [nil]) == true)
					ifTrue: [ (ex class = SwazooStreamNoDataError) | (ex class = SpSocketError) ifFalse: [ self halt ] ]
				] ]
		ifCurtailed: [ 
			(Delay forMilliseconds: 50) wait. "to finish sending, if any"
			self isOpen ifTrue: [self close]] ].
	self server isMultiThreading 
		ifTrue: [self loop: (interactionBlock forkAt: Processor userBackgroundPriority)]
		ifFalse: [interactionBlock value].
	^self

"I represent a specifc connection with an HTTP client (a browser, probably) over which will come an HTTP request.  Here, I fork the handling of the request so that the current thread (which is most likely the HTTP server main loop) can carry on with the next request.  This means that more than one request may being handled in the image at a time, and that means that the application developer must worry about thread safety - e.g the problem of a given business object being updated by more than one HTTP request thread.
For a GemStone implementation of Swazoo, one may want only one request is handled at a time, multi-threadedness being handled by having multiple gems.  This is a nice option because the application developer does not have to worry about thread safety in this case - GemStone handles the hard stuff.
*And* the thing called a loop that was in this method was no such thing.  In all circumstances, >>getAndDispatchMessages handles exactly one requst and then closes the socket!! (very non-HTTP1.1).  Anyway, for now I'm just going to make that explicit.  This needs to be re-visited to support HTTP 1.1."! !

!Array methodsFor: '*Orca' stamp: 'sw 3/31/2011 11:05'!
asObject 
	
	^ S2JSlotObject newFrom: self! !

!Array methodsFor: '*Orca' stamp: 'ag 3/31/2011 10:27'!
fillInstVars: codeLines guardedBy: alreadySerialized
	"The super-call should have no effect, as there are no instance-variables here. Let content serialize themselves, then collect their
	variable names and set the primitive js-array (original$)."
	
	super fillInstVars: codeLines guardedBy: alreadySerialized.
	self do: [ :each | each serializeToJavaScript: codeLines guardedBy: alreadySerialized ].
	codeLines addLast: 
		(alreadySerialized at: self), '.original$=[', 
		((self collect: [ :each | alreadySerialized at: each ]) separatedBy: ', '),
		']'.! !

!UndefinedObject methodsFor: '*Orca' stamp: 'ag 3/1/2011 16:25'!
definitionLine
	
	^ (S2JSqueakAstToJsAst jsKeywordFor: self asString) key! !

Compiler subclass: #OCCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OCCompiler methodsFor: 'public access' stamp: 'robi 3/16/2011 16:42'!
compile: origCode in: cls classified: aCategory notifying: notify ifFail: failBlock
	| code |
	
	(origCode includesSubString:  '<language: #JavaScript>')
		ifTrue: [ code := self stubCodeFor: origCode ]
		ifFalse: [ code := origCode ].

	 ^ super compile: code 
				in: cls 
				classified: aCategory 
				notifying: notify 
				ifFail: failBlock! !

!OCCompiler methodsFor: 'code generation' stamp: 'robi 3/16/2011 16:41'!
stubCodeFor: aMethodString

	^ ((aMethodString lineNumber: 1), 
		Character lf, 
		'self error: ''JavaScript code cannot be executed in Squeak environment.''')! !

!Number methodsFor: '*Orca' stamp: 'ag 3/1/2011 16:16'!
definitionLine
	
	^ S2JSqueakAstToJsAst numberFunction asString, '(', self asString, ')'! !

!Number methodsFor: '*Orca' stamp: 'sec 2/16/2011 17:24'!
 aNumber
	{true. false}  atRandom
		ifTrue: [ ^ self + aNumber ]
		ifFalse: [ ^ self - aNumber ]! !

!Utilities class methodsFor: '*Orca' stamp: 'ag 4/6/2011 13:33'!
changeClassPrefixFrom: oldPrefix to: newPrefix
	
	PackageOrganizer default packages do: [ :pk | | classes |
		pk classes do: [ :cl | | n |
			n := cl name.
			(n beginsWith: oldPrefix) ifTrue: [
				cl rename: newPrefix, (n copyFrom: (oldPrefix size + 1) to: n size) ] ]].! !

!Utilities class methodsFor: '*Orca' stamp: 'ag 2/3/2011 12:05'!
classesWithDirtyCategories
	
	^ self ourClasses select: [ :class |
		(class name endsWith: 'Test') not & (class name endsWith: 'Tests') not &
		(class organization categories includes: 'as yet unclassified' asSymbol) ]! !

!Utilities class methodsFor: '*Orca' stamp: 'ag 2/3/2011 12:02'!
classesWithEmptyCategories
	
	^ (self ourClasses select: [ :class |
			class organization categories anySatisfy: [ :category | class organization isEmptyCategoryNamed: category ] ]),
		self ourEmptyClassCategories! !

!Utilities class methodsFor: '*Orca' stamp: 'ag 2/3/2011 12:02'!
countCategoriesOf: aClass
	
	^ (aClass organization categories
		reject: [ :cat | cat == 'no messages' asSymbol ])
			size! !

!Utilities class methodsFor: '*Orca' stamp: 'ag 2/3/2011 12:02'!
debugSwazooErrors: aBoolean
	
	^ Smalltalk
		at: #S2JDebugSwazooInternalErrors
		put: aBoolean! !

!Utilities class methodsFor: '*Orca' stamp: 'ag 3/28/2011 18:01'!
grep: aString
	"Search the source-code of our packages and return a collection of all CompiledMethods, that contain aString in their source-code."
	
	| methods |
	methods := OrderedCollection new.
	self ourClasses do: [ :class |
		class methodDict values do: [ :compiledMethod |
			(compiledMethod value getSource asString includesSubString: aString)
					ifTrue: [ methods add: compiledMethod ]]].
	^ methods! !

!Utilities class methodsFor: '*Orca' stamp: 'ag 2/3/2011 12:03'!
ourClasses
	
	^ self ourPackage classesAndMetaClasses! !

!Utilities class methodsFor: '*Orca' stamp: 'ag 2/3/2011 12:03'!
ourEmptyClassCategories
	
	^ self ourPackage systemCategories select: [ :cat |
		SystemOrganization isEmptyCategoryNamed: cat]! !

!Utilities class methodsFor: '*Orca' stamp: 'ag 2/3/2011 12:03'!
ourPackage
	
	^ PackageOrganizer default
		packageNamed: 'Squeak2JS' asSymbol
		ifAbsent: [ self error: 'Our package Squeak2JS could not be found...' ]! !

!Utilities class methodsFor: '*Orca' stamp: 'ag 2/3/2011 12:03'!
removeEmptyCategories
	"Removes method-categories and class-categories. Return, how many categories have been removed."
	
	| removedCategories |
	removedCategories := 0.
	self ourClasses do: [ :class | | categoriesBefore |
		categoriesBefore := self countCategoriesOf: class.
		class organization removeEmptyCategories.
		removedCategories := removedCategories + categoriesBefore - (self countCategoriesOf: class) ].
	self ourEmptyClassCategories do: [ :cat |
		SystemOrganization removeCategory: cat.
		removedCategories := removedCategories + 1].
	^ removedCategories! !

!Utilities class methodsFor: '*Orca' stamp: 'ag 4/6/2011 13:32'!
renamePackagesNamed: oldName to: newName
	
	PackageOrganizer default packages do: [ :pk | | classes |
		pk classesAndMetaClasses do: [ :cl |
			cl organization categories do: [ :cat |
				(cat = oldName asSymbol)
					ifTrue: [ cl organization
						renameCategory: oldName
						toBe: newName ] ] ]].! !

!Boolean methodsFor: '*Orca' stamp: 'ag 3/1/2011 16:25'!
definitionLine
	
	^ (S2JSqueakAstToJsAst jsKeywordFor: self asString) key! !

!BlockClosure methodsFor: '*Orca' stamp: 'ag 1/19/2011 18:34'!
onServer
	"This is overridden when executing on the client. On the server, there is no change."
	
	^ self! !

SwazooResource subclass: #OCResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

OCResource subclass: #OCBasicApp
	instanceVariableNames: 'clients repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

OCBasicApp class
	instanceVariableNames: 'instance'!

OCBasicApp class
	instanceVariableNames: 'instance'!

OCBasicApp subclass: #OCApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OCApp class methodsFor: 'rendering-helpers' stamp: 'ag 1/25/2011 15:49'!
allRequiredClasses
	"Return the requiredClasses together with all their superclasses. Only for this class, not the superclasses."
	
	| allClasses |
	allClasses := OrderedCollection new.
	self requiredClasses do: [ :eachClass |
		eachClass allSuperclasses reverseDo: [ :superClass |
			(allClasses includes: superClass) ifFalse: [ allClasses add: superClass ]].
		(allClasses includes: eachClass) ifFalse: [ allClasses add: eachClass ]].
	^ allClasses! !

!OCApp class methodsFor: 'rendering-configuration' stamp: 'srv 1/24/2011 14:05'!
codeFactory
	
	^ S2JPrettyCodeFactory.! !

!OCApp class methodsFor: 'rendering-helpers' stamp: 'SW 1/31/2011 08:35'!
codeForAllClasses

	^ self codeFactory codeForClasses: self collectRequiredClasses! !

!OCApp class methodsFor: 'rendering-helpers' stamp: 'ag 1/24/2011 17:00'!
collectPostloadScripts
	"Collect #requiredClasses from all superclasses"
	
	^ self
		collect: [ :eachClass | eachClass postloadScripts ]
		upTo: S2JApp! !

!OCApp class methodsFor: 'rendering-helpers' stamp: 'ag 1/24/2011 17:01'!
collectRequiredClasses
	"Collect #requiredClasses from all superclasses"
	
	^ self
		collect: [ :eachClass | eachClass allRequiredClasses ]
		upTo: S2JApp! !

!OCApp class methodsFor: 'rendering-javascript' stamp: 'lw 4/4/2011 16:55'!
postloadScripts
	
	^ #( 'boxing.js' 'bootstrap.js' 'doesNotUnderstand.js' 'kernel_primitives.js' )! !

!OCApp class methodsFor: 'rendering-helpers' stamp: 'srv 1/24/2011 14:04'!
recompileRequiredClasses
	"This causes all required classes of THIS web-app (none of the super-classes) to be invalidated in the code-factory-cache."
	
	^ self allRequiredClasses do: [ :each | each compileAll ]! !

!OCApp class methodsFor: 'rendering-javascript' stamp: 'ag 4/5/2011 17:24'!
requiredClasses
	"Return any array of classes, that must be compiled to JS-code to enable this application.
	Classes added by subclasses must also return the classes in this implementation, as these clases are required by the js-bootstrapping-library."
	
	^ { Js. BlockClosure. Float. True. False. Error. ByteString. OrderedCollection. Character. Array. UndefinedObject. Point. WriteStream . Message  }! !

!OCApp class methodsFor: 'rendering-javascript' stamp: 'srv 1/24/2011 14:14'!
scripts
	"= preload scripts"
	
	^ #( 'squeaky.js' )! !

!OCApp class methodsFor: 'rendering-javascript' stamp: 'ag 1/24/2011 16:35'!
startupClass
	"Return something other than nil to call the static method #start on the class returned here."
	
	^ nil! !

!OCApp class methodsFor: 'rendering-css' stamp: 'SW 2/21/2011 15:13'!
styles
	
	^ #( 'styles/default.css' )! !

!OCApp class methodsFor: 'rendering-helpers' stamp: 'srv 1/24/2011 14:05'!
writeClassesTo: aDirectoryName
	"Write all classes required by this WebApp (together with their superclasses) to files named '<classname>.txt' in the given directory."
	
	self codeForAllClasses.
	self collectRequiredClasses withIndexDo: [ :cl :index |
		self codeFactory
			printCodeFor: cl
			to: aDirectoryName, index asString, '-', cl name, '.txt' ].! !

!OCApp class methodsFor: 'rendering-helpers' stamp: 'srv 1/24/2011 14:05'!
writeClassesToFile: aFileName
	"Write all classes required by this WebApp (together with their superclasses) to files named '<classname>.txt' in the given directory."
	
	^ self codeFactory
		printCodeFor: self collectRequiredClasses
		to: aFileName! !

!OCApp class methodsFor: 'rendering-helpers' stamp: 'srv 1/24/2011 14:06'!
writeSiteTo: aLocalFilename
	"Write the website, that would be sent to a client, to a new file named aLocalFilename (overwrites existing)."
	
	^ self codeFactory converterClass
		print: self new render
		to: aLocalFilename! !

!OCApp methodsFor: 'hooks' stamp: 'ag 1/24/2011 20:43'!
onloadCode
	
	^ super onloadCode, 'app=startupS2J();'! !

!OCApp methodsFor: 'rendering' stamp: 'hk 2/1/2011 11:58'!
renderJavascript
	"Render the external javascript resources and the link to the compiled classes code."
	
	^
	super renderJavascript,
	(self renderScriptTag: S2JClassesHandler pathSuffix),
	(self renderScriptTags: self class collectPostloadScripts),
	self renderStartupCall, String cr! !

!OCApp methodsFor: 'rendering' stamp: 'ag 1/24/2011 20:43'!
renderStartupCall
	
	^ 
	'<script type="text/javascript">',
	'var startupS2J = function() {', (self class startupClass
		ifNotNil: [ 'return ', (self class codeFactory codeFor: (self class startupClass name, ' start')) ]
		ifNil: [ '' ]),
			'}',
	'</script>'! !

OCApp subclass: #OCBallGameApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-BallGame'!

!OCBallGameApp class methodsFor: 'rendering-javascript' stamp: 'ag 3/29/2011 13:41'!
postloadScripts
	
	^ #( 'misc/canvastoolkit.js' )! !

!OCBallGameApp class methodsFor: 'rendering-javascript' stamp: 'lw 1/13/2011 11:34'!
requiredClasses
	
	^ { Rectangle. S2JBall. S2JBallGame }! !

!OCBallGameApp class methodsFor: 'rendering-javascript' stamp: 'ag 1/24/2011 16:36'!
startupClass
	
	^ S2JBallGame! !

!OCBallGameApp class methodsFor: 'configuration' stamp: 'lw 1/12/2011 18:39'!
title

	^ 'Bouncing Balls'! !

!OCBallGameApp class methodsFor: 'configuration' stamp: 'hk 2/1/2011 11:48'!
uniquePath 
	
	^ 'balls/'! !

!OCBallGameApp methodsFor: 'rendering' stamp: 'LT 1/19/2011 15:22:01.602'!
renderContent
	
	^ '<canvas id="ballCanvas" width="400" height="300" style="background-color: #ffffff;  position: relative; border: solid 1px #000000;"></canvas>'! !

OCApp subclass: #OCIndex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Applications'!

!OCIndex class methodsFor: 'configuration' stamp: 'ag 1/12/2011 18:21'!
title

	^ 'Index'! !

!OCIndex class methodsFor: 'configuration' stamp: 'hk 2/1/2011 11:48'!
uniquePath

	^ 'index/'! !

!OCIndex methodsFor: 'hooks' stamp: 'hk 2/1/2011 11:55'!
linkFor:application
	^ '<a href="/', application uniquePath , '" title="', application title ,'">', application title , '</a>'.
	    
	
	! !

!OCIndex methodsFor: 'hooks' stamp: 'hk 4/5/2011 11:13'!
renderContent
	
	^ '<h1>Orca Framework</h1>
	<h3>Installed applications:</h3>', self renderLinks! !

!OCIndex methodsFor: 'hooks' stamp: 'ag 1/25/2011 11:51'!
renderLinks

	| result |
	result := '<ul>'.
	S2JBasicApp allSubclassesDo: [ :application | 
		(application = self class or: [ application uniquePath isNil]) ifFalse: [
			result := result , '<li>', (self linkFor:application) , '</li>'.		
			].
		].
	result := result , '</ul>'.
	^ result
	    
	
	! !

OCApp subclass: #OCWidgetApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Applications'!

OCWidgetApp subclass: #OCBrowserApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-ClassBrowser'!

!OCBrowserApp class methodsFor: 'configuration' stamp: 'hk 4/5/2011 10:46'!
requiredClasses
	
	^ { S2JClassBrowser . S2JSideSelector . S2JBrowserPane . S2JClassPane . S2JMethodPane . S2JPackagePane . S2JProtocolPane . S2JCodeBox . S2JjQueryButton . S2JSaveButton . S2JLoader. S2JSmartSearch . S2JTabbyTextArea }! !

!OCBrowserApp class methodsFor: 'configuration' stamp: 'hk 4/5/2011 10:45'!
scripts

	^ { 'http://teddevito.com/demos/js/jquery.textarea.js' }! !

!OCBrowserApp class methodsFor: 'configuration' stamp: 'ag 1/24/2011 16:36'!
startupClass
	
	^ S2JClassBrowser! !

!OCBrowserApp class methodsFor: 'configuration' stamp: 'ag 1/17/2011 18:27'!
title
	
	^ 'Class Browser'! !

!OCBrowserApp class methodsFor: 'configuration' stamp: 'hk 2/1/2011 11:49'!
uniquePath
	
	^ 'browser/'! !

OCWidgetApp subclass: #OCSystemStatusApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-System-Status'!

!OCSystemStatusApp class methodsFor: 'rendering-javascript' stamp: 'SW 3/15/2011 16:29'!
requiredClasses
	
	^ S2JWidget allSubclasses asArray
"	^ { S2JControls . S2JConfirmButton . S2JControls . S2JSystemStatus . S2JSystemStatusTabHolder . S2JTabHost . S2JTreeGraph . S2JDialog . S2JChart . S2JAreaChart . S2JBarChart . S2JMonticelloStatistics  . S2JAccordion . S2JHeading}	
	
"! !

!OCSystemStatusApp class methodsFor: 'rendering-javascript' stamp: 'hk 3/22/2011 22:28'!
scripts 
	
	^ { 'http://thejit.org/static/v20/Jit/jit.js' }
! !

!OCSystemStatusApp class methodsFor: 'rendering-javascript' stamp: 'SW 2/8/2011 11:06'!
startupClass
	
	^ S2JSystemStatusTabHolder! !

!OCSystemStatusApp class methodsFor: 'configuration' stamp: 'SW 2/7/2011 14:21'!
title
	
	^ 'System Status'! !

!OCSystemStatusApp class methodsFor: 'configuration' stamp: 'SW 2/7/2011 14:21'!
uniquePath
	
	^ 'systat/'! !

!OCWidgetApp class methodsFor: 'rendering-javascript' stamp: 'hk 3/7/2011 15:29'!
requiredClasses
	
	^ { S2JSelectList. S2JTextArea. Association. S2JListOption . S2JButton. S2JHorizontalContainer. S2JVerticalContainer . S2JImage . S2JLoader . S2JParagraph . S2JTable . S2JTableRow . S2JTableCell . S2JAnchor . S2JListItem . S2JUnorderedList. S2JInput . S2JRadioGroup . S2JRadioButton. S2JLabel . S2JWindow }! !

!OCWidgetApp class methodsFor: 'rendering-css' stamp: 'hk 3/21/2011 16:29'!
scripts

	^ { 'https://ajax.googleapis.com/ajax/libs/jquery/1.5.1/jquery.min.js'. 
	'https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.11/jquery-ui.min.js' }! !

!OCWidgetApp class methodsFor: 'rendering-css' stamp: 'hk 3/4/2011 11:54'!
styles
	
	^ { 'styles/widgets.css' . 'styles/smoothness/jquery-ui-1.8.10.custom.css' }! !

!OCWidgetApp methodsFor: 'rendering' stamp: 'hk 3/4/2011 14:30'!
renderContent 
	
	^ '<div id="container"></div>'! !

OCWidgetApp subclass: #OCWidgetPlayground
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Applications'!

!OCWidgetPlayground class methodsFor: 'rendering-javascript' stamp: 'hk 4/5/2011 14:57'!
requiredClasses
	
	^ S2JWidget allSubclasses! !

!OCWidgetPlayground class methodsFor: 'configuration' stamp: 'hk 3/9/2011 09:07'!
scripts 
	
	^ { 'http://code.jquery.com/jquery-1.5.js'. 
	'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8/jquery-ui.js' . 
	'http://thejit.org/static/v20/Jit/jit.js' }! !

!OCWidgetPlayground class methodsFor: 'rendering-javascript' stamp: 'hk 1/26/2011 11:01'!
startupClass 

	^ S2JContainer! !

!OCWidgetPlayground class methodsFor: 'configuration' stamp: 'hk 1/24/2011 17:20'!
title

	^ 'Let''s play'! !

!OCWidgetPlayground class methodsFor: 'configuration' stamp: 'hk 2/1/2011 11:48'!
uniquePath

	^ 'play/'! !

OCWidgetApp subclass: #OCWorkspaceApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Examples-Workspace'!

!OCWorkspaceApp class methodsFor: 'rendering-javascript' stamp: 'hk 4/4/2011 16:57'!
requiredClasses
	
	^ { S2JWorkspace . LimitedWriteStream . S2JTabbyTextArea }! !

!OCWorkspaceApp class methodsFor: 'configuration' stamp: 'hk 4/5/2011 10:42'!
scripts

	^ { 'http://teddevito.com/demos/js/jquery.textarea.js' }! !

!OCWorkspaceApp class methodsFor: 'rendering-javascript' stamp: 'robi 1/26/2011 11:36'!
startupClass

	^ S2JWorkspace! !

!OCWorkspaceApp class methodsFor: 'configuration' stamp: 'robi 1/26/2011 11:24'!
title
	^ 'Workspace'! !

!OCWorkspaceApp class methodsFor: 'configuration' stamp: 'hk 2/1/2011 12:02'!
uniquePath
	^ 'workspace/'! !

!OCBasicApp class methodsFor: 'rendering-javascript' stamp: 'ag 1/24/2011 17:00'!
collect: aBlock upTo: topSuperClass
	"Evaluate aBlock with all relevant superclasses as single argument and collect the resulting collections."
	
	| class result superClasses |
	result := OrderedCollection new.
	superClasses := topSuperClass allSuperclasses.
	class := self.
	[ superClasses includes: class ]
		whileFalse: [
			result addAllFirst: (aBlock value: class).
			class := class superclass ].
	^ result
		inject: OrderedCollection new
		into: [ :all :cl | (all includes: cl) ifFalse: [ all add: cl ]. all ]! !

!OCBasicApp class methodsFor: 'rendering-javascript' stamp: 'ag 1/26/2011 14:52'!
collectScripts
	"Collect #scripts from all superclasses"
	
	^ self
		collect: [ :eachClass | eachClass scripts ]
		upTo: S2JBasicApp! !

!OCBasicApp class methodsFor: 'rendering-css' stamp: 'SW 2/21/2011 15:12'!
collectStyles
	"Collect #styles from all superclasses"
	
	^ (self
		collect: [ :eachClass | eachClass styles ]
		upTo: S2JBasicApp)! !

!OCBasicApp class methodsFor: 'configuration' stamp: 'HK 1/10/2011 16:30'!
htmlDocumentType

	^ '<!!DOCTYPE html>'.! !

!OCBasicApp class methodsFor: 'singleton' stamp: 'HK 1/12/2011 10:43'!
instance
	
	instance ifNil: [ instance := self new ].
	^ instance.! !

!OCBasicApp class methodsFor: 'rendering-javascript' stamp: 'ag 1/31/2011 14:06'!
scripts
	
	^ #( 'console.js' 'bidirectional_communication.js' 'server.js' )! !

!OCBasicApp class methodsFor: 'rendering-css' stamp: 'hk 1/26/2011 12:29'!
styles

	^ #()! !

!OCBasicApp class methodsFor: 'configuration' stamp: 'ag 1/24/2011 17:19'!
title
	"Must be implemented by non-abstract subclasses"
	
	^ nil! !

!OCBasicApp class methodsFor: 'configuration' stamp: 'ag 1/24/2011 17:20'!
uniquePath
	"Must be implemented by non-abstract subclasses"
	
	^ nil! !

!OCBasicApp methodsFor: 'dispatching' stamp: 'ag 1/25/2011 13:41'!
addClient: aClient

	self clients add: aClient.
	aClient application: self.! !

!OCBasicApp methodsFor: 'dispatching' stamp: 'ag 1/25/2011 13:41'!
answerNewContentTo: aClient

	aClient increaseRevision.
	^ self
		answerWithStatusCode: 200
		andContent: (self repository contentAtRevision: aClient revision)! !

!OCBasicApp methodsFor: 'rendering' stamp: 'SW 1/18/2011 11:26'!
answerNoContent

	^ self answerWithStatusCode: 204! !

!OCBasicApp methodsFor: 'dispatching' stamp: 'ag 1/25/2011 16:20'!
answerTo: aRequest
	
	| handlerClass |
	handlerClass := S2JClientHandler subclasses
		detect: [ :eachClass | eachClass canHandle: aRequest ]
		ifNone: [ nil ].
	^ handlerClass
		ifNotNil: [ (handlerClass newFor: self) answerTo: aRequest ]
		ifNil: [ self answerContent: self render withType: 'text/html' ]! !

!OCBasicApp methodsFor: 'accessing' stamp: 'hk 3/28/2011 17:12'!
clients
	clients ifNil: [ clients := OrderedCollection new ].
	^ clients! !

!OCBasicApp methodsFor: 'accessing' stamp: 'HK 1/12/2011 10:49'!
clients: anObject
	clients := anObject! !

!OCBasicApp methodsFor: 'rendering' stamp: 'hk 2/1/2011 12:00'!
fullUrlFor: aUrl
	^ (aUrl startsWith: 'http')
		ifTrue: [ aUrl ]
		ifFalse: [ S2JFileRequestHandler pathSuffix , '/' , aUrl ]! !

!OCBasicApp methodsFor: 'initialization' stamp: 'ag 1/13/2011 20:17'!
initialize

	super initialize.
	self
		clients: OrderedCollection new;
		repository: S2JContentRepository new.! !

!OCBasicApp methodsFor: 'hooks' stamp: 'ag 1/24/2011 16:45'!
onloadCode
	
	^ 'S2JConnection.connect();'! !

!OCBasicApp methodsFor: 'rendering' stamp: 'HK 1/12/2011 15:13'!
removeAllClients

	self clients
		select: [ :each | each isWebSocketClient ]
		thenDo: [ :each | each close ].
	self clients: OrderedCollection new.! !

!OCBasicApp methodsFor: 'rendering' stamp: 'ag 1/26/2011 11:47'!
removeClient: aClient
	
	self clients remove: aClient ifAbsent: [ ].! !

!OCBasicApp methodsFor: 'rendering' stamp: 'ag 1/13/2011 20:18'!
render
	
	^ self class htmlDocumentType,
		'<html>',
			self renderHeader, 
			self cr, 
			self renderBody,
		'</html>'! !

!OCBasicApp methodsFor: 'rendering' stamp: 'ag 1/24/2011 16:45'!
renderBody

	^'<body onload="', self onloadCode, '" onunload="">',
		self renderContent,
	   '</body>'.! !

!OCBasicApp methodsFor: 'hooks' stamp: 'ag 1/24/2011 14:31'!
renderContent 
	"Subclasses return custom html-content"
	
	^ ''! !

!OCBasicApp methodsFor: 'rendering' stamp: 'hk 1/26/2011 12:20'!
renderHeader

	^ '<head>',
		self renderTitle,
		self renderJavascript,
		self renderStyles,
	'</head>'.! !

!OCBasicApp methodsFor: 'rendering' stamp: 'srv 1/24/2011 14:08'!
renderJavascript
	"Render the external javascript resources."
	
	^ self renderScriptTags: self class collectScripts! !

!OCBasicApp methodsFor: 'rendering' stamp: 'ag 1/26/2011 09:56'!
renderScriptTag: aFilename
	
	^ '<script type="text/javascript" src="', aFilename, '"></script>', String cr! !

!OCBasicApp methodsFor: 'rendering' stamp: 'ag 1/26/2011 14:56'!
renderScriptTags: aCollectionOfFilenames
	"aCollectionOfFilenames does not contain absolute Urls, but only the filenames of the js-files. The path (url) will be prepended."
	
	^ self
		renderTags: aCollectionOfFilenames
		collectingFrom: [ :url | self renderScriptTag: url]! !

!OCBasicApp methodsFor: 'rendering' stamp: 'hk 1/26/2011 12:27'!
renderStyleTag: aFilename
	
	^ '<link href="', aFilename, '" rel="stylesheet" type="text/css" />', String cr! !

!OCBasicApp methodsFor: 'rendering' stamp: 'ag 1/26/2011 15:07'!
renderStyles
	"Render the external javascript resources."
	
	^ self
		renderTags: self class collectStyles
		collectingFrom: [ :url | self renderStyleTag: url]! !

!OCBasicApp methodsFor: 'rendering' stamp: 'ag 1/26/2011 14:55'!
renderTags: aCollectionOfFilenames collectingFrom: aBlock
	"aCollectionOfFilenames does not contain absolute Urls, but only the filenames. The path (url) will be prepended."
	
	^ aCollectionOfFilenames
		inject: ''
		into: [ :string :eachUrl | 
			string, (aBlock value: (self fullUrlFor: eachUrl)) ]! !

!OCBasicApp methodsFor: 'rendering' stamp: 'ag 1/26/2011 09:57'!
renderTitle
	
	^'<title>',
	 self class title,
	'</title>',
	String cr! !

!OCBasicApp methodsFor: 'accessing' stamp: 'HK 1/12/2011 10:49'!
repository
	^ repository! !

!OCBasicApp methodsFor: 'accessing' stamp: 'HK 1/12/2011 10:49'!
repository: anObject
	repository := anObject! !

!OCBasicApp methodsFor: 'hooks' stamp: 'SW 1/25/2011 11:59'!
reset 
	
	self
		clients: OrderedCollection new;
		repository: S2JContentRepository new.! !

!OCBasicApp methodsFor: 'sending content' stamp: 'ag 2/3/2011 12:21'!
sendCode: code
	
	| jsCode |
	jsCode := self translateSqueakCode: code.
	self updateRepositoryWith: jsCode.
	self sendCodeToWebSocketClients: jsCode.! !

!OCBasicApp methodsFor: 'sending content' stamp: 'SW 1/31/2011 09:25'!
sendCodeToWebSocketClients:jsCode

	self webSocketClients do: [ :each | each receive: jsCode ]
! !

!OCBasicApp methodsFor: 'sending content' stamp: 'SW 1/31/2011 09:22'!
translateSqueakCode: code

	| jsCode |
	[ jsCode := S2JPrinter convertDoIt: code ]
		on: Exception
		do: [ :err | jsCode := 'alert("Could not parse squeak-code: ', Character cr asString, code,
			Character cr asString, 'Error was: ', err asString, '");' ].
	^ jsCode! !

!OCBasicApp methodsFor: 'sending content' stamp: 'ag 1/26/2011 11:47'!
updateRepositoryWith: someContent
	
	self repository addContent: someContent.! !

!OCBasicApp methodsFor: 'sending content' stamp: 'ag 1/25/2011 13:33'!
updateRepositoryWithSqueakCode: code

	| jsCode |
	[ jsCode := S2JPrinter convertDoIt: code ]
		on: Exception
		do: [ :err | jsCode := 'alert("Could not parse squeak-code: ', Character cr asString, code,
			Character cr asString, 'Error was: ', err asString, '");' ].
	self updateRepositoryWith: jsCode.! !

!OCBasicApp methodsFor: 'dispatching' stamp: 'ag 1/25/2011 14:04'!
webSocketClients
	
	^ self clients select: [ :each | each isWebSocketClient ]! !

OCBasicApp subclass: #OCEmptyTestApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Applications'!

!OCEmptyTestApp class methodsFor: 'rendering-javascript' stamp: 'ag 2/3/2011 12:47'!
codeForAllClasses
	"This interface is implemented by S2JApp. We 'steal' the implementation from S2JApp, but we don't want to inherit from it!!"
	
	^ S2JApp codeForAllClasses! !

!OCEmptyTestApp class methodsFor: 'rendering-javascript' stamp: 'hk 3/29/2011 12:18'!
scripts
	
	^ #( 'squeaky.js' 'test/tests.js' )! !

!OCEmptyTestApp class methodsFor: 'rendering-css' stamp: 'lw 2/22/2011 14:01'!
styles
	
	^ #( 'styles/test.css' )! !

!OCEmptyTestApp class methodsFor: 'configuration' stamp: 'LT 2/21/2011 15:35:15.929'!
title

	^ 'Tests stub'! !

!OCEmptyTestApp class methodsFor: 'configuration' stamp: 'ag 2/3/2011 12:47'!
uniquePath

	^ 'emptyTest/'! !

OCEmptyTestApp subclass: #OCTestApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Applications'!

!OCTestApp class methodsFor: 'configuration' stamp: 'LT 2/21/2011 15:35:40.754'!
title

	^ 'JavaScript Tests'! !

!OCTestApp class methodsFor: 'configuration' stamp: 'ag 2/3/2011 12:47'!
uniquePath

	^ 'test/'! !

!OCTestApp methodsFor: 'hooks' stamp: 'ag 2/3/2011 12:41'!
onloadCode
	
	^ super onloadCode, 'S2JTests.runTests();'! !

OCResource subclass: #OCClientHandler
	instanceVariableNames: 'application'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

OCClientHandler subclass: #OCClassesHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OCClassesHandler class methodsFor: 'request handling' stamp: 'ag 1/26/2011 09:13'!
pathSuffix
	
	^ 'classes'! !

!OCClassesHandler methodsFor: 'request handling' stamp: 'ag 1/26/2011 09:19'!
answerTo: aRequest
	
	^ self answerCode: self application class codeForAllClasses! !

!OCClientHandler class methodsFor: 'request handling' stamp: 'ag 1/25/2011 16:29'!
canHandle: aRequest
	
	| segments |
	segments := self pathSegments: aRequest.
	^ segments size >= 2 and: [ segments second = self pathSuffix ]! !

!OCClientHandler class methodsFor: 'instance creation' stamp: 'HK 1/11/2011 16:33'!
newFor: anApplication

	^ self new application: anApplication.! !

!OCClientHandler class methodsFor: 'request handling' stamp: 'ag 1/25/2011 14:31'!
pathSegments: aRequest
	
	^ (aRequest requestLine requestURI identifier) findTokens: '/'! !

!OCClientHandler class methodsFor: 'request handling' stamp: 'ag 1/25/2011 14:07'!
pathSuffix
	
	self subclassResponsibility! !

!OCClientHandler methodsFor: 'request handling' stamp: 'ag 1/25/2011 14:08'!
answerTo: aRequest
	
	self subclassResponsibility! !

!OCClientHandler methodsFor: 'accessing' stamp: 'HK 1/11/2011 16:33'!
application
	^ application! !

!OCClientHandler methodsFor: 'accessing' stamp: 'HK 1/11/2011 16:33'!
application: anObject
	application := anObject! !

OCClientHandler subclass: #OCCometHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OCCometHandler class methodsFor: 'configuration' stamp: 'HK 12/15/2010 15:39'!
identifierRange

	^ 10e10.! !

!OCCometHandler class methodsFor: 'configuration' stamp: 'ag 1/25/2011 15:17'!
pathSuffix
	
	^ 'xhr'! !

!OCCometHandler methodsFor: 'responding' stamp: 'HK 1/3/2011 20:30'!
answerNewIdentifier: anIdentifier

	^ self
		answerWithStatusCode: 202
		andContent: anIdentifier.! !

!OCCometHandler methodsFor: 'request handling' stamp: 'ag 1/25/2011 13:45'!
answerTo: aRequest
	
	| client |
	client := self findClient: aRequest.
	^ client
		ifNil: [ self registerNewClient ]
		ifNotNil: [ 
			aRequest isGet ifTrue: [ client update ] ifFalse: [
			aRequest isPost ifTrue: [ client sent: aRequest ] ]]! !

!OCCometHandler methodsFor: 'identification' stamp: 'SW 1/19/2011 10:12'!
extractIdentifierFrom: aRequest

	(self includesIdentifier: aRequest) ifFalse: [ ^ nil ].
	^ (aRequest requestLine requestURI asString subStrings: '=') at: 2.! !

!OCCometHandler methodsFor: 'request handling' stamp: 'HK 1/12/2011 15:32'!
findClient: aRequest

	| identifier |
	identifier := self extractIdentifierFrom: aRequest.
	identifier ifNil: [ ^ nil ].
	^ self findClientById: identifier.! !

!OCCometHandler methodsFor: 'identification' stamp: 'HK 1/12/2011 10:54'!
findClientById: anIdentifier

	^ self application clients
		detect: [ :uniqueClient |
			uniqueClient isCometClient and:
				[ uniqueClient identifier = anIdentifier ]]
		ifNone: [ nil ].! !

!OCCometHandler methodsFor: 'identification' stamp: 'HK 1/3/2011 12:14'!
generateIdentifier

	| randomId |
	[ randomId := self class identifierRange atRandom ] doWhileFalse:
		[ self isIdentifierAvailable: randomId ].
	
	^ randomId asString.! !

!OCCometHandler methodsFor: 'identification' stamp: 'HK 1/3/2011 13:29'!
includesIdentifier: aRequest

	^ aRequest requestLine requestURI asString includesSubString: '?id='.! !

!OCCometHandler methodsFor: 'identification' stamp: 'hk 3/28/2011 17:14'!
isIdentifierAvailable: anIdentifier

	| allocatedIdentifiers |
	allocatedIdentifiers := self application clients
		select: [ :each | each isCometClient ]
		thenCollect: [ :each | each identifier ].
		
	 ^ (allocatedIdentifiers includes: anIdentifier) not.! !

!OCCometHandler methodsFor: 'convenience' stamp: 'SW 1/18/2011 15:36'!
registerNewClient

	| identifier client |
	
	identifier := self generateIdentifier.
	client := (S2JCometClient new identifier: identifier).
	client revision: self application repository revision.
	self application addClient: client.
	^ self answerNewIdentifier: identifier.! !

OCClientHandler subclass: #OCFileRequestHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OCFileRequestHandler class methodsFor: 'configuration' stamp: 'ag 1/25/2011 15:17'!
pathSuffix
	
	^ 'file'! !

!OCFileRequestHandler class methodsFor: 'configuration' stamp: 'ag 1/25/2011 15:41'!
rootDirectory: aDirectoryName
	"Configure the root-directory, this mini-server is serving. Only required once."
	
	| dir |
	dir := FileDirectory on: aDirectoryName.
	dir exists ifFalse: [ self error: 'Directory does not exist: ', aDirectoryName ].
	^ Smalltalk
		at: #S2JFileRootDirectory
		put: dir! !

!OCFileRequestHandler methodsFor: 'request handling' stamp: 'hk 3/29/2011 11:23'!
answerTo: aRequest
	
	| file |
	file := self extractFile: aRequest.
	^ file
		ifNotNil: [
			file binary.
			"images require binary mode. plain text works regardless of encoding"
			self application
				answerCode: file contents
				withType: (self mimeTypeOf: file) ]
		ifNil: [
			self application
				answerWithStatusCode: 404
				andContent: 'Requested file not found' ]! !

!OCFileRequestHandler methodsFor: 'request handling' stamp: 'robi 4/5/2011 19:02'!
extractFile: aRequest
	
	| segments fileRoot |
			
	segments := self class pathSegments: aRequest.
	segments removeFirst. "The app-name"
	segments removeFirst. "The /file -suffix"
	fileRoot := Smalltalk
		at: #S2JFileRootDirectory
		ifAbsent: [ 
			| possiblePathName possibleDirectory |

			possiblePathName := FileDirectory default pathName, 
								FileDirectory pathNameDelimiter asString, 'orca'.
			
			possibleDirectory := FileDirectory on: possiblePathName.
			
			possibleDirectory exists 
				ifTrue: [ possibleDirectory ]
				ifFalse: [
					self error: 'The root-directory name has not been configurd!! Execute: S2JFileRequestHandler rootDirectory: "/absolute/path/to/root/"'.
				].
			 ].
	^ fileRoot oldFileOrNoneNamed: (segments separatedBy: FileDirectory pathNameDelimiter asString)! !

!OCFileRequestHandler methodsFor: 'request handling' stamp: 'hk 3/29/2011 11:21'!
mimeTypeOf: aFile

	^ MIMEDocument guessTypeFromName: aFile name! !

OCClientHandler subclass: #OCMethodInvocationHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OCMethodInvocationHandler class methodsFor: 'configuration' stamp: 'ag 1/25/2011 15:17'!
pathSuffix 
	
	^ 'mi'! !

!OCMethodInvocationHandler methodsFor: 'request handling' stamp: 'ag 3/1/2011 17:28'!
answerTo: aRequest

	| code arguments result |
	aRequest ensureFullRead.
	code := (aRequest postDataAt: 'code') value.
	arguments := self retrieveArgumentsFrom: aRequest.
	result := (Compiler evaluate: code) valueWithArguments: arguments asArray.
	^ self application answerContent: result serializeToJavaScript withType: 'text/javascript'! !

!OCMethodInvocationHandler methodsFor: 'request handling' stamp: 'LT 2/21/2011 14:47:33.929'!
retrieveArgumentsFrom: aRequest

	| arguments currentArg |
	arguments := OrderedCollection new.
	currentArg := 0.
	[ currentArg isNil ]
		whileFalse: [ 
			| key arg |
			key := 'arg' , currentArg asString.
			arg := (aRequest postDataAt: key) value.
			arg
				ifNil: [ currentArg := nil ]
				ifNotNil: [ 
					arguments add: arg.
					currentArg := currentArg + 1 ] ].
	^ arguments! !

OCClientHandler subclass: #OCRemoteObjectsHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OCRemoteObjectsHandler class methodsFor: 'request handling' stamp: 'lw 4/5/2011 11:55'!
pathSuffix

	^ 'object'! !

!OCRemoteObjectsHandler methodsFor: 'request handling' stamp: 'lw 4/5/2011 12:01'!
answerTo: aRequest

	self halt.
! !

OCClientHandler subclass: #OCWebSocketHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OCWebSocketHandler class methodsFor: 'request handling' stamp: 'ag 1/25/2011 16:29'!
canHandle: aRequest
	"This class has an own implementation of this. That's why the abstract method pathSuffix is not implemented."
	
	^ aRequest isWebSocketRequest! !

!OCWebSocketHandler class methodsFor: 'configuration' stamp: 'HK 1/4/2011 12:17'!
millisecondsToWaitForHandshake

	^ 200.! !

!OCWebSocketHandler class methodsFor: 'client handling' stamp: 'hk 4/5/2011 11:15'!
pathSuffix
	
	^ 'ws'! !

!OCWebSocketHandler class methodsFor: 'client handling' stamp: 'SW 1/19/2011 09:45'!
updateAllClients

	self application webSocketClients do: [ :each |
		each update ].! !

!OCWebSocketHandler class methodsFor: 'client handling' stamp: 'SW 1/19/2011 09:45'!
updateAllClientsExcept: aClient
	
	aClient increaseRevision.
	self application webSocketClients
		reject: [ :uniqueClient | uniqueClient = aClient ]
		thenDo: [ :each | each update ].! !

!OCWebSocketHandler methodsFor: 'request handling' stamp: 'SW 1/17/2011 12:23'!
answerTo: aRequest

	| webSocket |
	webSocket := aRequest webSocket.
		
	(self isNew: webSocket ) ifTrue: 
		[ self setupClientWith: webSocket ].
	^ webSocket answerTo: aRequest.! !

!OCWebSocketHandler methodsFor: 'convenience' stamp: 'HK 1/12/2011 16:25'!
isNew: aWebSocket

	| registeredSockets |
	registeredSockets := self application webSocketClients collect:
		[ :each | each socket ].
	
	^ (registeredSockets includes: aWebSocket) not.! !

!OCWebSocketHandler methodsFor: 'convenience' stamp: 'SW 1/31/2011 10:11'!
setupClientWith: aWebSocket

	| client |
	client := (S2JWebSocketClient newWithSocket: aWebSocket).
	self application addClient: client.
	"self updateDelayed: client."! !

!OCWebSocketHandler methodsFor: 'convenience' stamp: 'SW 1/18/2011 10:54'!
updateDelayed: aClient

	[ (Delay forMilliseconds: self class millisecondsToWaitForHandshake) wait. 
	aClient update] fork.! !

OCResource subclass: #OCDispatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Server'!

!OCDispatcher class methodsFor: 'setup' stamp: 'ag 1/25/2011 13:57'!
defaultPort

	^ 8887! !

!OCDispatcher class methodsFor: 'setup' stamp: 'lw 2/25/2011 14:07'!
forcedRestart
	"Why is this even necessary?" "Brought to you by UGLYFIX!! :-)"
	
	Transcript show: 'Server restart.';cr.
	SwazooServer initSingleton.
	SwazooServer allInstancesDo: [ :swa | 
		swa stop; initSites].
	HTTPServer allInstancesDo: [ :http |
		http stop; initialize].
	HTTPConnection allInstancesDo: [ :conn |
		conn close].
	SwazooServer singleton start.
	Smalltalk garbageCollect.
	self start.! !

!OCDispatcher class methodsFor: 'setup' stamp: 'ag 1/13/2011 20:12'!
install
	
	^ self installOn: self defaultPort! !

!OCDispatcher class methodsFor: 'setup' stamp: 'ag 1/25/2011 14:16'!
installOn: aPort
	
	^ (SwazooSite
		newNamed: self name)
		host: '*'
		ip: '*'
		port: aPort;
		addResource: (self uriPattern: '/');
		yourself! !

!OCDispatcher class methodsFor: 'setup' stamp: 'ag 1/13/2011 20:12'!
isInstalled
	
	^ self site notNil! !

!OCDispatcher class methodsFor: 'setup' stamp: 'ag 1/25/2011 14:16'!
site
	
	^ SwazooServer singleton siteNamed: self name! !

!OCDispatcher class methodsFor: 'setup' stamp: 'ag 1/13/2011 20:12'!
start
	
	self isInstalled ifFalse: [ self install ].
	self site start.! !

!OCDispatcher class methodsFor: 'setup' stamp: 'ag 1/13/2011 20:13'!
uninstall
	
	self isInstalled ifTrue: [
		self removeAllClients.
		self resetContent.
		SwazooServer singleton removeSite: self site ].! !

!OCDispatcher methodsFor: 'dispatching' stamp: 'hk 2/1/2011 12:27'!
answerTo: aRequest 
	
	| application |
	(self hasToBeForwarded: aRequest ) 
		ifTrue: [ ^ self forward: aRequest ].		
	application := self findApplicationNamed: (self identifierOf: aRequest).
	application
		ifNil: [  ^ self redirectTo: '/', S2JIndex uniquePath ]
		ifNotNil: [ ^ application instance answerTo: aRequest ].! !

!OCDispatcher methodsFor: 'dispatching' stamp: 'hk 1/25/2011 13:51'!
findApplicationNamed: aName

	aName ifNil: [ ^ nil ].
	^ S2JBasicApp allSubclasses
		detect: [ :each | each uniquePath = aName ]
		ifNone: [ nil ]. ! !

!OCDispatcher methodsFor: 'dispatching' stamp: 'hk 2/1/2011 12:27'!
forward: aRequest

	| url |
	url:= self identifierOf: aRequest.
	^ self redirectTo: '/', url! !

!OCDispatcher methodsFor: 'dispatching' stamp: 'hk 2/1/2011 12:19'!
hasToBeForwarded: aRequest
	
	| url |
	url := aRequest requestLine requestURI identifier.
	^ ( url findTokens: '/') size = 1 and: [ (url endsWith: '/') not ]
	
	
! !

!OCDispatcher methodsFor: 'dispatching' stamp: 'hk 2/1/2011 11:54'!
identifierOf: aRequest
	
	((aRequest requestLine requestURI identifier) findTokens: '/') size = 0 
		ifTrue: [ ^ nil  ]
		ifFalse: [ ^ ((aRequest requestLine requestURI identifier) findTokens: '/') first, '/' ].
	
	
! !

!OCDispatcher methodsFor: 'dispatching' stamp: 'HK 1/4/2011 15:45'!
redirectTo: aPath

	^HTTPResponse new
		statusCode: 302;
		entity: '';
		location: aPath;
		yourself.! !

!OCResource methodsFor: 'responding' stamp: 'hk 1/26/2011 10:51'!
answerCode: code
	
	^ self
		answerCode: code
		withType: 'text/javascript'! !

!OCResource methodsFor: 'responding' stamp: 'hk 1/26/2011 10:27'!
answerCode: code withType: aString
	
	^ self
		answerContent: code
		withType: aString! !

!OCResource methodsFor: 'responding' stamp: 'HK 12/17/2010 13:57'!
answerContent: data withType: aString

	| response |
	response := HTTPResponse ok.
	^ response
		contentType: aString;
		entity: data;
		yourself.! !

!OCResource methodsFor: 'responding' stamp: 'HK 12/15/2010 17:15'!
answerCreated

	^ self answerWithStatusCode: 201.! !

!OCResource methodsFor: 'responding' stamp: 'HK 1/10/2011 13:53'!
answerNotModified

	^ self answerWithStatusCode: 304.! !

!OCResource methodsFor: 'responding' stamp: 'HK 12/15/2010 17:16'!
answerWithStatusCode: aNumber

	^ self answerWithStatusCode: aNumber andContent: ''.! !

!OCResource methodsFor: 'responding' stamp: 'HK 12/15/2010 15:47'!
answerWithStatusCode: aNumber andContent: content

	^ HTTPResponse ok
		statusCode: aNumber;
		entity: content.! !

!OCResource methodsFor: 'printing-helpers' stamp: 'ag 1/13/2011 20:19'!
cr

	^ String cr! !

!SHTextStylerST80 class methodsFor: '*Orca' stamp: 'hk 3/22/2011 14:55'!
disableJsHighlighting

	self chooseDefaultStyleTable.! !

!SHTextStylerST80 class methodsFor: '*Orca' stamp: 'hk 3/22/2011 12:03'!
enableJsHighlighting

	self styleTable: self jsStyleTable.! !

!SHTextStylerST80 class methodsFor: '*Orca' stamp: 'hk 3/22/2011 14:54'!
jsStyleTable
	"color can be a valid argument to Color class>>colorFrom: , or nil to
	use the editor text color.
	Multiple emphases can be specified using an array e.g. #(bold italic).
	If emphasis is not specified, #normal will be used.
	if pixel height is not specified , then the editor font size will be used.
	"
								
^#(
	"(symbol	color		[emphasisSymbolOrArray		[textStyleName [pixelHeight]]])"		
	(default 								black 		)
	(invalid 								red 			)
	(excessCode 								red 			)
	(comment 								(cyan darker) 		)
	(unfinishedComment 					(red muchDarker) 	italic)
	(#'$'									(red muchDarker) 	)
	(character								(red muchDarker) 	)
	(integer									(red muchDarker) 	)
	(number								(red muchDarker) 	)	
	(#-										(red muchDarker) 	)
	(symbol									(blue muchDarker)			)	
	(stringSymbol							(blue muchDarker)			)	
	(literalArray							(blue muchDarker)			)
	(string									(magenta muchDarker)	normal			)
	(unfinishedString						red			normal			)
	(assignment								nil			bold			)
	(ansiAssignment 						nil			bold)
	(literal									nil			italic)
	(keyword								(blue muchDarker)			)
	(binary 								(blue muchDarker)			)	
	(unary									(blue muchDarker)			)
	(incompleteKeyword						(gray muchDarker)			underlined)
	(incompleteBinary 						(gray muchDarker)			underlined)	
	(incompleteUnary						(gray muchDarker)			underlined)
	(undefinedKeyword						red			)
	(undefinedBinary 						red			)	
	(undefinedUnary						red			)													
	(patternKeyword 						nil			bold)
	(patternBinary 							nil			bold)
	(patternUnary							nil			bold)	
	(#self 									(red muchDarker)	)
	(#super									(red muchDarker)	) 
	(#true 									(red muchDarker)	)
	(#false 									(red muchDarker)	)
	(#nil 									(red muchDarker)	)
	(#thisContext 							(red muchDarker)	)
	(#return								(red muchDarker)	)
	(patternArg 							(blue muchDarker)			)	
	(methodArg 								(blue muchDarker)			)
	(blockPatternArg 						(blue muchDarker)			)
	(blockArg 								(blue muchDarker)			)
	(argument 								(blue muchDarker)			)
	(blockArgColon							black		) 
	(leftParenthesis							black		) 
	(rightParenthesis						black		) 
	(leftParenthesis1						(green muchDarker)		) 
	(rightParenthesis1						(green muchDarker)		) 
	(leftParenthesis2						(magenta muchDarker)		) 
	(rightParenthesis2						(magenta muchDarker)		) 
	(leftParenthesis3						(red muchDarker)		) 
	(rightParenthesis3						(red muchDarker)		) 
	(leftParenthesis4						(green darker)		) 
	(rightParenthesis4						(green darker)		) 
	(leftParenthesis5						(orange darker)		) 
	(rightParenthesis5						(orange darker)		) 
	(leftParenthesis6						(magenta darker)		) 
	(rightParenthesis6						(magenta darker)		) 
	(leftParenthesis7						blue		) 
	(rightParenthesis7						blue		) 
	(blockStart 								black		) 
	(blockEnd 								black		) 
	(blockStart1								(green muchDarker)			) 
	(blockEnd1								(green muchDarker)			) 
	(blockStart2								(magenta muchDarker)		) 
	(blockEnd2								(magenta muchDarker)		) 
	(blockStart3								(red muchDarker)		) 
	(blockEnd3								(red muchDarker)		) 
	(blockStart4								(green darker)		) 
	(blockEnd4								(green darker)		) 
	(blockStart5								(orange darker)		) 
	(blockEnd5								(orange darker)		) 
	(blockStart6								(magenta darker)		) 
	(blockEnd6								(magenta darker)		) 
	(blockStart7								blue		) 
	(blockEnd7								blue		) 																																																		
	(arrayStart								black		) 
	(arrayEnd								black		) 
	(arrayStart1							black		) 
	(arrayEnd1								black		) 
	(leftBrace 								blue		) 
	(rightBrace 								blue		) 
	(cascadeSeparator 						black		) 
	(statementSeparator 						black		) 
	(externalCallType 						black		) 
	(externalCallTypePointerIndicator 		black		) 
	(primitiveOrExternalCallStart 			black		) 
	(primitiveOrExternalCallEnd				black		)
	(methodTempBar							gray		) 
	(blockTempBar 							gray		)
	(blockArgsBar							gray		)
	(primitive								(green muchDarker)		bold)
	(pragmaKeyword						(green muchDarker)		bold)
	(pragmaUnary							(green muchDarker)		bold)
	(pragmaBinary							(green muchDarker)		bold)									
	(externalFunctionCallingConvention		(green muchDarker)		bold) 
	(module									(green muchDarker)		bold)
	(blockTempVar 							gray		)
	(blockPatternTempVar					gray		)
	(instVar 								black		)
	(workspaceVar							black		)
	(undefinedIdentifier						red			)
	(incompleteIdentifier					(gray darker) 	(italic underlined))
	(tempVar								(gray darker)	)
	(patternTempVar						(gray darker)	)
	(poolConstant							(gray muchDarker)	)
	(classVar								(gray muchDarker)	)
	(globalVar								black		) )! !

!Collection methodsFor: '*Orca' stamp: 'ag 1/25/2011 16:03'!
separatedBy: aString
	
	| stream |
	stream := TextStream on: ''.
	self asStringOn: stream delimiter: aString.
	^ stream contents! !

TextStream subclass: #OCTextStream
	instanceVariableNames: 'printer privateTextStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OCTextStream class methodsFor: 'instance creation' stamp: 'ag 1/9/2011 17:37'!
for: anS2JAbstractPrinter
	
	^ (self
		on: '')
		printer: anS2JAbstractPrinter;
		yourself! !

!OCTextStream methodsFor: 'initialization' stamp: 'ag 1/9/2011 20:08'!
initialize
	
	super initialize.
	self privateTextStream: (TextStream on: '').! !

!OCTextStream methodsFor: 'printing' stamp: 'ag 1/10/2011 10:14'!
printBlock: aConditionBlock prependedBy: prependBlock
	"aConditionBlock is evaluated with a 'mock'-stream. if true is returned, prependBlock is evaluated and aConditionBlock is evaluated with the actual self."
	
	(aConditionBlock value: self privateTextStream)
		ifTrue: [
			prependBlock value.
			aConditionBlock value: self].! !

!OCTextStream methodsFor: 'accessing' stamp: 'ag 1/9/2011 17:38'!
printer
	
	^ printer! !

!OCTextStream methodsFor: 'accessing' stamp: 'ag 1/9/2011 17:38'!
printer: anS2JAbstractPrinterClass
	
	printer := anS2JAbstractPrinterClass! !

!OCTextStream methodsFor: 'accessing' stamp: 'ag 1/9/2011 20:08'!
privateTextStream
	
	^ privateTextStream! !

!OCTextStream methodsFor: 'accessing' stamp: 'ag 1/9/2011 20:08'!
privateTextStream: aStream
	
	privateTextStream := aStream! !

TestCase subclass: #OCTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

OCTestCase subclass: #OCAbstractTest
	instanceVariableNames: 'currentRule nilResultAllowed checkResults'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

OCAbstractTest subclass: #OCAbstractPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OCAbstractPrinterTest methodsFor: 'test general' stamp: 'srv 1/10/2011 15:02'!
testExampleMethods
	
	super testExampleMethods.
	
	self class isOnCIServer ifTrue: [
		{ Object. Number. ProtoObject. OrderedCollection }
			do: [ :class | self class converterClass convertClass: class ]].! !

OCAbstractPrinterTest subclass: #OCPrettyPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OCPrettyPrinterTest class methodsFor: 'testing' stamp: 'lw 1/4/2011 17:46'!
converterClass
	
	^ S2JPrettyPrinter! !

!OCPrettyPrinterTest class methodsFor: 'testing' stamp: 'lw 1/4/2011 11:23'!
defaultCurrentRule
	
	^ #doItSnippet! !

!OCPrettyPrinterTest methodsFor: 'test printing' stamp: 'ag 3/29/2011 10:03'!
testCascades

	self 
		assertMatches: 'a b; c' andProduces:  
'            (function () {
                var cascadeReceiver$ = a;
                cascadeReceiver$.b();
                return cascadeReceiver$.c();
            }).apply(this)';

		assertMatches: 'a slot: b; slot: c' andProduces: 
 '            (function () {
                var cascadeReceiver$ = a;
                cascadeReceiver$.slot_(b);
                return cascadeReceiver$.slot_(c);
            }).apply(this)';

		assertMatches: 'a slot: b be: d; slot: c be: d' andProduces: 
 '            (function () {
                var cascadeReceiver$ = a;
                cascadeReceiver$.slot_be_(b, d);
                return cascadeReceiver$.slot_be_(c, d);
            }).apply(this)';

		assertMatches: '^ Object new slot: injection be: ''infovis''; yourself' andProduces: 
 '            return (function () {
                var cascadeReceiver$ = _Object._new();
                cascadeReceiver$.slot_be_(injection, string("infovis"));
                return cascadeReceiver$.yourself();
            }).apply(this)'.! !

!OCPrettyPrinterTest methodsFor: 'test nodetypes' stamp: 'LT 2/24/2011 19:42:38.807'!
testFunctionCall

	self 
		assertMatches: (S2JNode functionCall: 
			{S2JNode identifier: 'b'. 
			#js.
			S2JNode arguments }) 
		andProduces: 'b.js()';
		
		assertMatches: (S2JNode functionCall: 
			{S2JNode identifier: 'b'. 
			#call.
			S2JNode arguments: { S2JNode identifier: #b }}) 
		andProduces: 'b.call(b)'.
		! !

!OCPrettyPrinterTest methodsFor: 'test printing' stamp: 'ag 3/29/2011 10:06'!
testIndention

	self
		assertMatches: '[:e | Js Global alert value: e. [ :f | f + 1 ]. [ :f | f := f + 2. ^ [Js Global alert value: f ] ]]'
		andProduces:  
'            block(function (e) {
                Js.Global().alert().value_(e);
                block(function (f) {
                    return f._plus(number(1));
                });
                return block(function (f) {
                    f = f._plus(number(2));
                    nonLocalReturn(block(function () {
                        return Js.Global().alert().value_(f);
                    }));
                });
            })'! !

!OCPrettyPrinterTest methodsFor: 'test nodetypes' stamp: 'LT 2/24/2011 19:42:54.319'!
testSlotAccess

	self 
		assertMatches: (S2JNode slotAccess: {S2JNode identifier: 'a'. #b}) 
		andProduces: 'a.b'.
		
	self
		assertMatches: (S2JNode slotAccess: {S2JNode identifier: #'$a'. #'hello_world'})
		andProduces: '$a.hello_world'.! !

!OCPrettyPrinterTest methodsFor: 'test nodetypes' stamp: 'LT 2/24/2011 19:38:54.709'!
testSlotAssignment

	self 
		assertMatches: (S2JNode expression: 
			{S2JNode identifier: 'b'.
			S2JNode slotAccess: 
				{S2JNode identifier: 'a'. #slot}. 
			}) 
		andProduces: '        a.slot = b'.
		! !

OCAbstractPrinterTest subclass: #OCPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OCPrinterTest class methodsFor: 'testing' stamp: 'lw 1/4/2011 11:23'!
converterClass
	
	^ S2JPrinter! !

!OCPrinterTest class methodsFor: 'testing' stamp: 'ag 12/22/2010 13:52'!
defaultCurrentRule
	
	^ #doItSnippet! !

!OCPrinterTest methodsFor: 'test printing' stamp: 'lw 2/19/2011 02:30'!
testCascadedExpression
	
	self
		currentRule: #cascadedExpression;
		
		assertMatches: 'a b; c'
		andProduces: '(function(){var cascadeReceiver$=a;cascadeReceiver$.b();return cascadeReceiver$.c();}).apply(this)';
		
		assertMatches: 'a b: (a b; d); c'
		andProduces: '(function(){var cascadeReceiver$=a;cascadeReceiver$.b_((function(){var cascadeReceiver$=a;cascadeReceiver$.b();return cascadeReceiver$.d();}).apply(this));return cascadeReceiver$.c();}).apply(this)'! !

!OCPrinterTest methodsFor: 'test printing' stamp: 'lw 2/19/2011 02:29'!
testEscapingIdentifiers
	
	self
		currentRule: #doItSnippet;
		
		assertMatches: 'Object new'
		andProduces: '_Object._new()';
		
		assertMatches: 'a := true'
		andProduces: 'a=_true'.
	
	self class isOnCIServer ifTrue: [
		self assert: ((S2JCodeFactory new codeForClass: Object) beginsWith: 'Class("_Object",').
		self assert: ((S2JCodeFactory new codeForClass: Point) beginsWith: 'Class("Point",{superclass:_Object')].! !

!OCPrinterTest methodsFor: 'test general' stamp: 'srv 1/10/2011 15:02'!
testExampleMethods
	
	super testExampleMethods.! !

!OCPrinterTest methodsFor: 'test printing' stamp: 'ag 3/29/2011 16:53'!
testExceptionalSyntax
	
	self
		assertMatches: '#alert apply: {''aaa''}'
		andProduces: 'alert("aaa")'.! !

!OCPrinterTest methodsFor: 'test general' stamp: 'robi 1/17/2011 18:01'!
testJsStringPrinting
	
	self
		assert: [ '"\\\"''"' = (S2JAbstractPrinter asJSString: '\"''')];
		assert: [ '"abc def ()/&%"' = (S2JAbstractPrinter asJSString: 'abc def ()/&%')];
		assert: [ '"\r"' = (S2JAbstractPrinter asJSString: String cr)].! !

!OCPrinterTest methodsFor: 'test printing' stamp: 'LT 2/24/2011 20:40:26.861'!
testObjectLiteral

	self 
		assertMatches: (S2JNode objectLiteral: {})
		andProduces: '{}';

		assertMatches: (
			S2JNode objectLiteral: {
                    	S2JNode slotAssignment: 
					{#a. 
					S2JNode identifier: 'b'}.
                    	S2JNode slotAssignment:
                       	 	{#b.
                        	S2JNode functionCall: 
						{S2JNode functionCall: 
							{S2JNode identifier: 'a'. 
							#b. 
							S2JNode arguments}.
						#js.
						S2JNode arguments}}})
		andProduces: '{a:b,b:a.b().js()}'! !

!OCPrinterTest methodsFor: 'test printing' stamp: 'ag 1/19/2011 19:53'!
testPerformOnServer
	
	self
		assertMatches: '[1] onServer'
		andProduces: 'serverBlock("[1]")';
		
		assertMatches: '[:a|1] onServer'
		andProduces: 'serverBlock("[:a|1]")';
		
		assertMatches: '[ [ 1 ] onServer ] onServer'
		andProduces: 'serverBlock("[ [ 1 ] onServer ]")'.! !

!OCPrinterTest methodsFor: 'test printing' stamp: 'lw 2/19/2011 02:28'!
testPrinting
	
	self
		assert: '1 +/ 2' matches: #binaryExpression andProduces: 'number(1)._plus_slash(number(2))';
		assert: '{ 1. a b: c. ''s'' }' matches: #braceExpression andProduces: 'array([number(1), a.b_(c), string("s")])';
		assert: 'a :=   12 a: 12' matches: #expression andProduces: 'a=number(12).a_(number(12))';
		assert: '1 a: 2 b: 3' matches: #keywordExpression andProduces: 'number(1).a_b_(number(2), number(3))';
		assert: '1 a:a b:B. 2 s.' matches: #doItSnippet andProduces: 'number(1).a_b_(a, B);number(2).s()';
		assert: '| a b v |' matches: #temporaries andProduces: 'var a;var b;var v';
		assert: '1 bcd' matches: #unaryExpression andProduces: 'number(1).bcd()';
		assert: '(1 2 3 ''d  '')' matches: #array andProduces: 'array([number(1), number(2), number(3), string("d  ")])';
		assert: '#[ 1 2 3 255]' matches: #byteArray andProduces: 'array([number(1), number(2), number(3), number(255)])';
		assert: '12.3' matches: #number andProduces: 'number(12.3)';
		assert: 'self' matches: #reservedWord andProduces: 'this';
		assert: '#a12' matches: #symbol andProduces: 'string("a12")'.! !

!OCPrinterTest methodsFor: 'test printing' stamp: 'ag 1/24/2011 19:16'!
testSuper
	
	self
		assertMatches: 'super a'
		andProduces: '_super("a")()';
		
		assertMatches: 'super a: 1 b: d'
		andProduces: '_super("a_b_")(number(1), d)';
		
		assertMatches: 'a := super'
		andProduces: 'a=this';
		
		assertMatches: '^super'
		andProduces: 'return this'.! !

!OCAbstractTest class methodsFor: 'testing' stamp: 'ag 12/9/2010 13:15'!
converterClass
	
	self subclassResponsibility! !

!OCAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:23'!
defaultCheckResults
	
	^ true! !

!OCAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:24'!
defaultCurrentRule
	
	^ nil! !

!OCAbstractTest class methodsFor: 'testing' stamp: 'ag 12/13/2010 09:23'!
defaultNilResultsAllowed
	
	^ false! !

!OCAbstractTest methodsFor: 'helpers' stamp: 'lw 2/22/2011 16:58'!
assert: anObject matches: aRule
	"In most cases, throws an error when failing (hard fail)"
	
	| result |
	result := anObject isString 
		ifTrue: [ self class converterClass convert: anObject as: aRule. ] 
		ifFalse: [ self class converterClass convertAst: anObject ].
	
	self nilResultAllowed ifFalse: [ self assert: result notNil ].
	^ result! !

!OCAbstractTest methodsFor: 'helpers' stamp: 'sec 3/23/2011 14:24'!
assert: anObject matches: aRule andProduces: anObjectTree
	"In most cases, throws an error when failing (hard fail). #= Checks collections deeply."
	
	| result |
	result := self assert: anObject matches: aRule.
	result isString ifTrue: [ result := result withSqueakLineEndings ].
	self checkResults ifTrue: [ self assert: result = anObjectTree ].
	^ result! !

!OCAbstractTest methodsFor: 'helpers' stamp: 'lw 2/22/2011 17:30'!
assert: aString matches: aRule andProducesNode: aCollection
	"Matches the string to the rule and compares the result to an S2JNode containing the given collection and named like the rule.
	(Follows a convention)."
	
	| result |
	result := self assert: aString matches: aRule.
	self checkResults ifTrue: [ self assert: result = (S2JNode named: aRule asString with: aCollection) ].
	^ result! !

!OCAbstractTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 15:57'!
assertConverting: anInputString containsNodeNamed: aNodeName
	
	^ self assert: 
		(( self assertMatches: anInputString )
			includesChildNamed: aNodeName).! !

!OCAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertFails: aString
	"Checks against the currentRule"
	
	self
		assertFails: aString
		toMatch: self currentRule.! !

!OCAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertFails: aString toMatch: aRule
	
	self
		should: [ self assert: aString matches: aRule ]
		raise: OM2Fail
		description: 'Matching should have failed but didn''t!!'.! !

!OCAbstractTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 15:57'!
assertMatches: aString
	"Check against the currentRule"
	
	^ self assert: aString matches: self currentRule! !

!OCAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertMatches: aString andProduces: anObject
	"Check against the currentRule"
	
	^ self
		assert: aString
		matches: self currentRule
		andProduces: anObject! !

!OCAbstractTest methodsFor: 'helpers' stamp: 'ag 12/9/2010 13:14'!
assertMatches: aString andProducesNode: aCollection
	"Check against the currentRule"
	
	^ self
		assert: aString
		matches: self currentRule
		andProducesNode: aCollection! !

!OCAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
checkResults
	^ checkResults! !

!OCAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
checkResults: aBoolean
	checkResults := aBoolean! !

!OCAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
currentRule
	^ currentRule! !

!OCAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
currentRule: aSymbol
	currentRule := aSymbol! !

!OCAbstractTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 15:56'!
denyConverting: anInputString containsNodeNamed: aNodeName
	
	self deny: 
		(( self assertMatches: anInputString )
			includesChildNamed: aNodeName).! !

!OCAbstractTest methodsFor: 'test general' stamp: 'ag 3/28/2011 17:53'!
exampleMethod1
	
	"Comment"
	self class.
	^ [ Js Global alter: 'example'].! !

!OCAbstractTest methodsFor: 'test general' stamp: 'ag 3/28/2011 17:54'!
exampleMethod2
	
	| |
	< primitiveDecl: 1 >
	"Comment"
	self class.
	self
		a: 1;
		b: 2;
		c.
	^ [ Js Global alert: 'example'].! !

!OCAbstractTest methodsFor: 'test general' stamp: 'ag 3/28/2011 17:53'!
""exampleMethod3""
	""
	""<"" primitiveDecl: ""1 "">""
	""
	""| ""temporariesAfterPrimitiveDecl"" |""
	"Comment"
	""self"" class"".""
	self""
		""a:"" 1"";""
		""b: ""2"";""
		""c"".""
	""^"" [""Js Global ""alter:"" 'example'""]"".""! !

!OCAbstractTest methodsFor: 'initialization' stamp: 'ag 12/13/2010 09:24'!
initialize
	
	super initialize.
	self
		nilResultAllowed: self class defaultNilResultsAllowed;
		checkResults: self class defaultCheckResults;
		currentRule: self class defaultCurrentRule.! !

!OCAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:16'!
nilResultAllowed
	^ nilResultAllowed! !

!OCAbstractTest methodsFor: 'accessing' stamp: 'ag 12/9/2010 13:18'!
nilResultAllowed: aBoolean
	nilResultAllowed := aBoolean! !

!OCAbstractTest methodsFor: 'private' stamp: 'ag 1/11/2011 11:42'!
performTest
	
	self class = S2JAbstractTest | (self class = S2JTestCase) | (self class = S2JAbstractPrinterTest)
		ifTrue: [ "Just ignore the abstract tests" ]
		ifFalse: [ super performTest ].! !

!OCAbstractTest methodsFor: 'test general' stamp: 'srv 1/10/2011 15:00'!
testExampleMethods
	
	self class converterClass
		convertMethod: #exampleMethod1 of: self class;
		convertMethod: #exampleMethod2 of: self class;
		convertMethod: #exampleMethod3 of: self class.! !

OCAbstractTest subclass: #OCParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OCParserTest class methodsFor: 'testing' stamp: 'ag 12/9/2010 13:24'!
converterClass
	
	^ S2JParser! !

!OCParserTest methodsFor: 'test tokens' stamp: 'lw 2/22/2011 18:09'!
testArray
	
	self
		currentRule: #array;
		
		assertMatches: '()' andProducesNode: {};
		assertMatches: '(:)' andProducesNode: { S2JNode symbol: #: };
		assertMatches: '(  )  ' andProducesNode: {};
		assertMatches: '( 2. 1) ';
		assertMatches: '( 2. 1 [ ] ^ 23 { } ) ';
		assertMatches: '(  1 2   3) ' andProducesNode: {S2JNode number: 1. S2JNode number: 2. S2JNode number: 3};
		assertMatches: '(''aa'' 1 ''b1'' 32)' andProducesNode: 
			{S2JNode string: 'aa'. S2JNode number: 1. S2JNode string: 'b1'. S2JNode number: 32};
		assertMatches: '(#abc     11    ''a''   )' andProducesNode: 
			{S2JNode symbol: #abc. S2JNode number: 11. S2JNode string: 'a'};
		assertMatches: '(  ( 1 2 3    ''2'')   #a  ''c''   )' andProducesNode: 
			{S2JNode array: {S2JNode number: 1. S2JNode number: 2. S2JNode number: 3. S2JNode string: '2'}.
			S2JNode symbol: #a. S2JNode string: 'c'};
		assertMatches: '($a     11    ''a''   #a2   #(1 2   $2) )  ' andProducesNode: { S2JNode character: $a. S2JNode number: 11. S2JNode string: 'a'. S2JNode symbol: #a2. S2JNode array: {S2JNode number: 1. S2JNode number: 2. S2JNode character: $2}};
		assertMatches: '( a )' andProducesNode: { S2JNode symbol: #a};
		assertMatches: '( a b )' andProducesNode: {S2JNode symbol: #a. S2JNode symbol: #b} ;
		assertMatches: '(d ((b ((a))) (c)))' andProducesNode: {S2JNode symbol: #d. S2JNode array: {S2JNode array: {S2JNode symbol: #b. 
			S2JNode array: {S2JNode array: {S2JNode symbol: #a}}}. S2JNode array: {S2JNode symbol: #c}}};
		assertMatches: '( self a:bc == |? ?!!!! )  ' andProducesNode: {S2JNode symbol: #self. S2JNode symbol: #'a:bc'. 
			S2JNode symbol: #'=='. S2JNode symbol: #'|'. S2JNode symbol: #'?'. S2JNode symbol: #'?!!!!'};
		assertMatches: '( self #( aa 1 ) ( ''a'' #1 #ab: ab:))  ' andProducesNode: { S2JNode symbol: #self. S2JNode array: {S2JNode symbol: #aa. S2JNode number: 1. }. S2JNode array: { S2JNode string: 'a'. S2JNode number: 1. S2JNode symbol: #'ab:'. S2JNode symbol: #'ab:' }} ;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '(';
		assertFails: '#()';
		assertFails: '#(';
		assertFails: '{1}';
		assertFails: ' ( 1 2  )'. "Should not read prepended spaces"! !

!OCParserTest methodsFor: 'test complex' stamp: 'lw 2/22/2011 18:14'!
testBinaryExpression
	
	self
		currentRule: #binaryExpression;
		
		assertMatches: 'a+b' andProducesNode:  (S2JNode binaryExpression: { S2JNode identifier: 'a' . #+. S2JNode identifier: 'b'} );
		assertMatches: '1 * b' andProducesNode: (S2JNode binaryExpression: 
			{S2JNode number: 1 .#* . S2JNode identifier: 'b'});
		assertMatches: '1 \ b / c' andProducesNode: 
			(S2JNode binaryExpression: 
				{ S2JNode binaryExpression: {  S2JNode number: 1.  #\  . 
				S2JNode identifier: 'b'} . #/ . S2JNode identifier: 'c'} );
		
		assertFails: 'a 2';
		assertFails: 'a: 2';
		assertFails: '+ 2'.! !

!OCParserTest methodsFor: 'test tokens' stamp: 'ag 11/21/2010 20:02'!
testBinarySelector
	"Would be cool to find all the binary messages in the image and test them..."
	
	self
		currentRule: #binarySelector;
		
		"special cases: single pipe and single minus"
		assertMatches: '|' andProduces: #|;
		assertMatches: '-' andProduces: #-;
		
		"names starting with a minus"
		assertMatches: '-*' andProduces: #-*;
		assertMatches: '-***' andProduces: #-***;
		assertMatches: '-*%&' andProduces: #-*%&;
		assertMatches: '-*/\' andProduces: #-*/\;
		assertMatches: '-!!?' andProduces: #-!!?;
		assertMatches: '-==' andProduces: #-==;
		
		"mixed characters, check each one"
		assertMatches: '*+' andProduces: #*+;
		assertMatches: '/=\' andProduces: #/=\;
		assertMatches: '~,,,<' andProduces: #~,,,<;
		assertMatches: '>@' andProduces: #>@;
		assertMatches: '%&' andProduces: #%&;
		assertMatches: '?!!' andProduces: #?!!;
		assertMatches: '``' andProduces: #``;
		assertMatches: '+??=' andProduces: #+??=;
		assertMatches: ',!!!!,' andProduces: #,!!!!,;
		
		"Not allowed things"
		assertFails: '';
		assertFails: ' ';
		assertFails: 'w';
		assertFails: '2';
		assertFails: '--';
		assertFails: '||';
		assertFails: '|--';
		assertFails: '%--';
		assertFails: '%||';
		assertFails: '&-&-';
		assertFails: '- %';
		assertFails: ' -';
		assertFails: '& &';
		assertFails: 'w a';
		assertFails: '- -';
		assertFails: '#a a';
		assertFails: '#aa 2'.! !

!OCParserTest methodsFor: 'test complex' stamp: 'lw 2/22/2011 18:26'!
testBlock
	
	self
		currentRule: #block;
		
		assertMatches: '[]' andProducesNode: { };
		assertMatches: '[  ]' andProducesNode: { };
		assertMatches: '[||]' andProducesNode: {S2JNode temporaries};
		assertMatches: '[:a|||]' andProducesNode: 
			{ S2JNode arguments: {S2JNode identifier: 'a'}. S2JNode temporaries};
		assertMatches: '[||a]' andProducesNode: {S2JNode temporaries. S2JNode statements: {S2JNode expression: {S2JNode identifier: 'a'}}};
		assertMatches: '[:a|||a]' andProducesNode:
			{ S2JNode arguments: {S2JNode identifier: 'a'}. S2JNode temporaries. S2JNode statements: { S2JNode expression: {S2JNode identifier: 'a'}}};
		assertMatches: '[:a||a|a]' andProducesNode: 
			{ S2JNode arguments: {S2JNode identifier: 'a'}. S2JNode temporaries: { S2JNode identifier: 'a'}. 
			S2JNode statements: { S2JNode expression: { S2JNode identifier: 'a'}}};
		assertMatches: '[:a|a|a|a]' andProducesNode:
			{ S2JNode arguments: { S2JNode identifier: 'a' }. S2JNode statements:
				{ S2JNode expression: { S2JNode binaryExpression: { S2JNode binaryExpression: 
					{ S2JNode identifier: 'a'. #|. S2JNode identifier: 'a' }. #| . 
					S2JNode identifier: 'a'.  }}}};
		assertMatches: '[ :a ]  ' andProducesNode: {S2JNode arguments: {S2JNode identifier: 'a'}};
		assertMatches: '   [ :a ]  ' andProducesNode: {S2JNode arguments: { S2JNode identifier: 'a'}};
		assertMatches: '[ :a :b ]  ' andProducesNode: {S2JNode arguments: {S2JNode identifier: 'a'. S2JNode identifier: 'b'}};
		assertMatches: '[ :a  :b | ]' andProducesNode: {S2JNode arguments: {S2JNode identifier: 'a'. S2JNode identifier: 'b'}};
		assertMatches: '  [   :a |   |  a  |   ]  ' andProducesNode: {S2JNode arguments: {S2JNode identifier: 'a'}. 
			S2JNode temporaries: {S2JNode identifier: 'a'}};
		assertMatches: '[  :a  | a ]  ' andProducesNode:
			{S2JNode arguments: {S2JNode identifier: 'a'}. 
			S2JNode statements: {S2JNode expression: {S2JNode identifier: 'a'}}};
		assertMatches: '[ :a  | a. ^ 1 ]' andProducesNode:
			{S2JNode arguments: {S2JNode identifier: 'a'}. S2JNode statements:
				{S2JNode expression: {S2JNode identifier: 'a'}. S2JNode returnExpression: {S2JNode number: 1}}};
		assertMatches: '[  :a  |  1  ]' andProducesNode:
			{S2JNode arguments: {S2JNode identifier: 'a'}. S2JNode statements: {S2JNode expression: {S2JNode number: 1}}};
		assertMatches: '[  :b  |   []  ]' andProducesNode:
			{S2JNode arguments: {S2JNode identifier: 'b'}. S2JNode statements: {S2JNode expression: { S2JNode block}}};
		
		"Can also leave spaces between : and the argument-name !!"
		assertMatches: '[ :  i | ]' andProducesNode: {S2JNode arguments: {S2JNode identifier: 'i'}};
		assertMatches: '[ :  i :  d | ]' andProducesNode: {S2JNode arguments: {S2JNode identifier: 'i'. S2JNode identifier: 'd'}};
		
		assertFails: '[]]';
		assertFails: '[[]';
		assertFails: '[::a]';
		assertFails: '[ :a | b';
		assertFails: '[ :a |||| b]';
		assertFails: '[ | :a | b]';
		assertFails: '[ || :a | b]';
		assertFails: '[ :a || b]';
		assertFails: '[ :a | :b  ]';
		assertFails: '[ :a || :b|]';
		assertFails: '[ :a | b| :a]';
		assertFails: '[ :a :1 | b]';
		assertFails: '[ aaaa"] ';
		assertFails: '[ "aaa"a"] ';
		assertFails: '[ "aaaa] '.! !

!OCParserTest methodsFor: 'test complex' stamp: 'lw 2/22/2011 17:41'!
testBraceExpression
	
	self
		currentRule: #braceExpression;
		
		assertMatches: '{}' andProducesNode: { };
		assertMatches: '  {  }   ' andProducesNode: { };
		assertMatches: '{1}' andProducesNode: {S2JNode expression: {S2JNode number: 1}};
		assertMatches: '  {  11 }  ' andProducesNode: {S2JNode expression: {S2JNode number: 11}};
		assertMatches: '  {  11. }  ' andProducesNode: {S2JNode expression: { S2JNode number: 11}};
		assertMatches: '{ 1.   2}' andProducesNode: {S2JNode expression: 
			{S2JNode number: 1}. S2JNode expression: { S2JNode number: 2 }};
		assertMatches: '{1.2}' andProducesNode: { S2JNode expression: { S2JNode number: 1.2 }};
		assertMatches: '{1. 2}' andProducesNode: { S2JNode expression: { S2JNode number: 1 }. 
			S2JNode expression: { S2JNode number: 2 }};
		assertMatches: '{1. ''.'' .}' andProducesNode: { S2JNode expression: { S2JNode number: 1}. 
			S2JNode expression: { S2JNode string: '.' }};
		assertMatches: '{1  .  2  .}' andProducesNode: { S2JNode expression: { S2JNode number: 1}. 
			S2JNode expression: { S2JNode number: 2 }};		
		
		assertFails: '.{}.';
		assertFails: '{1 .. 2}';
		assertFails: '{ 1  . 2 ..}';
		assertFails: '{.1.2}';
		assertFails: '{..1.}';
 		assertFails: '{ "bb}';
 		assertFails: '{ "b "   .  b"}'.! !

!OCParserTest methodsFor: 'test tokens' stamp: 'ag 12/9/2010 13:40'!
testByteArray
	
	self
		currentRule: #byteArray;
		
		assertMatches: '#[1]' andProducesNode: {1};
		assertMatches: '#  [  1  ]  ' andProducesNode: {1};
		assertMatches: '#[]' andProducesNode: {};
		assertMatches: '#   [1 2 3 ]' andProducesNode: {1. 2. 3.};
		assertMatches: '#[255 000 000 123 255]' andProducesNode: {255. 0. 0. 123. 255};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#[ 1';
		assertFails: '  #[ 1 ]';
		assertFails: '# [ 1.2 ]';
		assertFails: '#[ 256 1 00]';
		assertFails: '#[ -1 ]';
		assertFails: '#[ +1 ]';
		assertFails: '#[ #[ 1 ] ]  ';
		assertFails: '#( 255 )'.! !

!OCParserTest methodsFor: 'test complex' stamp: 'lw 2/22/2011 18:12'!
testCascadedExpression
	
	self
		currentRule: #cascadedExpression;
		assertMatches: 'Transcript  show:2;cr' andProducesNode: (S2JNode cascadedExpression:
				{ S2JNode identifier: 'Transcript'.  S2JNode keywordExpression: {#show: . S2JNode number: 2}. S2JNode unaryExpression: {#cr}});
		"assertMatches: 'Transcript  show:2 ""Comment"";cr' andProducesNode: (self node: 'cascadedExpression' with:
				{self node: 'identifier:' with:{'Transcript'}. self node: 'keywordExpression' with: {#show: . self node: 'number' with: {2}} .self node:'unarayExpression' with:{self node:'comment' with:{'Comment'} . #cr} } );" "comments are not yet stored correctly"

		assertFails: 'Transcript  show:2 "Comment;cr';				
		assertFails: 'Transcript show:1'.! !

!OCParserTest methodsFor: 'test tokens' stamp: 'ag 12/7/2010 11:14'!
testCharacter
	
	self
		currentRule: #character;
		
		assertMatches: '$c' andProducesNode: { $c };
		assertMatches: '$&' andProducesNode: { $& };
		assertMatches: '$ ' andProducesNode: { $ };
		assertMatches: '$`' andProducesNode: { $` };
		assertMatches: 'Character space' andProducesNode: { $  };
		
		assertFails: '';
		assertFails: ' ';
		assertFails: 'a';
		assertFails: '`';
		assertFails: ' $a';
		assertFails: '$$$';
		assertFails: '$  a';
		assertFails: '$av';
		assertFails: '$ a'.! !

!OCParserTest methodsFor: 'test general' stamp: 'LT 4/5/2011 15:12:15.129'!
testComments
	true ifTrue: [ ^ self ].
	self
		
		currentRule: #block;
		
		assertMatches: '"aaaaa" "aaa"[]'  andProducesNode: { S2JNode comments: {S2JNode comment: 'aaaaa'}. S2JNode comments: {S2JNode comment: 'aaa'}. S2JNode block: {}};
		assertMatches: '"aaaaa" ["a aa"]'  andProducesNode: { S2JNode comments: {S2JNode comment: 'aaaaa'}. S2JNode block: {S2JNode comments: {S2JNode comment: 'a aa'}} };
		assertMatches: '[ "a aaa"] '  andProducesNode: { S2JNode block: {S2JNode comments: {S2JNode comment: 'a aaa'}} };
		assertMatches: '"aaa"{ "bbb"}' andProducesNode: { S2JNode comments: {S2JNode comment: 'aaa'}. S2JNode braceExpression: { S2JNode comments: {S2JNode comment: 'bbb'}}};
		assertMatches: '# "adsd" eins "asdads"' andProducesNode: { S2JNode symbol: {S2JNode comments: {S2JNode comment: 'adsd'}. #eins}. S2JNode comments: {S2JNode comment: 'asdads'}};

		
		currentRule: #binaryExpression;
		assertMatches: '1 "Comment "* b' andProducesNode: (S2JNode binaryExpression: 
			{  S2JNode number: 1. S2JNode comments: {S2JNode comment: 'Comment '}. #*. 
			S2JNode identifier: 'b'}).! !

!OCParserTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:15'!
testExampleMethods
	
	super testExampleMethods! !

!OCParserTest methodsFor: 'test complex' stamp: 'lw 2/22/2011 17:53'!
testExpressionAssignment
	
	self
		currentRule: #expression;
		
		assertMatches: 'a' andProducesNode: { S2JNode identifier: 'a'};
		assertMatches: 'a := b' andProducesNode: { S2JNode identifier: 'b'. 
			 S2JNode identifier: 'a'};
		assertMatches: '  a   :=   b  ' andProducesNode: { S2JNode identifier: 'b'. 
			 S2JNode identifier: 'a'};
		assertMatches: 'a := b := c := 1' andProducesNode: { S2JNode number: 1. 
			 S2JNode identifier: 'a'. S2JNode identifier: 'b'. S2JNode identifier: 'c'};
		assertMatches: '  a    :=  b  :=  c :=   1' andProducesNode: {S2JNode number: 1. 
			 S2JNode identifier: 'a'. S2JNode identifier: 'b'. S2JNode identifier: 'c'};
		assertMatches: 'a _ b' andProducesNode: { S2JNode identifier: 'b'. 
			 S2JNode identifier: 'a'};
		assertMatches: 'a := 1';
		assertMatches: 'a := b := 1';
		assertMatches: 'a := b := c := d';
		assertMatches: '   a     :=      a     ';
		assertMatches: '   a     _   1 ';
		assertMatches: 'a:=1';
		assertMatches: 'a:=1.0';
		assertMatches: 'a:=b:=1.0';
		assertMatches: 'a_v_1';
		
		assertFails: 'a : = b';
		assertFails: ' := b';
		assertFails: 'a := ';
		assertFails: 'a := b :=';
		assertFails: 'a := b := 1 := a';
		assertFails: 'a := := b   ';
		assertFails: 'a _ _ b';
		assertFails: 'a __ b';
		assertFails: 'a :=:= b';
		assertFails: 'a := b v := a';
		assertFails: 'a  b := a ';
		assertFails: 'a := 1 := b';
		assertFails: 'a: := b';
		assertFails: 'a: _ b';
		assertFails: 'a :_ b';
		assertFails: 'a := 1 := 2:=f';
		assertFails: 'a __ b';
		assertFails: 'a : = b'.! !

!OCParserTest methodsFor: 'test tokens' stamp: 'LT 12/6/2010 11:22:53.039'!
testIdentifier
	
	self
		currentRule: #identifier;
		
		assertMatches: 'abc' andProducesNode: {'abc'};
		assertMatches: 'a1' andProducesNode: {'a1'};
		assertMatches: '1' andProducesNode: {'1'};
		assertMatches: 'aaaaaaaa1233333' andProducesNode: {'aaaaaaaa1233333'};
		assertMatches: '' andProducesNode: {''};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '|';
		assertFails: ':';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc:';
		assertFails: 'abc<<'.! !

!OCParserTest methodsFor: 'test tokens' stamp: 'ag 11/22/2010 11:30'!
testKeywordSelector
	
	self
		currentRule: #keyword;
		
		assertMatches: 'abc:' andProduces: #abc:;
		assertMatches: 'a1:' andProduces: #a1:;
		assertMatches: '1:' andProduces: #1:;
		assertMatches: 'aaaaaaaa1233333:' andProduces: #aaaaaaaa1233333:;
		assertMatches: ':' andProduces: #:;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc';
		assertFails: 'abc<<'.! !

!OCParserTest methodsFor: 'test complex' stamp: 'ag 12/13/2010 09:27'!
testMethod
	
	self
		currentRule: #method;
		
		assertFails: 'a |a| <p> |a|'. "Don't allow two temporaries-declarations"! !

!OCParserTest methodsFor: 'test tokens' stamp: 'LT 12/6/2010 11:22:08.233'!
testNumber
	
	self
		currentRule: #number;
		
		assertMatches: '1' andProducesNode: {1};
		assertMatches: '0' andProducesNode: {0};
		assertMatches: '123' andProducesNode: {123};
		assertMatches: '112345678' andProducesNode: {112345678};
		assertMatches: '000' andProducesNode: {0};
		assertMatches: '-000' andProducesNode: {0};
		assertMatches: '-1' andProducesNode: {-1};
		assertMatches: '-1.22' andProducesNode: {-1.22};
		assertMatches: '1.22e23' andProducesNode: {1.22e23};
		assertMatches: '122e23' andProducesNode: {12200000000000000000000000};
		assertMatches: '35r35' andProducesNode: {35r35};
		assertMatches: '-35r35' andProducesNode: {-35r35};
		assertMatches: '22r12.12' andProducesNode: {22r12.12};
		assertMatches: '22r12.12e12' andProducesNode: {22r12.12e12};
		assertMatches: '-22r-12.12e12' andProducesNode: {-22r-12.12e12};
		assertMatches: '22r-12.12e12' andProducesNode: {22r-12.12e12};
		assertMatches: '-22r12.12e12' andProducesNode: {-22r12.12e12};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '+1';
		assertFails: '+1.2';
		assertFails: '+23r23.3';
		assertFails: '+23r+233.3';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: 'abc';
		assertFails: '<<'.! !

!OCParserTest methodsFor: 'test complex' stamp: 'ag 12/7/2010 15:35'!
testPrimitiveDeclaration
	
	self
		currentRule: #primitiveDeclaration;
		
		assertMatches: '<a:1b:1>';
		assertMatches: '<a>';
		assertMatches: '<  a>';
		assertMatches: '  <  a  >';
		assertMatches: '< | 1>';
		assertMatches: '< == 2>';
		assertMatches: '<  var: ''anc'' >';
		assertMatches: '< & ''add''>';
		assertMatches: '< abc: 22 dfe: 23>';
		
		assertFails: '<1>';
		assertFails: '< 1 2 >';
		assertFails: '<a: 1 1>';
		"assertFails: '<v: d>';" "These should not match, but match currently. Never mind, is not allowed by the compiler"
		"assertFails: '<d: 2 d: e>';"
		"assertFails: '< | d >';"
		assertFails: '<''2''>';
		assertFails: '<| 1>';
		assertFails: '<< 2>';
		assertFails: '< > 2>';
		assertFails: '<> 2>';
		assertFails: '< a: 2 ';
		assertFails: '< a ';
		assertFails: '< | 2 '.! !

!OCParserTest methodsFor: 'test tokens' stamp: 'lw 2/22/2011 17:50'!
testReservedWord
	
	self
		currentRule: #statements;
		
		assertConverting: '1 a; b: self; c' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. self}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. nil}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. true.nil,true}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. true.nil,true}' containsNodeNamed: 'reservedWord';
		assertConverting: '{true|nil,true}' containsNodeNamed: 'reservedWord';
		assertConverting: '{1. true.nil.{true}}' containsNodeNamed: 'reservedWord';
		denyConverting: '{1. self2. true12}' containsNodeNamed: 'reservedWord';
		denyConverting: '{1. aNself}' containsNodeNamed: 'reservedWord';
		denyConverting: '#(1 self super)' containsNodeNamed: 'reservedWord';
		assertConverting: '#(true)' containsNodeNamed: 'reservedWord';
		
		currentRule: #primary;
		
		assertConverting: '(self)' containsNodeNamed: 'reservedWord';
		assertConverting: '(self/1)' containsNodeNamed: 'reservedWord';
		assertConverting: '([self])' containsNodeNamed: 'reservedWord';
		assertConverting: '([self.])' containsNodeNamed: 'reservedWord';
		assertMatches: '(self2)' andProduces: (S2JNode paranthesizedExpression: { S2JNode identifier: 'self2' });
		denyConverting: '([self2])' containsNodeNamed: 'reservedWord'.! !

!OCParserTest methodsFor: 'test complex' stamp: 'ag 12/7/2010 15:53'!
testStatements

	"TODO Not complete test !! Write more !! " 
	
	self
		currentRule: #statements;
		nilResultAllowed: true;
		
		assertMatches: '...';
		assertMatches: 'a. b. ^ c';
		assertMatches: 'a.b.c';
		assertMatches: '1 a. b d: d d: 1. 2. ^ a d: d f: 2';
		assertMatches: '  a  .  b   .. . . . .. . . . .   c.  ^ 1.';
		
		assertFails: ' a. ^ 1...';
		assertFails: ' 1. a ^ 1';
		assertFails: '^ d d. 1';
		assertFails: '^ .';
		assertFails: '^....';
		assertFails: '^^'.! !

!OCParserTest methodsFor: 'test tokens' stamp: 'lw 2/22/2011 17:49'!
testString
	
	self
		currentRule: #string;
		
		assertMatches: '''a''' andProduces: (S2JNode string: 'a');
		assertMatches: '''''' andProduces: (S2JNode string: '');
		assertMatches: '''123''' andProduces: (S2JNode string: '123');
		assertMatches: ''' '''' '''' ''' andProduces: (S2JNode string: ' '' '' ');
		assertMatches: '''''''123''' andProduces: (S2JNode string: '''123');
		assertMatches: '''    ''' andProduces: (S2JNode string: '    ');
		assertMatches: '''"$%&''' andProduces: (S2JNode string: '"$%&');
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '#abc';
		assertFails: ''' ''a';
		assertFails: ' ''''';
		assertFails: 'a''''';
		assertFails: '''as';
		assertFails: 'as''';
		assertFails: ''' '' ''';
		assertFails: '''a '' a''';
		assertFails: '''/'.! !

!OCParserTest methodsFor: 'test tokens' stamp: 'ag 12/7/2010 17:32'!
testSymbol
	
	"TODO extend test, if stringS2J gets extended to support '' inside of a string"
	
	self
		currentRule: #symbol;
		
		assertMatches: '#abc' andProducesNode: {#abc};
		assertMatches: '# ''''' andProducesNode: {#''};
		assertMatches: '#   abc' andProducesNode: {#  abc};
		assertMatches: '#abc1' andProducesNode: {#abc1};
		assertMatches: '#a' andProducesNode: {#a};
		assertMatches: '#''a''' andProducesNode: {#a};
		assertMatches: '#''a b c''' andProducesNode:  {#'a b c'};
		assertMatches: '#''''' andProducesNode: {#''};
		assertMatches: '#''123''' andProducesNode:  {#'123'};
		assertMatches: '#''    ''' andProducesNode: {#'    '};
		assertMatches: '#''"$%&''' andProducesNode: {#'"$%&'};
		assertMatches: '#abc1:' andProducesNode: {#abc1:};
		assertMatches: '#|' andProducesNode: {#|};
		assertMatches: '#-&&' andProducesNode: {#-&&};
		assertMatches: '#-' andProducesNode: {#-};
		assertMatches: '#a:b:c1' andProducesNode: {#a:b:c1};
		assertMatches: '#:' andProducesNode: {#:};
		
		assertFails: '';
		assertFails: ' ';
		assertFails: 'abc';
		assertFails: '#1abc';
		assertFails: '#""';
		assertFails: '#'' ''a';
		assertFails: '#a''''';
		assertFails: '#''as';
		assertFails: '#as''';
		assertFails: '#'' '' ''';
		assertFails: '#''a '' a''';
		assertFails: '#123';
		assertFails: '###';
		assertFails: '#''/'.! !

!OCParserTest methodsFor: 'test complex' stamp: 'lw 2/22/2011 17:48'!
testUnaryExpression
	
	self
		currentRule: #unaryExpression;
		
		assertMatches: 'a b' andProducesNode: { S2JNode identifier: 'a'. #b };
		assertMatches: '1 b' andProducesNode: { S2JNode number: 1. #b };
		assertMatches: 'a b c' andProducesNode: { S2JNode unaryExpression: { S2JNode identifier: 'a'. #b }. #c };
		assertMatches: ' a  b c d ' andProducesNode: { S2JNode unaryExpression: { S2JNode unaryExpression: { S2JNode identifier: 'a'. #b }. #c }. #d };
		assertMatches: '   ''abc''    b1     ' andProducesNode: { S2JNode string: 'abc'. #b1 };
		
		assertFails: '';
		assertFails: '  ';
		assertFails: 'a';
		assertFails: '  a  ';
		assertFails: 'a  1';
		assertFails: 'a b 1';
		assertFails: 'a || b';
		assertFails: 'a % b';
		assertFails: 'a -|';
		assertFails: 'a b > a';
		assertFails: 'a unary>'.! !

!OCParserTest methodsFor: 'test tokens' stamp: 'ag 12/7/2010 10:08'!
testUnarySelector
	"Would be cool to find all the unary messages in the image and test them..."
	
	self
		currentRule: #unarySelector;
		
		assertMatches: 'abc' andProduces: #abc;
		assertMatches: 'a1' andProduces: #a1;
		assertMatches: '1' andProduces: #1;
		assertMatches: 'aaaaaaaa1233333' andProduces: #aaaaaaaa1233333;
		assertMatches: '' andProduces: #;
		
		assertFails: '';
		assertFails: ' ';
		assertFails: '|';
		assertFails: ':';
		assertFails: '#abc';
		assertFails: '1abc';
		assertFails: '123';
		assertFails: 'abc';
		assertFails: 'abc:';
		assertFails: 'abc<<'.! !

OCAbstractTest subclass: #OCSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OCSerializationTest methodsFor: 'testing' stamp: 'ag 3/31/2011 10:04'!
assert: objectTree isSerializedTo: jsCode
	
	self assert: jsCode = objectTree serializeToJavaScript.! !

!OCSerializationTest methodsFor: 'testing' stamp: 'ag 3/31/2011 10:09'!
testNestedObjectSerialization
	
	| var1 var2 var3 |
	var1 := S2JSerializationTestObject new.
	var2 := S2JSerializationTestObject new.
	var3 := S2JSerializationTestObject new.
	var1 otherObject: var2.
	var2 otherObject: var3.
	var3 otherObject: var1.
	self
		assert: var1
		isSerializedTo: 
			'(function(){var obj3=S2JSerializationTestObject._newInstance();',
			'var obj2=S2JSerializationTestObject._newInstance();',
			'var obj1=S2JSerializationTestObject._newInstance();',
			'obj3.$otherObject=obj1;',
			'obj2.$otherObject=obj3;',
			'obj1.$otherObject=obj2;',
			'return obj1;})()'.! !

!OCSerializationTest methodsFor: 'testing' stamp: 'ag 3/31/2011 10:27'!
testObjectSerialization
	
	self
		assert: (1)
		isSerializedTo: '(function(){var obj1=number(1);return obj1;})()';
		
		assert: ({})
		isSerializedTo: '(function(){var obj1=_Array._newInstance();obj1.original$=[];return obj1;})()';
		
		assert: ({1. 'a'})
		isSerializedTo: '(function(){var obj3=string("a");var obj2=number(1);var obj1=_Array._newInstance();obj1.original$=[obj2, obj3];return obj1;})()';
		
		assert: (nil)
		isSerializedTo: '(function(){var obj1=nil;return obj1;})()'.! !

!OCSerializationTest methodsFor: 'testing' stamp: 'ag 4/4/2011 09:58'!
testSlotObjectSerialization
	
	self
		assert: ({} asObject)
		isSerializedTo: '(function(){var obj1={};_unboxSlotObject(obj1);return obj1;})()';
		
		assert: ({#a -> 1. #b -> 2} asObject)
		isSerializedTo: '(function(){var obj3=number(2);var obj2=number(1);var obj1={};obj1.a=obj2;obj1.b=obj3;_unboxSlotObject(obj1);return obj1;})()'.! !

OCAbstractTest subclass: #OCSqueakAstToJsAstTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OCSqueakAstToJsAstTest class methodsFor: 'testing' stamp: 'ag 12/9/2010 13:19'!
converterClass
	
	^ S2JSqueakAstToJsAst! !

!OCSqueakAstToJsAstTest methodsFor: 'test stories' stamp: 'lw 2/22/2011 19:38'!
testBlockArgument
	
	self
		currentRule: #block;
		
		assertMatches: '[]' 
		andProduces: (S2JNode functionCall: 
			{nil. 'block'. S2JNode arguments: 
				{S2JNode functionDeclaration: {S2JNode arguments. S2JNode functionContent: {}}}});
		
		assertMatches: '[1]' 
		andProduces: (S2JNode functionCall:  
			{nil. 'block'. S2JNode arguments: 
				{S2JNode functionDeclaration: 
					{ S2JNode arguments. 
					S2JNode functionContent: 
						{ S2JNode returnExpression: 
							{ S2JNode functionCall: 
								{ nil. 'number'. 
								S2JNode arguments: { S2JNode number: 1 }}}}}}});
								
		assertMatches: '[^''1'']' 
		andProduces: (S2JNode functionCall:  
			{nil. 'block'. S2JNode arguments: 
				{S2JNode functionDeclaration: 
					{ S2JNode arguments. 
					S2JNode functionContent: 
						{ S2JNode expression: 
							{ S2JNode functionCall: 
								{ nil.
								'nonLocalReturn'.
								S2JNode arguments: 
									{ S2JNode functionCall: 
										{ nil.
										'string'. 
										S2JNode arguments: {S2JNode string:  '1' }}}}}}}}});
		
		assertMatches: '[:a]' 
		andProduces: (S2JNode functionCall: 
			{nil. 'block'. S2JNode arguments: 
				{S2JNode functionDeclaration: {S2JNode arguments: { S2JNode identifier: 'a' }. S2JNode functionContent: {}}}}).! !

!OCSqueakAstToJsAstTest methodsFor: 'test general' stamp: 'ag 12/13/2010 09:15'!
testExampleMethods
	
	super testExampleMethods! !

!OCSqueakAstToJsAstTest methodsFor: 'test treequality' stamp: 'ag 3/29/2011 10:12'!
testNestedExpressions

	self 
		currentRule: #expression;
		
		assertMatches: (S2JNode expression) 
		andProduces: (S2JNode expression);
		
		assertMatches: (S2JNode expression: {S2JNode expression}) 
		andProduces: (S2JNode expression);
		
		assertMatches: (S2JNode expression: 
			{S2JNode expression. S2JNode identifier: 'a'}) 
		andProduces: (S2JNode expression: {S2JNode identifier: 'a'});
			
		assertMatches: (S2JNode expression: {S2JNode returnExpression: {}}) 
		andProduces: (S2JNode returnExpression: {})! !

!OCSqueakAstToJsAstTest methodsFor: 'test stories' stamp: 'lw 2/22/2011 17:42'!
testNonLocalReturn
	
	self
		currentRule: #block;
		
		assertMatches: 
			'[ [^ ''returned nonlocally''] value ]'
		 andProduces: (S2JNode functionCall: 
			{nil.
			'block'.
			S2JNode arguments: 
				{S2JNode functionDeclaration: 
					{ S2JNode arguments.
					S2JNode functionContent: 
						{S2JNode returnExpression: 
						{S2JNode functionCall: 
							{ S2JNode functionCall: 
								{nil. 
								'block'.
								S2JNode arguments: 
									{S2JNode functionDeclaration: 
										{S2JNode arguments.
										S2JNode functionContent:
											{ S2JNode expression: 
												{ S2JNode functionCall: 
													{nil. 
													'nonLocalReturn'. 
													S2JNode arguments: 
														{ S2JNode functionCall: 
															{ nil. 
															'string'. 
															S2JNode arguments: {S2JNode string: 'returned nonlocally'}}}}}}}}}.
							'value'. S2JNode arguments}}}}}})
		
		
	"expected JavaScript: block(function(){return block(function(){nonLocalReturn('returned nonlocally')}).value() }, this)"! !

OCAbstractTest subclass: #OCTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OCTranslatorTest class methodsFor: 'testing' stamp: 'LT 2/24/2011 15:45:24.518'!
converterClass
	
	^ S2JPrinter! !

!OCTranslatorTest class methodsFor: 'testing' stamp: 'lw 2/21/2011 13:17'!
defaultCurrentRule
	
	^ #doItSnippet! !

!OCTranslatorTest methodsFor: 'test stories' stamp: 'LT 2/24/2011 15:50:24.948'!
testAddition
	
	self
		assertMatches: '3+4'
		andProduces: 'number(3)._plus(number(4))'.! !

!OCTranslatorTest methodsFor: 'test branch' stamp: 'ag 3/29/2011 10:23'!
testCascades

	self 
		assertMatches: 'a b; c' andProduces:  
'(function(){var cascadeReceiver$=a;cascadeReceiver$.b();return cascadeReceiver$.c();}).apply(this)';

		assertMatches: 'a slot: b; slot: c' andProduces: 
 '(function(){var cascadeReceiver$=a;cascadeReceiver$.slot_(b);return cascadeReceiver$.slot_(c);}).apply(this)';

		assertMatches: 'a slot: b be: d; slot: c be: d' andProduces: 
 '(function(){var cascadeReceiver$=a;cascadeReceiver$.slot_be_(b, d);return cascadeReceiver$.slot_be_(c, d);}).apply(this)';

		assertMatches: '^ Object new slot: injection be: ''infovis''; yourself' andProduces: 
 'return (function(){var cascadeReceiver$=_Object._new();cascadeReceiver$.slot_be_(injection, string("infovis"));return cascadeReceiver$.yourself();}).apply(this)'.! !

!OCTranslatorTest methodsFor: 'test stories' stamp: 'ag 3/29/2011 10:50'!
testLoop
	
	self
		assertMatches: '{1. 2. 3} do: [:elem | Js Global alert value: elem]'
		andProduces: 'array([number(1), number(2), number(3)]).do_(block(function(elem){return Js.Global().alert().value_(elem);}))';
		
		assertMatches: 'arr do: [:elem | Js Global alert value: elem ]'
		andProduces: 'arr.do_(block(function(elem){return Js.Global().alert().value_(elem);}))';
		
		assertMatches: 'arr do: block'
		andProduces: 'arr.do_(block)'.! !

!OCTranslatorTest methodsFor: 'test stories' stamp: 'ag 3/29/2011 10:52'!
testNonLocalReturn
	
	self
		assertMatches: '
			[ Js Global alert value: ''outer''.
			[Js Global alert value: ''inner''.
			 ^self].
			Js Global alert value: ''end'' ]'
		andProduces: 
'block(function(){Js.Global().alert().value_(string("outer"));block(function(){Js.Global().alert().value_(string("inner"));nonLocalReturn(this);});return Js.Global().alert().value_(string("end"));})'! !

!OCTranslatorTest methodsFor: 'test stories' stamp: 'lw 2/21/2011 13:21'!
testSelectorTranslation
	
	| assertBlock |
	assertBlock := [ :squeakSelector :jsFunctionname  | 
		self assert: jsFunctionname equals: (S2JSqueakAstToJsAst jsFunctionNameFor: squeakSelector).].
	
	assertBlock
		value: 'do:forDuration:' value: 'do_forDuration_';
		value: 'do:' value: 'do_';
		value: 'do' value: '_do';
		value: '*+' value: '_times_plus';
		value: '++' value: '_plus_plus'.! !

!OCTranslatorTest methodsFor: 'test stories' stamp: 'ag 3/29/2011 10:54'!
testTrueFalse

	self 
		assertMatches: '10 < 5 ifTrue: [ Js Global alert value: ''small'' ] ifFalse: [ Js Global alert value: ''big'' ]'
		andProduces:
'number(10)._less(number(5)).ifTrue_ifFalse_(block(function(){return Js.Global().alert().value_(string("small"));}), block(function(){return Js.Global().alert().value_(string("big"));}))'! !

!OCTranslatorTest methodsFor: 'test printing' stamp: 'LT 2/24/2011 15:45:50.248'!
testVarDeclaration
	
	self 
		assertMatches: '|a b c|'
		andProduces: 'var a;var b;var c'! !

OCTestCase subclass: #OCCodeCleanTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OCCodeCleanTest methodsFor: 'tests' stamp: 'ag 2/3/2011 12:05'!
testNoDirtyCategories
	
	self assert: (Utilities classesWithDirtyCategories isEmpty)! !

!OCCodeCleanTest methodsFor: 'tests' stamp: 'ag 2/3/2011 12:04'!
testNoEmptyCategories
	
	self assert: (Utilities classesWithEmptyCategories isEmpty)! !

OCTestCase subclass: #OCCodeFactoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OCCodeFactoryTest methodsFor: 'test methods' stamp: 'ag 12/16/2010 11:21'!
aTestMethod
	
	"Empty method for tests"! !

!OCCodeFactoryTest methodsFor: 'test methods' stamp: 'ag 12/16/2010 11:23'!
aTestMethod2
	
	"Empty method for tests"! !

!OCCodeFactoryTest methodsFor: 'test methods' stamp: 'LT 3/16/2011 14:48:46.253'!
aTestMethod3
	
	self error: 'testMethod: do not call'.
	self this is only a test message.
	
	"used in testTranslatedMethodContainsAllUsedMessages" ! !

!OCCodeFactoryTest methodsFor: 'helpers' stamp: 'ag 12/16/2010 11:15'!
codeFactory
	"Skip the singleton-pattern"
	
	^ S2JCodeFactory new! !

!OCCodeFactoryTest methodsFor: 'helpers' stamp: 'LT 3/16/2011 14:51:18.709'!
getTestMethod: aSymbol
	
	^ S2JOMeta2 method: aSymbol of: self class! !

!OCCodeFactoryTest methodsFor: 'helpers' stamp: 'ag 1/5/2011 22:57'!
methodNumIn: aClass
	
	^ aClass methodDict size + aClass class methodDict size! !

!OCCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 1/6/2011 11:06'!
testCaching
	
	| factory |
	factory := self codeFactory.
	self assert: factory codeCache size == 0.
	factory codeForMethod: #aTestMethod of: self class.
	self assert: factory codeCache size == 1.
	factory codeForMethod: #aTestMethod of: self class.
	self assert: factory codeCache size == 1.
	factory codeForMethod: #aTestMethod2 of: self class.
	self assert: factory codeCache size == 2.
	factory codeForClass: self class.
	factory codeFor: self class. "If already cached, this works, too"
	self assert: factory codeCache size == ((self methodNumIn: self class) + 1).
	
	factory := self codeFactory.
	factory codeFor: '1 a'.
	self assert: factory codeCache size == 1.
	factory codeFor: '1 a'.
	factory codeFor: '1 a'.
	self assert: factory codeCache size == 1.
	factory codeFor: '1 a; b'.
	factory codeFor: '1 a; b'.
	self assert: factory codeCache size == 2.! !

!OCCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 1/5/2011 22:58'!
testCachingClasses
	
	| factory |
	factory := self codeFactory.
	factory codeForClass: self class.
	self assert: factory codeCache size = (self class methodDict size + 1).
	factory codeForClasses: { self class. S2JNode }.
	self assert: 
		factory codeCache size = 
		((self methodNumIn: self class) + (self methodNumIn: S2JNode) + 3). "Methods + 2 classes + 1 class-array"! !

!OCCodeFactoryTest methodsFor: 'test cases' stamp: 'ag 12/16/2010 21:20'!
testCachingWithRecompile
	
	| factory size |
	factory := self codeFactory.
	factory codeForClass: self class.
	size := factory codeCache size.
	self class compileAll.
	factory codeForClass: self class.
	self assert: size == factory codeCache size.! !

!OCCodeFactoryTest methodsFor: 'test cases' stamp: 'LT 3/16/2011 14:51:58.514'!
testEqualsBlock
	
	| factory block antiBlock method1 method2 |
	factory := self codeFactory.
	block := [ :o1 :o2 | self assert: (factory compareCacheKey: o1 to: o2)].
	antiBlock := [ :o1 :o2 | self deny: (factory compareCacheKey: o1 to: o2)].
	
	block
		value: 'abc' value: 'abc';
		value: (self getTestMethod: #aTestMethod) value: (self getTestMethod: #aTestMethod);
		value: self class value: self class.
	antiBlock
		value: 'abc1' value: 'abc2';
		value: self class value: Object;
		value: 1 value: 2;
		value: 1 value: '1';
		value: (self getTestMethod: #aTestMethod) value: (S2JOMeta2 method: #asString of: Object);
		value: (self getTestMethod: #aTestMethod) value: (self getTestMethod: #aTestMethod2).
	
	method1 := (self getTestMethod: #aTestMethod).
	self class compileAll.
	method2 := (self getTestMethod: #aTestMethod).
	self deny: method1 == method2. "Should be new objects after recompiling!!"
	block value: method1 value: method2.! !

!OCCodeFactoryTest methodsFor: 'test cases' stamp: 'lw 3/28/2011 17:55'!
testTranslatedMethodContainsAllUsedMessages

	| codeFactory cacheEntry |
	codeFactory := self codeFactory.
	cacheEntry := codeFactory cacheObjectForMethod: (self getTestMethod: #aTestMethod3).
	self assert: cacheEntry calledFunctions size = 8.
	self assert: (cacheEntry calledFunctions includesAllOf: { #'error_'. #'_this'. #'_is'. #only. #a. #test. #message. #string}).
	self assert: (cacheEntry calledFunctions keys includesAllOf: { #'error:'. #'this'. #'is'. #only. #a. #test. #message. #string})
! !

OCTestCase subclass: #OCJavascriptTest
	instanceVariableNames: 'semaphore clientTestResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

OCJavascriptTest class
	instanceVariableNames: 'currentTestCase'!

!OCJavascriptTest commentStamp: 'ag 1/26/2011 15:16' prior: 0!
This Test starts the browser with the url of the S2JTestApp.
Then it waits for the test-results from the browser.!

OCJavascriptTest class
	instanceVariableNames: 'currentTestCase'!

!OCJavascriptTest class methodsFor: 'accessing' stamp: 'ag 1/31/2011 12:31'!
currentTestCase
	^ currentTestCase! !

!OCJavascriptTest class methodsFor: 'accessing' stamp: 'ag 1/31/2011 12:31'!
currentTestCase: anObject
	currentTestCase := anObject! !

!OCJavascriptTest class methodsFor: 'waiting' stamp: 'lw 2/19/2011 19:51'!
reportJSResult: aString
	"If we currently are executing a test-case, it gets notified."
	
	self currentTestCase notNil & self isOnCIServer ifTrue: [ self currentTestCase clientResponded: aString ].
	^ ''! !

!OCJavascriptTest class methodsFor: 'waiting' stamp: 'srv 1/31/2011 22:35'!
reportJSResults: aString
	"If we currently are executing a test-case, it gets notified."
	
	self currentTestCase notNil & self isOnCIServer ifTrue: [ self currentTestCase clientResponded: aString ].
	^ ''! !

!OCJavascriptTest class methodsFor: 'waiting' stamp: 'lw 2/19/2011 19:53'!
reportJSResults: failed and: errors
	"If we currently are executing a test-case, it gets notified."
	
	self currentTestCase notNil & self isOnCIServer ifTrue: [ self currentTestCase clientResponded: { failed. errors} ].
	^ ''! !

!OCJavascriptTest class methodsFor: 'accessing' stamp: 'ag 1/31/2011 12:30'!
retryTime
	" in seconds "
	
	^ 120! !

!OCJavascriptTest methodsFor: 'helpers' stamp: 'ag 2/3/2011 13:00'!
clientResponded: aString
	
	self clientTestResult: aString.
	self semaphore signal.! !

!OCJavascriptTest methodsFor: 'accessing' stamp: 'ag 2/3/2011 13:00'!
clientTestResult
	^ clientTestResult! !

!OCJavascriptTest methodsFor: 'accessing' stamp: 'ag 2/3/2011 13:00'!
clientTestResult: anObject
	clientTestResult := anObject! !

!OCJavascriptTest methodsFor: 'helpers' stamp: 'srv 1/27/2011 16:48'!
killFireFox
	
	CommandShell command: 'pkill firefox;exit'! !

!OCJavascriptTest methodsFor: 'testing' stamp: 'ag 2/3/2011 12:57'!
performTest: url tryAgain: tryAgain
	
	^ self performTest: url tryAgain: tryAgain doing: []! !

!OCJavascriptTest methodsFor: 'testing' stamp: 'ag 2/3/2011 16:00'!
performTest: url tryAgain: tryAgain doing: aBlock
	
	self runFireFox: url.
	(Delay forSeconds: 3) wait.
	aBlock value.
	(self semaphore waitTimeoutSeconds: self class retryTime) 
		ifTrue: [
			self killFireFox.
			tryAgain ifTrue: [ self performTest: url tryAgain: false doing: aBlock] ] "have a second try, because sometimes the bodys onload is not evaluated"
		ifFalse: [ ^ self clientTestResult ].
	self error: 'No answer from the Javascript-side'.! !

!OCJavascriptTest methodsFor: 'helpers' stamp: 'ag 2/3/2011 12:48'!
runFireFox: url

	CommandShell command: 'firefox -P JSTests ', url, ';exit'! !

!OCJavascriptTest methodsFor: 'accessing' stamp: 'lw 1/27/2011 05:07'!
semaphore
	^ semaphore! !

!OCJavascriptTest methodsFor: 'accessing' stamp: 'lw 1/27/2011 05:07'!
semaphore: anObject
	semaphore := anObject! !

!OCJavascriptTest methodsFor: 'running' stamp: 'ag 2/3/2011 13:09'!
setUp
	
	self class isOnCIServer ifTrue: [
		S2JDispatcher forcedRestart.
		self clientTestResult: nil.
		self semaphore: Semaphore new.
		self class currentTestCase: self ].! !

!OCJavascriptTest methodsFor: 'running' stamp: 'ag 1/31/2011 12:32'!
tearDown
	
	self class isOnCIServer ifTrue: [
		self killFireFox.
		self class currentTestCase: nil ].! !

!OCJavascriptTest methodsFor: 'testing' stamp: 'lw 2/19/2011 20:00'!
testClientside
	
	self class isOnCIServer ifTrue: [ | result |
		result := (self performTest: 'http://localhost:8887/test' tryAgain: true ).
		(result at: 2) = '0' ifFalse: [ self error: 'One of the JS-Tests ended with an error. For more details visit http://localhost:8887/test/'].
		self assert: 0 = (result at: 1) asInteger ].! !

!OCJavascriptTest methodsFor: 'testing' stamp: 'srv 2/15/2011 11:51'!
testOnServerBlock
	
	"TODO test commented out, because communication required bootstrap.js and classes, which are not loaded yet"
	
	false & (self class isOnCIServer) ifTrue: [
		self assert: 
			'abc123' =
			(self
				performTest: 'http://localhost:8887/emptyTest'
				tryAgain: true
				doing: [ S2JEmptyTestApp sendCode: '[ S2JJavascriptTest js reportJSResults: S2JmockTestResult ] onServer value' ] ) ].! !

!OCJavascriptTest methodsFor: 'testing' stamp: 'srv 2/15/2011 11:50'!
testSendCode
	
	"TODO test commented out, because communication required bootstrap.js and classes, which are not loaded yet"
	
	false & (self class isOnCIServer) ifTrue: [
		self assert: 
			'abc123' =
			(self
				performTest: 'http://localhost:8887/emptyTest'
				tryAgain: true
				doing: [ S2JEmptyTestApp sendCode: 'S2JServer js performOnServer: '' S2JJavascriptTest js reportJSResults: S2JmockTestResult ''' ] ) ].! !

OCTestCase subclass: #OCSwazooTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

OCSwazooTests subclass: #OCCometHandlerTests
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OCCometHandlerTests methodsFor: 'accessing' stamp: 'HK 1/5/2011 16:57'!
client
	^ client! !

!OCCometHandlerTests methodsFor: 'accessing' stamp: 'HK 1/5/2011 16:57'!
client: anObject
	client := anObject! !

!OCCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'SW 1/25/2011 11:16'!
killClient

	self client timeStampOfLatestRequest: TimeStamp now - S2JCometClient defaultMaximumAge! !

!OCCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'SW 1/25/2011 12:04'!
setUp

	self client: S2JCometClient new.
	self client application: (S2JTestApp instance reset );
			    identifier: (S2JCometHandler newFor: self client application ) generateIdentifier.
	self client application addClient: self client.
		
! !

!OCCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'SW 1/25/2011 11:38'!
testClientMatchingAtCometHandler

	client := (S2JCometHandler newFor: (S2JTestApp instance)) findClientById: self client identifier.
	self assert: ( client = self client).
	! !

!OCCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'ag 2/16/2011 18:24'!
testCreateNewId
	| oldCount newCount response path |
	
	oldCount := self client application clients size.
	path := S2JTestApp uniquePath, S2JCometHandler pathSuffix.	
	response := S2JDispatcher new answerTo: (self basicGetFor: path).
	self assert: response notNil.
	self assert: (response statusCode = 202).
	newCount := self client application clients size.
	self assert: newCount = (oldCount + 1)! !

!OCCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'SW 1/25/2011 11:23'!
testDeathAfterMaximumAge 

	self killClient.
	self deny: self client isAlive ! !

!OCCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'SW 1/26/2011 09:23'!
testDispatchApplicationAndCreateCometClient
	
	| clientId response path |

	path := S2JTestApp uniquePath,'/', S2JCometHandler pathSuffix.
	response := S2JDispatcher new answerTo: (self basicGetFor: path).
	clientId := response body asString.
	
	self client: ((S2JCometHandler newFor: S2JTestApp instance ) findClientById: clientId).
	self assert: (self client notNil).
	self assert: (self client isAlive).
! !

!OCCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'SW 1/25/2011 14:50'!
testForwardingCometHandler

	| request path response |
	
	path := S2JTestApp uniquePath, S2JCometHandler pathSuffix, '?id=', self client identifier.
	request :=  self basicGetFor: path. 
	
	self client application repository addContent: 'test'.
	response := (S2JCometHandler newFor: (S2JTestApp instance)) answerTo: request. 

	self assert: (response body asString = 'test').
! !

!OCCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'SW 1/19/2011 10:17'!
testIsInitiallyAlive


	self assert: self client isAlive! !

!OCCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'SW 1/25/2011 14:50'!
testQueriesKeepAlive
	| path response |
	
	self client timeStampOfLatestRequest: (TimeStamp now - (Duration seconds: 2)).
	path := S2JTestApp uniquePath, S2JCometHandler pathSuffix , '?id=', self client identifier.

	[ response := S2JDispatcher new answerTo: (self basicGetFor: path) ] fork.
	(Delay forSeconds: 2) wait.
	self assert: self client isAlive.
	self killClient.
	! !

!OCCometHandlerTests methodsFor: 'as yet unclassified' stamp: 'SW 1/26/2011 09:23'!
testRemoveDeadClient

	| clientId response path |
	
	path := S2JTestApp uniquePath, '/', S2JCometHandler pathSuffix , '?id=', self client identifier.
	[ (Delay forSeconds: 1) wait.
		 self killClient.
	] fork.
	response := S2JDispatcher new answerTo: (self basicGetFor: path).
	self assert: (response statusCode = S2JCometClient HTTPStatusCodeTimeOut).
	self assert: ((S2JCometHandler newFor: (S2JTestApp instance)) findClientById: clientId) isNil.! !

OCSwazooTests subclass: #OCDispatcherTests
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OCDispatcherTests methodsFor: 'as yet unclassified' stamp: 'SW 1/25/2011 14:50'!
testDispatchVirginCometRequest

	| response path httpRequest |
	
	path := S2JTestApp uniquePath, S2JCometHandler pathSuffix.
	httpRequest :=	(self basicGetFor: path).
	response := S2JDispatcher new answerTo: httpRequest.
	
	self assert: (response body asString isAllDigits ).! !

!OCDispatcherTests methodsFor: 'as yet unclassified' stamp: 'hk 4/5/2011 11:16'!
testDispatchVirginWebSocketRequest

	| response path httpRequest |
	
	path := S2JTestApp uniquePath, S2JWebSocketHandler pathSuffix.
	httpRequest :=	(self basicWSFor: path).
	response := S2JDispatcher new answerTo: httpRequest.
	
	self assert: (response body asString isAllDigits).! !

!OCSwazooTests methodsFor: 'as yet unclassified' stamp: 'SW 1/31/2011 08:52'!
arrayFromHexString: aString
	| array stream lookup |
	lookup := '123456789ABCDEF'.
	array := ByteArray new: aString size // 2.
	stream := aString readStream.
	1 to: array size do: [ :i || h l |
		h := stream next.
		h := h = $0 ifTrue: [0] ifFalse: [lookup indexOf: h].
		l := stream next.
		l := l = $0 ifTrue: [0] ifFalse: [lookup indexOf: l].
		array at: i put: ((h bitShift: 4) bitOr: l) ].
	^array! !

!OCSwazooTests methodsFor: 'as yet unclassified' stamp: 'ag 2/16/2011 18:29'!
basicGetFor: aPath

	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET localhost:8887/', aPath, ' HTTP/1.1';
		nextPutLine: 'Host: localhost';
		nextPutLine: 'Connection: Keep-Alive';
		crlf.
	^ HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents).! !

!OCSwazooTests methodsFor: 'as yet unclassified' stamp: 'SW 1/31/2011 09:08'!
basicWSFor: aPath

	| requestStream request|
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET ', aPath, ' HTTP/1.1';
		nextPutLine: 'Host: example.com';
		nextPutLine: 'Connection: Upgrade';
		nextPutLine: 'Sec-WebSocket-Key2: 8 1 8 6    7 ]   8476';
		nextPutLine: 'Sec-WebSocket-Protocol: sample';
		nextPutLine: 'Upgrade: WebSocket';
		nextPutLine: 'Sec-WebSocket-Key1: 2  __4 ''79  #  9"; +K 67  -655';
		nextPutLine: 'Origin: http://example.com';
		nextPutLine: 'Content-Length: 8';
		crlf;
		nextPutLine: (self arrayFromHexString: '598F6AEF77E67CBE') asString.
		
	request := HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents).
	request task: (SwazooTask newOn: request).
	request task connection: HTTPConnection new.
	^ request! !

!OCSwazooTests methodsFor: 'as yet unclassified' stamp: 'HK 1/12/2011 17:17'!
upgradeGetFor: aPath

	| requestStream |
	requestStream := SwazooStream on: String new.
	requestStream
		nextPutLine: 'GET ', aPath, ' HTTP/1.1';
		nextPutLine: 'Host: localhost';
		nextPutLine: 'Upgrade: WebSocket';
		crlf.
	^ HTTPRequest readFrom: (SwazooStream on: requestStream writeBuffer contents).! !

OCSwazooTests subclass: #OCWebSocketHandlerTests
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Tests'!

!OCWebSocketHandlerTests methodsFor: 'as yet unclassified' stamp: 'SW 1/31/2011 11:52'!
testOpenConnection

	| oldCount response request |

	oldCount := S2JTestApp instance clients size.

	request := self basicWSFor: S2JTestApp uniquePath, '/ws'..
	response := (S2JWebSocketHandler newFor: (S2JTestApp instance)) answerTo: request.	
	self assert: response isWebSocketHandshake.
	
	self assert: (S2JTestApp instance clients size = (oldCount +1)).! !

!OCTestCase class methodsFor: 'testing' stamp: 'lw 2/19/2011 19:54'!
isOnCIServer
	
	^ true == (Smalltalk at: #S2JisOnCIServer ifAbsent: [ nil ])! !

!OCTestCase class methodsFor: 'testing' stamp: 'ag 2/3/2011 13:08'!
setIsOnCIServer
	
	^ self setIsOnCIServer: true! !

!OCTestCase class methodsFor: 'testing' stamp: 'ag 2/3/2011 13:08'!
setIsOnCIServer: aBoolean
	
	Smalltalk at: #S2JisOnCIServer put: aBoolean.! !

!OCTestCase methodsFor: 'private' stamp: 'srv 1/5/2011 11:09'!
timeoutForTest
	"remove test-timeout on the CI-server"
	
	^ self class isOnCIServer
		ifTrue: [ 15 * 60 * 1000 ]
		ifFalse: [ ^ super timeoutForTest ]! !

!Symbol methodsFor: '*Orca' stamp: 'lw 2/22/2011 13:51'!
apply: aCollection
	"calls this symbol as global function with aCollection as parameters"! !

ProtoObject subclass: #Js
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Stubs'!

!Js commentStamp: 'ag 4/5/2011 17:21' prior: 0!
This is a place, where programmers can define global shortcuts to access or execute common functions with long names.
The superclass of this class is set to nil to remove unnecessary methods.
Code inside this class should be short and is pure client-side code.!

!Js class methodsFor: 'shortcuts' stamp: 'ag 4/5/2011 17:47'!
@ aString
	"This shortcuts calling the jQuery-$-function with one string as parameter.
	This is client-side code."
	
	^ (self Global perform: '$') value: aString! !

!Js class methodsFor: 'stubs' stamp: 'hk 4/5/2011 13:02'!
Document

	self clientSideResposibility.! !

!Js class methodsFor: 'stubs' stamp: 'hk 4/5/2011 13:03'!
Global

	self clientSideResposibility.! !

!Js class methodsFor: 'shortcuts' stamp: 'ag 4/5/2011 17:48'!
jit
	
	^ self Global perform: '$jit'! !

ProtoObject subclass: #OCFutureResult
	instanceVariableNames: 'computationCompleted result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-RemoteObjects'!

!OCFutureResult class methodsFor: 'instance creation' stamp: 'lw 4/5/2011 12:25'!
newFrom: aBlock

	^ self new
		xxxStartComputation: aBlock;
		yourself! !

!OCFutureResult methodsFor: 'error handling' stamp: 'lw 4/5/2011 12:19'!
doesNotUnderstand: aMessage

	computationCompleted wait.
	self become: result.
	^ aMessage sendTo: result.! !

!OCFutureResult methodsFor: 'error handling' stamp: 'lw 4/5/2011 12:24'!
initialize

	computationCompleted := Semaphore new.! !

!OCFutureResult methodsFor: 'error handling' stamp: 'lw 4/5/2011 12:51'!
xxxStartComputation: aBlock

	[ result := aBlock value.
	computationCompleted signal ] fork! !

ProtoObject subclass: #OCRemoteObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-RemoteObjects'!

!OCRemoteObject methodsFor: 'error handling' stamp: 'lw 4/5/2011 12:50'!
doesNotUnderstand: aMessage

	"Query on Client/Server and answer the result as a Future"
	"In order to reduce the selector footprint of this class, most selectors starts with xxx, alike the objectTracer"
	
	| aBlock aClient |
	aClient := nil.
	aBlock := [ aClient perform ].
	^ S2JFutureResult newFrom: aBlock.! !

!ProtoObject methodsFor: '*Orca' stamp: 'ag 3/1/2011 15:58'!
definitionLine
	
	^ (S2JSqueakAstToJsAst escapeReservedWord: self class name),
		'._newInstance()'! !

!ProtoObject methodsFor: '*Orca' stamp: 'ag 3/31/2011 10:21'!
fillInstVars: codeLines guardedBy: alreadySerialized
	
	self class allInstVarNames withIndexDo: [ :varName :i | | varValue |
		varValue := self instVarAt: i. "This really works :D"
		varValue serializeToJavaScript: codeLines guardedBy: alreadySerialized.
		codeLines addLast: 
			(alreadySerialized at: self), '.', (S2JSqueakAstToJsAst jsInstVarNameFor: varName), 
			'=', (alreadySerialized at: varValue) ].! !

!ProtoObject methodsFor: '*Orca' stamp: 'ag 3/1/2011 18:07'!
serializeToJavaScript
	
	| code objectIds |
	code := OrderedCollection new.
	objectIds := Dictionary new.
	self serializeToJavaScript: code guardedBy: objectIds.
	code addLast: 'return ', (objectIds at: self).
	code := code separatedBy: ';'.
	^ '(function(){', code, ';})()'! !

!ProtoObject methodsFor: '*Orca' stamp: 'ag 3/31/2011 10:02'!
serializeToJavaScript: codeLines guardedBy: alreadySerialized
	
	(alreadySerialized includesKey: self) ifFalse: [
		alreadySerialized at: self put: 'obj', (alreadySerialized size + 1) asString.
		codeLines addFirst:  'var ', (alreadySerialized at: self), '=', self definitionLine.
		self fillInstVars: codeLines guardedBy: alreadySerialized ].! !

!MIMEDocument class methodsFor: '*Orca' stamp: 'hk 1/26/2011 10:40'!
extendedMIMEdatabase
	| d |
	(d := self defaultMIMEdatabase)
		 at: 'js' put: 'text/javascript';
		 at: 'hqx' put: 'application/mac-binhex40';
		 at: 'cpt' put: 'application/mac-compactpro';
		 at: 'pdf' put: 'application/pdf';
		 at: 'ps' put: 'application/postscript';
		 at: 'ai' put: 'application/postscript';
		 at: 'eps' put: 'application/postscript';
		 at: 'rtf' put: 'text/rtf';
		 at: 'ics' put: 'text/calendar';
		 at: 'bin' put: 'application/octet-stream';
		 at: 'dms' put: 'application/octet-stream';
		 at: 'lha' put: 'application/octet-stream';
		 at: 'lzh' put: 'application/octet-stream';
		 at: 'exe' put: 'application/octet-stream';
		 at: 'class' put: 'application/octet-stream';
		 at: 'zip' put: 'application/zip';
		 at: 'gtar' put: 'application/x-gtar';
		 at: 'swf' put: 'application/x-shockwave-flash';
		 at: 'sit' put: 'application/x-stuffit';
		 at: 'tar' put: 'application/x-tar';
		 at: 'au' put: 'audio/basic';
		 at: 'snd' put: 'audio/basic';
		 at: 'mid' put: 'audio/midi';
		 at: 'midi' put: 'audio/midi';
		 at: 'mpga' put: 'audio/mpeg';
		 at: 'mp2' put: 'audio/mpeg';
		 at: 'mp3' put: 'audio/mpeg';
		 at: 'aiff' put: 'audio/x-aiff';
		 at: 'aif' put: 'audio/x-aiff';
		 at: 'aifc' put: 'audio/x-aiff';
		 at: 'rm' put: 'audio/x-pn-realaudio';
		 at: 'ram' put: 'audio/x-pn-realaudio';
		 at: 'rpm' put: 'audio/x-pn-realaudio-plugin';
		 at: 'ra' put: 'audio/x-realaudio';
		 at: 'wav' put: 'audio/x-wav';
		 at: 'css' put: 'text/css';
		 at: 'mpeg' put: 'video/mpeg';
		 at: 'mpg' put: 'video/mpeg';
		 at: 'mpe' put: 'video/mpeg';
		 at: 'qt' put: 'video/quicktime';
		 at: 'mov' put: 'video/quicktime';
		 at: 'avi' put: 'video/x-msvideo';
		 at: 'movie' put: 'video/x-sgi-movie'.
	^ d! !

OrderedCollection subclass: #OCNode
	instanceVariableNames: 'name originalCode jsArgumentValue originalMethodName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OCNode commentStamp: 'ag 11/18/2010 13:09' prior: 0!
This is only a named collection, that is supposed to hold further collections or strings to form a tree!

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:31'!
arguments
	
	^ self arguments: {}! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:26'!
arguments: aCollection
	
	^ self named: 'arguments' with: aCollection! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:59'!
array: aCollection

	^ self named: 'array' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:27'!
assignment: aCollection

	^ self named: 'assignment' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:15'!
binaryExpression: aCollection

	^ self named: 'binaryExpression' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:31'!
block

	^ self block: {}.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:26'!
block: aCollection

	^ self named: 'block' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'LT 2/24/2011 13:34:07.814'!
braceExpression: aCollection

	^ self named: 'braceExpression' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:37'!
byteArray: aCollection

	^ self named: 'byteArray' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:12'!
cascadedExpression: aCollection

	^ self named: 'cascadedExpression' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:05'!
character: aCharacter

	aCharacter isCharacter ifFalse: [ self error: 'need a Character' ].
	^ self named: 'character' with: { aCharacter }.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'LT 4/5/2011 13:50:00.746'!
comment: aString

	aString isString ifFalse: [ self error: 'need a String' ].
	^ self named: 'comment' with: { aString }! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'LT 4/5/2011 13:49:56.145'!
comments: anOrderedCollection

	^ self named: 'comments' with: anOrderedCollection! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/25/2011 13:57'!
expression

	^ self named: 'expression' with: {}.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:27'!
expression: aCollection

	^ self named: 'expression' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:27'!
functionCall: aCollection
	"aCollection = { receiver. aMessageNameString. argumentsNode }"
	
	^ self named: 'functionCall' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:27'!
functionContent: aCollection

	^ self named: 'functionContent' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:28'!
functionDeclaration: aCollection

	^ self named: 'functionDeclaration' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:28'!
identifier: aString

	aString isString ifFalse: [ self error: 'need a String' ].
	^ self named: 'identifier' with: { aString }.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'robi 3/22/2011 13:47'!
javaScriptMethod: aCollection
	"aCollection = { header. statements }"
	^ self named: 'javaScriptMethod' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:11'!
keywordExpression: aCollection

	^ self named: 'keywordExpression' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'robi 3/22/2011 13:48'!
method: aCollection
	"aCollection = { header. statements }"
	^ self named: 'method' with: aCollection.! !

!OCNode class methodsFor: 'instance creation' stamp: 'lw 2/22/2011 17:45'!
named: aString
	
	^ self named: aString with: {}! !

!OCNode class methodsFor: 'instance creation' stamp: 'ag 11/18/2010 13:08'!
named: aString with: anOrderedCollection
	
	^ self new
		name: aString;
		addAll: anOrderedCollection;
		yourself! !

!OCNode class methodsFor: 'instance creation' stamp: 'ag 11/18/2010 13:58'!
named: aString withoutNils: anOrderedCollection
	
	anOrderedCollection ifNil: [ ^ nil ].
	^ self
		named: aString
		with: (anOrderedCollection reject: [ :each | each isNil])! !

!OCNode class methodsFor: 'instance creation' stamp: 'ag 11/21/2010 19:15'!
named: aString withoutNilsNotEmpty: anOrderedCollection
	"Returns nil, if resulting node would be empty"
	
	| result |
	result := self named: aString withoutNils: anOrderedCollection.
	^ (result isNil or: [result isEmpty])
		ifTrue: [ nil ]
		ifFalse: [ result ]! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 19:05'!
newExpression: aCollection

	^ self named: 'newExpression' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:28'!
number: aNumber

	aNumber isNumber ifFalse: [ self error: 'need a Number' ].
	^ self named: 'number' with: { aNumber }.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'LT 2/24/2011 13:34:59.983'!
objectLiteral: aCollection

	^ self named: 'objectLiteral' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:51'!
paranthesizedExpression: aCollection

	^ self named: 'paranthesizedExpression' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:28'!
reservedWord: aString

	aString isString ifFalse: [ self error: 'need a String' ].
	^ self named: 'reservedWord' with: { aString }.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:29'!
returnExpression: aCollection

	^ self named: 'returnExpression' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:29'!
slotAccess: aCollection

	^ self named: 'slotAccess' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:29'!
slotAssignment: aCollection

	^ self named: 'slotAssignment' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:31'!
statements

	^ self statements: {}.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:24'!
statements: aCollection

	^ self named: 'statements' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:29'!
string: aString

	aString isString ifFalse: [ self error: 'need a String' ].
	^ self named: 'string' with: { aString }.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:06'!
symbol: aSymbol

	aSymbol isSymbol ifFalse: [ self error: 'need a Symbol' ].
	^ self named: 'symbol' with: { aSymbol }.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:32'!
temporaries
	
	^ self temporaries: {}! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 18:24'!
temporaries: aCollection
	
	^ self named: 'temporaries' with: aCollection! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:48'!
unaryExpression: aCollection

	^ self named: 'unaryExpression' with: aCollection.! !

!OCNode class methodsFor: 'instance creation helpers' stamp: 'lw 2/22/2011 17:29'!
variableDeclaration: aCollection

	^ self named: 'variableDeclaration' with: aCollection.! !

!OCNode methodsFor: 'comparing' stamp: 'ag 11/21/2010 19:19'!
= anObject
	
	^ super = anObject and: 
		[ name = anObject name ]! !

!OCNode methodsFor: 'adding' stamp: 'lw 4/5/2011 18:19'!
addAllWhitoutNils: aCollection
	
	aCollection do: [ :each | each ifNotNil: [self add: each]]
! !

!OCNode methodsFor: 'testing' stamp: 'ag 12/16/2010 15:58'!
includesChildNamed: aString
	
	^ self name = aString
		or: [ self anySatisfy: [ :node | 
			(node isKindOf: S2JNode) and: [
			node includesChildNamed: aString ] ] ]! !

!OCNode methodsFor: 'testing' stamp: 'LT 12/1/2010 14:06:25.154'!
isArrayNode

	^ name = 'array' or: [name = 'byteArray' or: [name = 'braceExpression']]! !

!OCNode methodsFor: 'testing' stamp: 'LT 2/24/2011 13:54:04.347'!
isAssociationNode

	^ (self name = 'binaryExpression' and: [ (self at: 2) = #-> ])
	or: [ self name = 'expression' and: [ self size = 1 ] and: [ (self at: 1) isAssociationNode ]]! !

!OCNode methodsFor: 'accessing' stamp: 'ag 2/7/2011 19:20'!
jsArgumentValue
	^ jsArgumentValue! !

!OCNode methodsFor: 'accessing' stamp: 'ag 2/7/2011 19:25'!
jsArgumentValue: anS2JNode
	"The ast-to-ast-step stores an additional info here: The value of this node, if it would act as a argument to a js-function-call.
	E.g. a number-literal is stored directly as a number-node here, without wrapping it as squeak-object and calling js() on it.
	This is important, as for boolean-value the js()-mechanism has been found to be non-functional!!"
	
	jsArgumentValue := anS2JNode! !

!OCNode methodsFor: 'accessing' stamp: 'ag 1/25/2011 14:45'!
name
	
	^ name! !

!OCNode methodsFor: 'accessing' stamp: 'ag 1/25/2011 14:45'!
name: aString
	
	name := aString! !

!OCNode methodsFor: 'accessing' stamp: 'lw 3/28/2011 17:40'!
originalCode
	^ originalCode! !

!OCNode methodsFor: 'accessing' stamp: 'ag 1/19/2011 19:17'!
originalCode: anObject
	"This is only set on 'block'-nodes. Never mind. :-)"
	
	originalCode := anObject! !

!OCNode methodsFor: 'printing' stamp: 'ag 11/19/2010 00:39'!
printString
	
	| result first |
	first := true.
	result := name, ' ('.
	self do: [ :each |
		first ifTrue: [first := false] ifFalse: [result := result, ', '].
		result := result,  each printString].
	^ result, ')'! !

OMeta2 subclass: #OCOMeta2
	instanceVariableNames: 'currentMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

OCOMeta2 subclass: #OCAstReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

OCAstReader subclass: #OCAbstractPrinter
	instanceVariableNames: 'indentation'
	classVariableNames: 'ClassTextOutputStream JavascriptPrintStream TextOutputStream'
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OCAbstractPrinter class methodsFor: 'converting' stamp: 'robi 1/17/2011 16:17'!
asJSString: aString
	"Use the squeak-library to encode the string.. if not found, use an easy escaping-algorithm."
	
	^ (aString respondsTo: #javascriptOn:)
		ifTrue: [
			JavascriptPrintStream ifNil: [ JavascriptPrintStream := TextStream on: '' ] ifNotNil: [ JavascriptPrintStream reset ].
			aString javascriptOn: JavascriptPrintStream.
			JavascriptPrintStream contents ]
		ifFalse: [ | tokens |
			tokens := aString findTokens: self jsEscapeChars keep: self jsEscapeChars.
			'"', (tokens inject: '' into: [ :all :each |
				all, 
				((self jsEscapeChars includes: each asCharacter) ifTrue: [ '\' ] ifFalse: [ '' ]), 
				each]), '"' ]! !

!OCAbstractPrinter class methodsFor: 'converting classes private' stamp: 'ag 1/9/2011 20:23'!
convert: aBlock to: output
	
	aBlock value:
		output reset; yourself.
	^ output contents! !

!OCAbstractPrinter class methodsFor: 'converting classes' stamp: 'ag 1/5/2011 21:22'!
convertClass: aClass
	
	^ self
		convertClass: aClass
		retrievingFrom: [ :methodSelector |
			self convertCompiledMethod: methodSelector ]! !

!OCAbstractPrinter class methodsFor: 'converting classes' stamp: 'ag 1/9/2011 17:50'!
convertClass: aClass retrievingFrom: aBlock
	"Return the converted version of the whole class. aBlock takes one parameter (a CompiledMethod) and returns
	the code for the method as string. A static (reused) output-stream is used to print the code."
	
	^ self
		convert: [ :output | self convertClass: aClass to: output retrievingFrom: aBlock ]
		to: (TextOutputStream ifNil: [ TextOutputStream := S2JTextStream for: self ])! !

!OCAbstractPrinter class methodsFor: 'converting classes private' stamp: 'ag 1/18/2011 13:05'!
convertClass: aClass to: output retrievingFrom: aBlock
	
	| firstPrinted firstPrintedMemorizer |
	firstPrinted := false.
	firstPrintedMemorizer := [ :nextPartValid | nextPartValid and: [ firstPrinted or: [ firstPrinted := true. false ] ] ]. "Pretty complex. Remember, whether first line has been printed."
	output << 'Class(' << (self asJSString: (S2JSqueakAstToJsAst escapeReservedWord: aClass)) << ',' << self space << '{' << self newline.
	self
		printPart: 'superclass' with: (self printSuperclass: aClass) to: output guardedBy: firstPrintedMemorizer;
		printPart: 'instanceVariables' with: (self printVariables: aClass instVarNames) to: output guardedBy: firstPrintedMemorizer;
		printPart: 'classInstanceVariables' with: (self printVariables: aClass class instVarNames) to: output guardedBy: firstPrintedMemorizer;
		printPart: 'classVariables' with: (self printVariables: aClass classVarNames) to: output guardedBy: firstPrintedMemorizer;
		printPart: 'classMethods' with: (self printMethodsOf: aClass class retrievingFrom: aBlock) to: output guardedBy: firstPrintedMemorizer;
		printPart: 'instanceMethods' with: (self printMethodsOf: aClass retrievingFrom: aBlock) to: output guardedBy: firstPrintedMemorizer.
	output << self newline << '})'.! !

!OCAbstractPrinter class methodsFor: 'converting classes' stamp: 'ag 1/5/2011 19:59'!
convertClasses: anArrayOfClasses
	
	^ self
		convertClasses: anArrayOfClasses
		retrievingFrom: [ :class |
			self convertClass: class ]! !

!OCAbstractPrinter class methodsFor: 'converting classes' stamp: 'ag 1/10/2011 10:20'!
convertClasses: anArrayOfClasses retrievingFrom: aBlock
	"Return the code for all the classes in anArrayOfClasses. aBlock takes on parameter (a class) and returns the code for the class."
	
	^ self
		convert: [ :output | output << (self
							printEach: [ :class | aBlock value: class ]
							of: anArrayOfClasses
							separatedBy: (';', self newline))]
		to: (ClassTextOutputStream ifNil: [ ClassTextOutputStream := S2JTextStream for: self ])! !

!OCAbstractPrinter class methodsFor: 'converting classes' stamp: 'lw 4/4/2011 17:17'!
doesNotUndestandClasswithMethods: aDictionaryOfMethodNames

	| cr functions crr |
	cr := self newline, self indentation.
	crr := cr, self indentation.
	functions := TextStream with: ''.
	aDictionaryOfMethodNames keysAndValuesDo: 
		[ :aSTFunctionCallName :aJSFunctionCallName | 
			functions << aJSFunctionCallName << ':' << self space << 'function(){' << crr << 
			'return this.doesNotUnderstand_(Message.selector_arguments_(string("' << aSTFunctionCallName << '"), array(_toArray(arguments)))); ' << '},' << crr].
	functions := functions contents.
	^ ((TextStream with: 'Class("') << S2JAbstractCodeFactory doesNotUnderstandClass 
			<< '", {' << cr <<
		'instanceMethods: {' << cr <<
			self indentation << functions << cr <<
		'}, ' << cr <<
		'classMethods: {' << cr <<
			self indentation << functions << cr <<
		'}' << self newline << 
		'})' << self newline) contents! !

!OCAbstractPrinter class methodsFor: 'pretty-print' stamp: 'ag 1/5/2011 20:01'!
indentation
	
	self subclassResponsibility! !

!OCAbstractPrinter class methodsFor: 'converting' stamp: 'ag 1/5/2011 20:01'!
inputConverter

	^ S2JSqueakAstToJsAst! !

!OCAbstractPrinter class methodsFor: 'converting' stamp: 'ag 1/17/2011 10:39'!
jsEscapeChars
	
	^ #($" $\)! !

!OCAbstractPrinter class methodsFor: 'pretty-print' stamp: 'ag 1/5/2011 20:01'!
newline
	
	self subclassResponsibility! !

!OCAbstractPrinter class methodsFor: 'converting classes private' stamp: 'ag 1/10/2011 08:01'!
printEach: aBlock of: aCollection separatedBy: aString
	
	| result isFirst |
	isFirst := true.
	result := ''.
	aCollection do: [ :each | 
		isFirst
			ifTrue: [ isFirst := false ]
			ifFalse: [ result := result, aString ].
		result := result, (aBlock value: each)].
	^ result! !

!OCAbstractPrinter class methodsFor: 'converting classes private' stamp: 'ag 1/10/2011 10:16'!
printMethodsOf: aClass retrievingFrom: aBlock
	
	| methods |
	methods := aClass methodDict values.
	^ methods 
		ifEmpty: [ false ]
		ifNotEmpty: [
			'{', self newline,
			(self
				printEach: [ :eachmethod | | code |
					code := aBlock value: eachmethod.
					self indentation, self indentation, code key, ':', self space, code value ]
				of: methods
				separatedBy: ',', self newline),
			self newline, self indentation, '}' ].! !

!OCAbstractPrinter class methodsFor: 'converting classes private' stamp: 'ag 1/10/2011 10:43'!
printPart: aString with: aValue to: output guardedBy: aGuardBlock
	"Print a slot. If aValue is a String (should return false then), this is skipped.
	aGuardBlock is called with whether this part will be printed and returns, whether we have to prepend a colon + newline ('guards' whether we are the first line)."
	
	(aGuardBlock value: aValue isString)
		ifTrue: [ output << ',' << self newline ].
	aValue isString ifTrue: [
		output << self indentation << aString << ':' << self space << aValue ]! !

!OCAbstractPrinter class methodsFor: 'converting classes private' stamp: 'lw 3/28/2011 13:25'!
printSuperclass: aClass
	
	^ aClass superclass
		ifNil: [ S2JAbstractCodeFactory doesNotUnderstandClass ]
		ifNotNil: [ S2JSqueakAstToJsAst escapeReservedWord: aClass superclass name ]! !

!OCAbstractPrinter class methodsFor: 'converting classes private' stamp: 'ag 1/10/2011 09:12'!
printVariables: aCollection
	"Print a collection containing all members of aCollection separated by colons"
	
	^ aCollection
		ifEmpty: [ false ]
		ifNotEmpty: [
			'[', self space,
			(self
				printEach: [ :each | '"', S2JSqueakAstToJsAst escapeCharForIdentifier, each, '"' ]
				of: aCollection
				separatedBy: ',', self space),
			self space, ']' ]! !

!OCAbstractPrinter class methodsFor: 'converting classes' stamp: 'ag 1/10/2011 09:10'!
resetTextStreams
	"These helper-TextStreams are recreated lazily"
	
	ClassTextOutputStream := TextOutputStream := JavascriptPrintStream := nil.! !

!OCAbstractPrinter class methodsFor: 'pretty-print' stamp: 'ag 1/5/2011 20:01'!
space
	
	self subclassResponsibility! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/8/2010 14:44'!
arguments =
	
	translate*:identifiers
	-> [ self functionParameters: identifiers ]! !

!OCAbstractPrinter methodsFor: 'translate tokens' stamp: 'ag 1/25/2011 14:44'!
array = 
	
	translateWith(#expressionBase)*:contents
	-> [ '[', (contents separatedBy: ', '), ']' ]! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/9/2010 16:19'!
assignment =
	
	translate! !

!OCAbstractPrinter methodsFor: 'pretty print' stamp: 'ag 1/10/2011 09:17'!
cSpace
	
	^ self class space! !

!OCAbstractPrinter methodsFor: 'translate tokens' stamp: 'LT 4/5/2011 16:47:03.435'!
comment =
	
	^string:comment
	-> [ self createComment: comment ]! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'LT 4/5/2011 16:49:24.177'!
comments =
	
	translateNamed('comment')*:commentStrings
	-> [commentStrings
		ifNil: [''] 
		ifNotNil: 
			[commentStrings separatedBy: '']]! !

!OCAbstractPrinter methodsFor: 'helpers' stamp: 'lw 4/5/2011 17:04'!
createComment: aString

	| result |
	self indent.
	result := TextStream with: ''.
	result << self indentation << '// '.
	aString do: 
			[ :each |
			each = Character cr
				ifTrue: [result << self newline << self indentation <<  '//']
				ifFalse: [
					each = Character lf
						ifFalse: [result << each]]].
	result << self newline.
	self unindent.
	^ result contents! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'LT 2/24/2011 19:23:05.913'!
expression =
	
	expressionBase:expr
	-> [ self indentation, expr ]! !

!OCAbstractPrinter methodsFor: 'helpers' stamp: 'ag 1/25/2011 14:43'!
expression: anExpressionBodyString withAssignments: aStringCollection
	
	^ ((aStringCollection isNil or: [ aStringCollection isEmpty ])
			ifTrue: [ '' ]
			ifFalse: [
				(aStringCollection separatedBy: self cSpace, '=', self cSpace),
				self cSpace, '=', self cSpace ])
					, anExpressionBodyString! !

!OCAbstractPrinter methodsFor: 'helpers' stamp: 'lw 4/5/2011 21:36'!
expression: anExpressionBodyString withAssignments: aStringCollection withComments: aStringOfComments
	
	^ (aStringOfComments ifNil: ['']),
		((aStringCollection isNil or: [ aStringCollection isEmpty ])
			ifTrue: [ '' ]
			ifFalse: [
				(aStringCollection separatedBy: self cSpace, '=', self cSpace),
				self cSpace, '=', self cSpace ])
					, anExpressionBodyString! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'lw 4/5/2011 21:42'!
expressionBase =
	
	translateNamed('comments')?:comments translate:expressionBody translate*:assignments
	-> [ self expression: expressionBody withAssignments: assignments withComments: comments ]! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 1/24/2011 19:13'!
functionCall =
	// Can be either an invokation of a named function of an object OR an invokation of a anonymous function
	
	&anything:receiverNode (nil | translate):receiver (^string | translate):functionName translate:arguments
	-> [ self
			functionCall: functionName
			to: ((receiverNode notNil and: [ receiverNode name = 'functionDeclaration' ])
					ifTrue: [ '(', receiver, ')' ]
					ifFalse: [ receiver ] )
			withArguments: arguments ]! !

!OCAbstractPrinter methodsFor: 'helpers' stamp: 'lw 3/28/2011 16:43'!
functionCall: aFunctionNameOrDeclarationString to: aReceiverString withArguments: anArgumentsString
	
	| function |
	function := (aFunctionNameOrDeclarationString startsWith: 'function') "no test yet, necessary?"
		ifTrue: ['(', aFunctionNameOrDeclarationString, ')'] 
		ifFalse: [ aFunctionNameOrDeclarationString].
	
	^ (aReceiverString
		ifNotNil: [ aReceiverString, '.' ]
		ifNil: [ '' ]), function, anArgumentsString! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'SW 1/25/2011 16:56'!
functionContent =
	// This is intentionally not named 'statements', to deny all nested statements-nodes
	// The ast-to-ast step must flatten all statements into one list of expressions here
	
	[ self indent ]
	translate*:expressions
	[ self unindent ]
	-> [ expressions separatedBy: ';', self newline ]! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 1/10/2011 09:38'!
functionDeclaration =
	
	translate:arguments
	translate:statements
	-> [ self functionDeclaration: arguments withBody: statements ]! !

!OCAbstractPrinter methodsFor: 'helpers' stamp: 'ag 1/26/2011 10:05'!
functionDeclaration: aParameterString withBody: aStatementsString
	"aParameterString already contains the parantheses; #functionParameters: should be used."
	
	^ 'function', self cSpace, aParameterString, self cSpace, '{', self newline,
			(aStatementsString ifEmpty: [ '' ] ifNotEmpty: [ aStatementsString, ';' ]),
		self newline, self indentation, '}'! !

!OCAbstractPrinter methodsFor: 'helpers' stamp: 'lw 4/5/2011 21:30'!
functionDeclaration: aParameterString withComment: aCommentString withBody: aStatementsString

	"aParameterString already contains the parantheses; #functionParameters: should be used."
	^ 'function', self cSpace, aParameterString, self cSpace, '{', self newline,
			(aCommentString ifNil: [ '' ]),
			(aStatementsString ifEmpty: [ '' ] ifNotEmpty: [ aStatementsString, ';' ]),
		self newline, self indentation, '}'! !

!OCAbstractPrinter methodsFor: 'helpers' stamp: 'lw 2/22/2011 13:19'!
functionParameters: aStringCollection

	^ '(', ((aStringCollection collect: [ :aString | aString trimLeft ]) separatedBy: ', '), ')'! !

!OCAbstractPrinter methodsFor: 'helpers' stamp: 'sec 1/4/2011 11:46'!
hasSelector: aSymbol
	"Adding the superclass method dictionary to the searcharea for matching methods is required because the printers don't implement all the methods on their own"
	
	^ ((super hasSelector: aSymbol) or: [ self class superclass includesSelector: aSymbol ])
		ifTrue: [ true ]
		ifFalse: [ self error: 'Unknown selector: ', aSymbol asString. false ]! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 14:14'!
header =
	
	^string:functionName arguments:arguments
	-> [ functionName -> arguments ]! !

!OCAbstractPrinter methodsFor: 'translate tokens' stamp: 'ag 12/2/2010 11:52'!
identifier =
	
	^string:identifier
	-> [ identifier ]! !

!OCAbstractPrinter methodsFor: 'pretty print' stamp: 'ag 1/10/2011 09:17'!
indent
	
	self indentation: self indentation, self class indentation! !

!OCAbstractPrinter methodsFor: 'accessing' stamp: 'lw 1/4/2011 17:25'!
indentation
	^ indentation! !

!OCAbstractPrinter methodsFor: 'accessing' stamp: 'lw 1/4/2011 17:25'!
indentation: anObject
	indentation := anObject! !

!OCAbstractPrinter methodsFor: 'initialization' stamp: 'lw 3/28/2011 16:45'!
initialize

	super initialize.
	self 
		indentation: ''.! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'robi 3/21/2011 21:04'!
javaScriptMethod =
	// This does not return a string, but an association from the method-name to the method-declaration
	
	translate:functionNameAndArguments
	translate:statements
	-> [ functionNameAndArguments key -> 
		(self
			functionDeclaration: functionNameAndArguments value
			withBody: statements) ]! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'LT 4/5/2011 16:11:11.73'!
method =
	// This does not return a string, but an association from the method-name to the method-declaration
	
	translate:functionNameAndArguments
	translateNamed('comments')?:comment
	translate:statements
	-> [ functionNameAndArguments key -> 
		(self
			functionDeclaration: functionNameAndArguments value
			withComment: comment
			withBody: statements) ]! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 3/29/2011 10:08'!
newExpression =
	
	// Here is a function-call, which is handled a little bit differently. Code copied from functionCall.
	
	{ &anything:receiverNode (nil | translate):receiver (^string | translate):functionName translate:arguments }
	-> [ 'new (', (self
			functionCall: functionName, ')'
			to: ((receiverNode notNil and: [ receiverNode name = 'functionDeclaration' ])
					ifTrue: [ '(', receiver, ')' ]
					ifFalse: [ receiver ] )
			withArguments: arguments) ]! !

!OCAbstractPrinter methodsFor: 'pretty print' stamp: 'ag 1/10/2011 09:35'!
newline
	
	^ self class newline! !

!OCAbstractPrinter methodsFor: 'translate tokens' stamp: 'ag 12/16/2010 16:32'!
number =
	
	^number:number
	-> [ number asString ]! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'LT 2/24/2011 20:15:46.145'!
objectLiteral =

	translateNamed(#slotAssignment)*:result
	-> [ '{', (result separatedBy: ',', self cSpace) , '}' ]! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 1/10/2011 10:00'!
paranthesizedExpression =
	
	expressionBase:value
	-> [ '(', value, ')' ]! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 17:37'!
reservedWord =
	
	^string! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 1/10/2011 09:49'!
returnExpression =
	
	expressionBase:expr
	-> [ self indentation, 'return ', expr ]! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/22/2010 16:36'!
slotAccess =
	
	(nil | translate):object ^symbol:slotName
	-> [ (object ifNotNil: [ object, '.' ] ifNil: [ '' ]), slotName asString ]! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'LT 2/24/2011 20:45:26.197'!
slotAssignment =
	
	^symbol:slotname translate:value
	-> [  slotname, self cSpace, ':', self cSpace, value ]! !

!OCAbstractPrinter methodsFor: 'translate tokens' stamp: 'ag 1/9/2011 16:45'!
string =
	
	^string:string
	-> [ self class asJSString: string ]! !

!OCAbstractPrinter methodsFor: 'pretty print' stamp: 'ag 1/10/2011 09:17'!
unindent
	
	self indentation: (self indentation allButLast: self class indentation size)! !

!OCAbstractPrinter methodsFor: 'translate complex' stamp: 'ag 12/13/2010 19:40'!
variableDeclaration =
	
	translateNamed('identifier')+:variableNames translateNamed('assignment')?:assignment
	-> [ self variableDeclaration: variableNames withAssignment: assignment ]! !

!OCAbstractPrinter methodsFor: 'helpers' stamp: 'ag 1/25/2011 14:43'!
variableDeclaration: variableNames withAssignment: assignment
	"Acts as an expression, not terminated by a semi colon"
	
	| oneVar firstLine |
	firstLine := self indentation, 'var ', ((oneVar := variableNames size = 1)
		ifTrue: [ variableNames first ]
		ifFalse: [ (variableNames separatedBy: ';', self cSpace, 'var ')]).
	^ assignment 
		ifNil: [ firstLine ]
		ifNotNil: [
			oneVar
				ifTrue: [ self expression: assignment withAssignments: { firstLine } ]
				ifFalse: [ 
					firstLine, ';', self newline, self indentation, (self expression: assignment withAssignments: variableNames) ]]! !

OCAbstractPrinter subclass: #OCPrettyPrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OCPrettyPrinter class methodsFor: 'pretty-print' stamp: 'lw 1/4/2011 17:37'!
indentation

	^ '    '! !

!OCPrettyPrinter class methodsFor: 'pretty-print' stamp: 'sec 3/2/2011 16:08'!
newline
	
	^ Character lf asString! !

!OCPrettyPrinter class methodsFor: 'pretty-print' stamp: 'lw 1/4/2011 17:37'!
space

	^ ' '! !

!OCPrettyPrinter methodsFor: 'initialization' stamp: 'ag 1/10/2011 10:11'!
initialize
	"Do everything indented x2 from the start, to have json-like pretty-print for the whole js-file."
	
	super initialize.
	self
		indent;
		indent.! !

OCAbstractPrinter subclass: #OCPrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OCPrinter class methodsFor: 'pretty-print' stamp: 'lw 1/4/2011 17:37'!
indentation

	^ ''! !

!OCPrinter class methodsFor: 'pretty-print' stamp: 'ag 1/5/2011 20:02'!
newline
	
	^ ''! !

!OCPrinter class methodsFor: 'pretty-print' stamp: 'lw 1/4/2011 17:30'!
space

	^ ''! !

!OCAstReader class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:20'!
applyRule: aRule on: aMatcher
	
	^ super applyRule: #translate on: aMatcher! !

!OCAstReader class methodsFor: 'converting private' stamp: 'LT 2/24/2011 19:36:54.354'!
convertAst: anS2JNodeTree

	| matcher result |
	matcher := self matcherOn: {anS2JNodeTree} readStream.
	matcher currentMethod: nil.
	result := self applyRule: #translate on: matcher.
	^ result! !

!OCAstReader class methodsFor: 'converting private' stamp: 'lw 3/28/2011 17:50'!
createInputFrom: aString as: aRule insideMethod: aCompiledMethod
	
	| input |
	input := (self inputConverter convert: aString as: aRule insideMethod: aCompiledMethod).
	" The outermost node is alike an expression or statements node. Because OMeta uses this first node to iterate over, it's node name is not base for translation: it will be consumed without effect and therefore lost. To not lose any nodes, we add a generic one."
	input value: { input value }. 
	^ input! !

!OCAstReader class methodsFor: 'converting private' stamp: 'ag 12/8/2010 22:13'!
inputConverter
	"An AstReader should know, which converter-class can provide the ast wants to read"
	
	self subclassResponsibility! !

!OCAstReader methodsFor: 'helpers' stamp: 'ag 12/16/2010 23:37'!
hasSelector: aSymbol
	"Offers a hook to catch, if an unknown node occurs"
	
	^ self class includesSelector: aSymbol! !

!OCAstReader methodsFor: 'ometa helpers' stamp: 'ag 12/16/2010 23:36'!
translate =
	// Translate the next node using it's name as rule
	
	translateNamed(nil)! !

!OCAstReader methodsFor: 'ometa helpers' stamp: 'ag 12/16/2010 23:36'!
translateNamed :nodeName =
	// Assert, that the next node has the name nodeName and translate it using it's name as rule
	
	translateNamedWith(nodeName. nodeName)! !

!OCAstReader methodsFor: 'ometa helpers' stamp: 'ag 12/16/2010 23:36'!
translateNamedWith :nodeName :targetRule =
	// Assert, that the next node has the name nodeName and translate it with targetRule
	
	translateNamedWithArgument(nodeName. targetRule. nil)! !

!OCAstReader methodsFor: 'ometa helpers' stamp: 'LT 2/24/2011 20:12:33.968'!
translateNamedWithArgument :nodeName :targetRule :argument =
	// Assert, that the next node has the name nodeName, use targetRule to convert the node and pass argument when calling targetRule
	
	// Lookahead for one node
	&anything:node
	
	// Some assertions, e.g. about the nodeName
	?[ node class = S2JNode ]
	?[ nodeName isNil | (node name = nodeName )]
	[ targetRule ifNil: [ node name asSymbol ] ifNotNil: [ targetRule asSymbol ]]:appliedRule
	?[ self hasSelector: appliedRule ]
	
	// If an argument is given, call the targetRule with that argument. Else, call the targetRule without arguments
	(( ?[ argument notNil ] { apply(appliedRule. argument):result } )
	| { apply(appliedRule):result })
	
	// Return the parsed content of the node
	-> [ result ]! !

!OCAstReader methodsFor: 'ometa helpers' stamp: 'ag 12/16/2010 23:34'!
translateWith :aRule =
	// Translate the next node with aRule, regardless of it's name
	
	translateNamedWith(nil. aRule)! !

!OCAstReader methodsFor: 'ometa helpers' stamp: 'ag 12/16/2010 23:47'!
translateWithArgument :aRule :argument =
	// Translate the next node with aRule, regardless of it's name, and pass aRule the argument
	
	translateNamedWithArgument(nil. aRule. argument)! !

OCAstReader subclass: #OCAstToAst
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OCAstToAst methodsFor: 'helpers' stamp: 'lw 2/22/2011 18:34'!
passThroughAndTranslate =
	
	// TODO add all primitive values?..
	
	^symbol
|	string
|	number
|	char
|	nil
	
|	({ translate*:children }:node
	-> [ S2JNode named: node name with: children ])! !

!OCAstToAst methodsFor: 'helpers' stamp: 'lw 2/22/2011 18:34'!
renameTo :nodeName =
	
	translate*:contents
	-> [ S2JNode named: nodeName with: contents ]! !

!OCAstToAst methodsFor: 'helpers' stamp: 'ag 12/9/2010 12:31'!
translate = 
	
	^translate
|	passThroughAndTranslate! !

OCAstToAst subclass: #OCJsAstOptimizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OCJsAstOptimizer class methodsFor: 'converting' stamp: 'ag 12/8/2010 21:30'!
inputConverter
	
	self error: 'The Js-Ast-Optimizer is not yet functional!!'.
	^ S2JSqueakToJsAst! !

!OCJsAstOptimizer methodsFor: 'convert special cases' stamp: 'ag 12/8/2010 10:38'!
forLoop =
	// Special case of keywordExpression
	

	translate:receiver symbol:selector translate*:arguments
	?[ selector = #do: ]
	?[ arguments size = 1 ]
	[ arguments first ]:block
	?[ block size >= 1 ]
	?[ block first name = 'arguments' ]
	?[ block first size = 1 ]
	-> [ self forLoopOver: receiver do: block ]! !

!OCJsAstOptimizer methodsFor: 'convert special cases' stamp: 'lw 2/22/2011 17:32'!
forLoopOver: anArrayNode do: aBlockNode

	| arrayName statements aStatementsNode aTemporariesNode loopVariableName |
	arrayName := 'arr$'.
	loopVariableName := aBlockNode first first.
	aStatementsNode := aBlockNode detect: [:each | each name = 'statements'] ifNone: [ nil ].
	aTemporariesNode := aBlockNode detect: [:each | each name = 'temporaries'] ifNone: [ nil ].
	aStatementsNode ifNotNil: [ statements := self apply: #translate withArgs: aStatementsNode].
	^ S2JNode statements:
		{S2JNode variableDeclaration:
			{S2JNode identifier: arrayName.
			  S2JNode expression: anArrayNode}.
		 S2JNode forLoop:
			{S2JNode identifier: arrayName.
			loopVariableName.
			aTemporariesNode.
			statements}}! !

!OCJsAstOptimizer methodsFor: 'convert complex' stamp: 'ag 12/8/2010 13:54'!
keywordExpression = 
	
	forLoop
|	messageSendExpression // ...not correct ...
! !

OCAstToAst subclass: #OCSqueakAstToJsAst
	instanceVariableNames: 'calledFunctions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OCSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 1/11/2011 17:35'!
arrayFunction
	
	^ 'array'! !

!OCSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 1/10/2011 11:51'!
blockFunction
	
	^ 'block'! !

!OCSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 1/10/2011 11:51'!
charFunction
	"Cannot name it char"
	
	^ 'character'! !

!OCSqueakAstToJsAst class methodsFor: 'escaping' stamp: 'robi 1/4/2011 15:21'!
escapeCharForIdentifier
	
	^ '$'! !

!OCSqueakAstToJsAst class methodsFor: 'escaping' stamp: 'robi 1/4/2011 15:21'!
escapeCharForMethod
	
	^ '_'! !

!OCSqueakAstToJsAst class methodsFor: 'escaping' stamp: 'sec 1/5/2011 11:54'!
escapeReservedWord: aStringOrSymbol
	
	aStringOrSymbol ifNil: [ ^nil ].
	^ ((self jsReservedWords includes: aStringOrSymbol asString)
		ifTrue: [ self escapeCharForMethod ]
		ifFalse: [ '' ]), aStringOrSymbol asString! !

!OCSqueakAstToJsAst class methodsFor: 'converting' stamp: 'LT 3/1/2011 10:10:30.562'!
ignoredPrimitives
	"This returns an array of CompiledMethod. All primitive-declarations in these methods are ignored.
	This means, these methods must have a correct software-fallback-implementation."
	
	^ {
	self method: #@ of: Number.
	self method: #replaceFrom:to:with:startingAt: of: String.
	self method: #replaceFrom:to:with:startingAt: of: Symbol.
	self method: #replaceFrom:to:with:startingAt: of: Array.
	self method: #replaceFrom:to:with:startingAt: of: ByteString.
	self method: #atEnd of: PositionableStream.
	self method: #next of: ReadStream.
	self method: #species of: Object
	}! !

!OCSqueakAstToJsAst class methodsFor: 'converting' stamp: 'sec 3/23/2011 14:14'!
inputConverter
	
	^ S2JParser! !

!OCSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 3/29/2011 10:27'!
isKeywordLiteral: aString

	^ { 'true'. 'false' } includes: aString! !

!OCSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 1/5/2011 09:43'!
jsFunctionNameFor: aStringOrSymbol
	
	| result |
	result := ''.
	aStringOrSymbol asString do: [ :each | | jsIdentifier |
		jsIdentifier := self squeakCharacterToJsIdentifier at: each ifAbsent: [each asString].
		result := result, jsIdentifier].
	^ self escapeReservedWord: result! !

!OCSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 3/29/2011 10:45'!
jsIdentifierFor: aString inMethod: aCompiledMethod
	"Escape reserved js-words and instance variables."
	
	^ (aCompiledMethod notNil and: [ aCompiledMethod methodClass allInstVarNames includes: aString ])
			ifTrue: [
				S2JNode named: 'slotAccess' with: { 
					S2JNode named: 'reservedWord' with: { 'this' }. 
					(self jsInstVarNameFor: aString) asSymbol } ]
			ifFalse: [	
				S2JNode named: 'identifier' with: { self escapeReservedWord: aString } ]! !

!OCSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 3/29/2011 10:46'!
jsInstVarNameFor: aString
	
	^ self escapeCharForIdentifier asString, aString! !

!OCSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 3/29/2011 10:39'!
jsKeywordFor: aString
	"thisContext is not covered, just a stub leading to a not-defined-error.
	The returned association maps from the literal evaluating to the squeak-object to the literal evaluating to the underlying js-object."
	
	^ aString
		caseOf: {
			[ 'self' ] -> [ 'this' -> 'this' ].
			[ 'true' ] -> [ (self escapeReservedWord: 'true') -> 'true' ].
			[ 'false' ] -> [ (self escapeReservedWord: 'false') -> 'false' ].
			[ 'nil' ] -> [ 'nil' -> 'null' ].
			"In Squeak, using super as identifier (e.g. a := super. ) without calling functions on it, seems to have the same effect as using self."
			"Calling super-functions is not handled here"
			[ 'super' ] -> [ 'this' -> 'this' ].
			"thisContext is not implemented in any way"
			[ 'thisContext' ] -> [ 'THIS_CONTEXT' -> 'THIS_CONTEXT' ].
		}
		otherwise: [ self error: 'Cannot translate keyword to JS: ', aString ]! !

!OCSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'ag 3/28/2011 18:10'!
jsReservedWords
	"http://javascript.about.com/library/blreserved.htm"
	
	^ #('abstract' 'as' 'boolean' 'break' 'byte' 'case' 'catch' 'char' 'class' 'continue' 'const' 'debugger' 'default' 'delete' 'do' 'double' 'else' 'enum' 'export' 'extends' 'false' 'final' 'finally' 'float' 'for' 'function' 'goto' 'if' 'implements' 'import' 'in' 'instanceof' 'int' 'interface' 'is' 'long' 'namespace' 'native' 'new' 'null' 'package' 'private' 'protected' 'public' 'return' 'short' 'static' 'super' 'switch' 'synchronized' 'this' 'throw' 'throws' 'transient' 'true' 'try' 'typeof' 'use' 'var' 'void' 'volatile' 'while' 'with' 'arguments'
	
	"Classes, that already exist in javascript, should not be overridden, our squeak-version of these classes will be escaped."
	"TODO if we have an own namespace, these can be removed."
	'Object' 'Function' 'Number' 'Array' 'String'
	)! !

!OCSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 1/10/2011 11:51'!
numberFunction
	
	^ 'number'! !

!OCSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 1/10/2011 11:51'!
primitiveCallFunction
	
	^ 'primitiveDeclaration'! !

!OCSqueakAstToJsAst class methodsFor: 'mapping-identifiers' stamp: 'lw 2/17/2011 16:33'!
squeakCharacterToJsIdentifier
	"Several characters can be used for selectors in squeak but
	are not allowed for JavaScript functionname"
	
	"TODO check, if one of these might be a reserved word (would cause conflicts with unary message named that way). Builds exception-rule."
	
	^ (Dictionary newFrom:
		{$: -> ''.  
		$+ -> 'plus'.
		$- -> 'minus'.
		$* -> 'times'.
		$/ ->  'slash'.
		$\ -> 'backslash'.
		$~ -> 'tilde'.
		$< ->  'less'.
		$> -> 'greater'.
		$= -> 'equals'.
		$@ -> 'at'.
		$% -> 'percent'.
		$& -> 'and'.
		$? -> 'question'.
		$!! -> 'exclamation'.
		$` -> 'backtick'.
		$, -> 'comma'.
		$ -> 'plusminus'.
		$| -> 'pipe'})
			collect: [ :string | self escapeCharForMethod, string ]! !

!OCSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 1/10/2011 11:51'!
stringFunction
	
	^ 'string'! !

!OCSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 1/24/2011 18:42'!
superFunction
	
	^ '_super'! !

!OCSqueakAstToJsAst class methodsFor: 'special functions' stamp: 'ag 3/29/2011 10:32'!
unboxFunction
	
	^ '_unboxObject'! !

!OCSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 2/22/2011 17:33'!
addReturnExpression: statements
	
	(statements isEmpty or: [(statements last name = 'returnExpression') not])
		ifTrue: [
			statements add: (S2JNode returnExpression: { S2JNode reservedWord: 'this' })].! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/9/2010 13:07'!
arguments =
	
	renameTo('arguments')! !

!OCSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'lw 2/22/2011 19:03'!
array =
	// Pack inner nodes in expression-nodes
	
	translate*:elements
	arrayBase(elements collect: [ :each | S2JNode expression: { each }])! !

!OCSqueakAstToJsAst methodsFor: 'ometa helpers' stamp: 'ag 1/13/2011 12:01'!
arrayBase :collection =
	
	wrapAsPrimitive(
		self class arrayFunction.
		'array'.
		collection)! !

!OCSqueakAstToJsAst methodsFor: 'convert exceptions' stamp: 'ag 3/29/2011 09:57'!
association = 
	
	{
	({ ^symbol:key }
	?[ key isSymbol ]
	^symbol:message
	?[ message = #'->' ]
	^translate:value
	-> [ S2JNode slotAssignment: 
		{ key.
		self convertToJsArgument: value }]):result
	}
	-> [ result ]! !

!OCSqueakAstToJsAst methodsFor: 'convert exceptions' stamp: 'ag 3/29/2011 09:57'!
associations = 

	translateNamedWith(#expression. #association)*! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 1/3/2011 14:18'!
binaryExpression =
	
	messageSendExpression! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 2/26/2011 15:26'!
block =
	
	translateNamed('arguments')?:arguments
	methodContent:statements
	
	// All return-statements in the block are nonlocal returns. After that, the last expression into a return-expression like in a method.
	// Nonlocal returns are function calls in JS: nonLocalReturn()
	[ self renameNonLocalReturns: statements ]
	renameLastExpression(statements)
	
	[S2JNode named: 'functionDeclaration' withoutNils: 
		{( arguments 
			ifNotNil: [ arguments ] 
			ifNil: [ S2JNode arguments ] ).
		statements }]:blockContent
	
	-> [(S2JNode functionCall: 
		{ nil.
		self class blockFunction.
		S2JNode arguments: {blockContent}}) ]! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 2/7/2011 21:28'!
braceExpression =
	// take the contents of the expression as it's js-arg-value. In a brace-expression, there is no assigment.
	
	translate*:expressions
	[ expressions do: [ :each | each first jsArgumentValue ifNotNil: [ each jsArgumentValue: each first jsArgumentValue ] ] ]
	arrayBase(expressions)! !

!OCSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'ag 12/16/2010 23:39'!
byteArray =
	
	array! !

!OCSqueakAstToJsAst methodsFor: 'accessing' stamp: 'lw 3/28/2011 18:25'!
calledFunctionNamesAt: aStringOrSymbol put: anotherStringOrSymbol

	(aStringOrSymbol isString or: [ aStringOrSymbol isSymbol ]) ifTrue: [ ^ self calledFunctions at: aStringOrSymbol asSymbol put: anotherStringOrSymbol asSymbol ]! !

!OCSqueakAstToJsAst methodsFor: 'accessing' stamp: 'lw 3/28/2011 16:44'!
calledFunctions
	^ calledFunctions! !

!OCSqueakAstToJsAst methodsFor: 'accessing' stamp: 'lw 3/28/2011 16:44'!
calledFunctions: anObject
	calledFunctions := anObject! !

!OCSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 2/22/2011 19:04'!
cascadeReceiver
	
	^ S2JNode identifier: ('cascadeReceiver', self class escapeCharForIdentifier)! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 2/22/2011 16:17'!
cascadedExpression =
	
	translate:receiver
	translateWithArgument(#keywordExpression. self cascadeReceiver)*:functions
	-> [ self cascadedExpression: functions to: receiver ]! !

!OCSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 2/25/2011 13:57'!
cascadedExpression: functions to: receiver
	"The statements-node created here is later flattened into one flat list of expressions."
	
	| statements |
	statements := S2JNode functionDeclaration:
		{ S2JNode arguments. 
		S2JNode functionContent: 
			{ S2JNode variableDeclaration: 
				{ self cascadeReceiver. 
				S2JNode assignment: { receiver }}}}.
	functions do: [ :each | statements last add: (self expression: (S2JNode expression) add: each)].
	statements last last name: 'returnExpression'.
	^ self
		functionCall: 'apply'
		to: statements
		withArguments: { S2JNode reservedWord: 'this' }! !

!OCSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'ag 1/24/2011 10:29'!
character =
	
	char:char
	wrapAsPrimitive(self class charFunction. 'string'. char asString) // the 'string' here is the node inside the character()-function call. The Printer does not know about characters.
	! !

!OCSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 1/3/2011 16:53'!
checkSingleArgumentSelector: aSymbol
	"Answer, whether aSymbol is a selector for a keyword-message with one argument.
	aSymbol is already is keyword-selector.
	TODO Please implement a better way to do this."
	
	| tokens |
	tokens := aSymbol findTokens: $:.
	^ tokens size = 1 and: [ tokens first = (aSymbol asString subStrings: ':') first ]! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/5/2011 21:19'!
comment =
	//Neccessary to avoid packing String into calls to the string-wrapper function
	^string:string
	
	-> [ S2JNode comment: string asString ]! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/5/2011 20:32'!
comments =
	
	anything:comments
	?[ comments name = 'comments' ]
	(?[comments isEmpty] -> [nil]
|	-> [ comments ])
	! !

!OCSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 3/28/2011 19:43'!
convertToJsArgument: argument

	^ argument jsArgumentValue
		ifNil: [
			self
				functionCall: self class unboxFunction
				to: nil
				withArguments: { argument } ]
		ifNotNil: [ argument jsArgumentValue ]! !

!OCSqueakAstToJsAst methodsFor: 'helpers' stamp: 'LT 2/24/2011 15:21:01.444'!
convertToJsArguments: arguments

	^ arguments collect: [ :argument |
		self convertToJsArgument: argument ]! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/16/2010 23:12'!
doItSnippet =
	// No need to turn the last expression into a returnExpression, like in a method
	
	methodContent! !

!OCSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 4/5/2011 21:52'!
expression =

	comments?:comments
	translate*:nodes
	->[ (comments
			ifNil: [ nodes ]
			ifNotNil: [ {comments}, nodes  ])
		inject: S2JNode expression 
		into: [ :newCollection :each | self expression: newCollection add: each ]]! !

!OCSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 2/25/2011 13:49'!
expression: newCollection add: each
	"kein double dispatch, da Nodes namen haben und nicht nach klassen aufgeteilt sind."
	
	each name = 'returnExpression'
		ifTrue: 
			[ ^each ].
	each name = 'expression'
		ifTrue: 
			[ ^ newCollection 
				addAllLast: each;
				yourself ].
	^ newCollection 
		addLast: each; 
		yourself ! !

!OCSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 3/28/2011 17:39'!
functionCall: selector to: receiver withArguments: arguments
	"In case of a super-call: the functionName is a _super-function-call itself: _super('field')() "
	
	| functionName |
	functionName := selector isString ifTrue: [ self class jsFunctionNameFor: selector ] ifFalse: [ selector ].
	self calledFunctionNamesAt: selector put: functionName.
	^ S2JNode functionCall: {
		receiver.
		functionName.
		S2JNode arguments: arguments }.
	
	! !

!OCSqueakAstToJsAst methodsFor: 'convert exceptions' stamp: 'ag 3/29/2011 09:52'!
globalFunctionCall =
	// Calls of #apply: on Symbols are resolved to global function calls
	
	symbolNode:functionName
	^symbol:message ?[ message = #apply: ]
	jsMethodCall(nil. functionName)! !

!OCSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'ag 1/8/2011 18:22'!
identifier =
	
	^string:name
	-> [ self class jsIdentifierFor: name inMethod: self currentMethod ]! !

!OCSqueakAstToJsAst methodsFor: 'initialization' stamp: 'lw 3/28/2011 16:47'!
initialize

	super initialize.
	self calledFunctions: Dictionary new.! !

!OCSqueakAstToJsAst methodsFor: 'convert exceptions' stamp: 'LT 2/24/2011 15:21:39.486'!
jsArgument =
	
	translate:singleArgument
	-> [ self convertToJsArgument: singleArgument ]! !

!OCSqueakAstToJsAst methodsFor: 'convert exceptions' stamp: 'lw 2/22/2011 19:31'!
jsMethodArguments =
	
	(
	translateNamed('braceExpression'):arguments
	[ arguments last first ]:arguments // Unpack the array-contents
	-> [ self convertToJsArguments: arguments ]
|	jsArgument:argument
	-> [ {argument } asOrderedCollection ]
	)
	
	! !

!OCSqueakAstToJsAst methodsFor: 'convert exceptions' stamp: 'ag 3/31/2011 09:54'!
jsMethodCall :receiver :selector =
	// Sorry, there is no comment here...
	
	jsMethodArguments:args
	[ self
		functionCall: selector
		to: receiver
		withArguments: args ]:result
	-> [ result
			jsArgumentValue: result;
			yourself ]! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 3/29/2011 14:30'!
keywordExpression =

	globalFunctionCall // #aSymbol apply: aParamterCollection --> aSymbol(parameter)
|	messageSendExpression! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/5/2011 20:47'!
messagePattern =
	
	^symbol:selector translate*:arguments
	-> [ S2JNode named: 'header' with: { self class jsFunctionNameFor: selector }, arguments ]! !

!OCSqueakAstToJsAst methodsFor: 'ometa helpers' stamp: 'ag 1/24/2011 19:06'!
messageSendExpression =
	
	superCall
	
|	(translate:receiver ^symbol:selector translate*:arguments
	-> [ self functionCall: selector to: receiver withArguments: arguments ])! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 4/5/2011 20:59'!
method =
	
	translateWith(#messagePattern):header
	comments?:comments
	methodContent:statements
	[ self addReturnExpression: statements ]
	
	-> [ S2JNode named: 'method' withoutNils: { header. comments. statements }]! !

!OCSqueakAstToJsAst methodsFor: 'ometa helpers' stamp: 'robi 3/22/2011 13:47'!
methodContent  =
	// This can also be used in a place, where primitive-declarations are not allowed: the parser already handles that correctly
	// This flattens all expressions (cascaded expressions in the first place) into one flat collection of expressions

	translateNamed('temporaries')?:temporaries
	translateNamed('primitiveDeclaration')*:primitives
	translate?:statements
	-> [ self statements: statements withTemps: temporaries andPrimitives: primitives ]! !

!OCSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'ag 1/9/2011 15:37'!
number =
	// Number-literals are packed into a 'primitive' number-function-call
	
	^number:number
	wrapAsPrimitive(self class numberFunction. 'number'. number)! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 2/7/2011 21:40'!
paranthesizedExpression =
	// I just found this method empty (without comment), don't really remember, why this works, but it does.
	
	translate:content
	-> [ content
		jsArgumentValue: content jsArgumentValue;
		yourself ]! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'lw 2/22/2011 19:06'!
primitiveDeclaration =
	// Some primitive-declarations are just ignored, because the software implementation is perfectly fine.
	
	(?[ self class ignoredPrimitives includes: self currentMethod ]
	anything*
	-> [ nil ])
|	
	(anything // ignored for now. No need to remember the primitive-number, the js-implementation will know which method this is in
	-> [ S2JNode expression:
		{ self functionCall: self class primitiveCallFunction to: nil withArguments: {} } ])! !

!OCSqueakAstToJsAst methodsFor: 'ometa helpers' stamp: 'ag 1/10/2011 11:16'!
renameLastExpression :statements =
	
	[ statements ifNotEmpty: [ 
		(statements last name = 'expression'
			and: [statements last first name = 'functionCall']
				and: [statements last first second = 'nonLocalReturn'])
		 			ifFalse: [ statements last name: 'returnExpression' ] ] ]! !

!OCSqueakAstToJsAst methodsFor: 'helpers' stamp: 'ag 1/10/2011 11:12'!
renameNonLocalReturns: statements
	
	^ statements doWithIndex: [ :st :index |
		st name = 'returnExpression' 
			ifTrue: [ | contents |
				st name: 'expression'.
				contents := st first.
				st removeAll; add: (self functionCall: 'nonLocalReturn' to: nil withArguments: { contents }) ]]! !

!OCSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'lw 2/19/2011 20:40'!
reservedWord =
	
	^string:keyword
	[ self class jsKeywordFor: keyword ]:jsAndSqueakKeyword
	-> [ self reservedWordNodeFor: jsAndSqueakKeyword ]! !

!OCSqueakAstToJsAst methodsFor: 'helpers' stamp: 'lw 2/22/2011 19:06'!
reservedWordNodeFor: anAssociation
	
	| result |
	result := S2JNode reservedWord: anAssociation key.
	(self class isKeywordLiteral: anAssociation value) 
		ifTrue: [
			result jsArgumentValue: (S2JNode reservedWord: anAssociation value)].
	^ result! !

!OCSqueakAstToJsAst methodsFor: 'accessing' stamp: 'lw 4/5/2011 20:52'!
returnExpression =

	comments?:comment
	translate*:nodes
	-> [ S2JNode returnExpression: nodes ]! !

!OCSqueakAstToJsAst methodsFor: 'convert exceptions' stamp: 'lw 2/28/2011 22:39'!
serverBlock =
	
	&anything:block
	translateNamed('block') ^symbol:selector
	?[ selector = #onServer ]
	-> [ self
		functionCall: 'serverBlock'
		to: nil
		withArguments: { S2JNode string: block originalCode } ]! !

!OCSqueakAstToJsAst methodsFor: 'helpers' stamp: 'robi 3/22/2011 13:47'!
statements: aNode withTemps: anElement andPrimitives: anElementCollection
	"All nils in the primitives-collection are removed (can occur, see #primitiveDeclaration)"
	
	| result |
	result := aNode ifNil: [ S2JNode statements ] ifNotNil: [ aNode ].
	anElement ifNotNil: [ result addFirst: anElement; yourself ].
	anElementCollection ifNotNil: [
		result addAllFirst: (anElementCollection reject: [ :each | each isNil ]); yourself ].

	^ result name: 'functionContent'; yourself! !

!OCSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'ag 1/9/2011 15:37'!
string =
	// String/Symbol-literals are packed into a 'primitive' string-function-call
	
	^string:string // Also covers symbols
	wrapAsPrimitive(self class stringFunction. 'string'. string asString)! !

!OCSqueakAstToJsAst methodsFor: 'convert exceptions' stamp: 'lw 2/22/2011 19:27'!
superCall =
	// An exception to a message-send-expression: super-calls are translated in this way.
	
	{ ^string:superKeyword }:superNode ^symbol:selector translate*:arguments
	?[ superNode name = 'reservedWord' & superKeyword = 'super' ]
	-> [ 
		self
			functionCall: 
				(self
					functionCall: self class superFunction
					to: nil
					withArguments: { S2JNode string: (self class jsFunctionNameFor: selector asString) })
			to: nil
			withArguments: arguments ]! !

!OCSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'LT 4/5/2011 14:45:44.938'!
symbol =
	
	string! !

!OCSqueakAstToJsAst methodsFor: 'convert tokens' stamp: 'lw 2/21/2011 18:27'!
symbolNode =
	
	^anything:symbolNode
	?[ symbolNode name  = 'symbol']
	-> [symbolNode at: 1]! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'ag 12/16/2010 12:31'!
temporaries =
	
	renameTo('variableDeclaration'):temporaries
	[ temporaries ifEmpty: [ nil ] ifNotEmpty: [ temporaries ] ]! !

!OCSqueakAstToJsAst methodsFor: 'convert complex' stamp: 'sw 3/31/2011 14:34'!
unaryExpression =

	serverBlock // [ 'a + b' ] onServer value   -->   onServer("a + b").value()
|	messageSendExpression! !

!OCSqueakAstToJsAst methodsFor: 'ometa helpers' stamp: 'lw 2/22/2011 19:21'!
wrapAsPrimitive :functionName :nodeName :wrappedObject =
	// Wrap an object into a node, that will result in a function-call to functionName with the object as argument
	
	[ S2JNode
		named: nodeName
		with: ( wrappedObject isCollection & wrappedObject isString not
			ifTrue: [ wrappedObject ]
			ifFalse: [ { wrappedObject } ]) ]:primitiveObject
	[ self
		functionCall: functionName
		to: nil
		withArguments: { primitiveObject } ]:result
	
	-> [ result
		jsArgumentValue: primitiveObject;
		yourself ]! !

!OCOMeta2 class methodsFor: 'helpers' stamp: 'ag 2/1/2011 10:34'!
allMethodsDo: aBlock
	"Execute aBlock with each parsable method in the image and return the sum of visited methods and classes."
	
	| numberOfObjects |
	numberOfObjects := 0.
	Smalltalk allClasses do: [ :eachClass |
		eachClass methodDict notEmpty  ifTrue: [
			numberOfObjects := numberOfObjects + 1.
			eachClass methodDict do: [ :eachMethod |
				numberOfObjects := numberOfObjects + 1.
				aBlock value: eachMethod ]]].
	^ numberOfObjects! !

!OCOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/15/2010 16:25'!
allMethodsDoAndReport: aBlock
	"Execute aBlock for each method in the image, print which methods have failed
	and notify each 500 methods. Print status-report at the end."
	
	| converted succeeded total |
	converted := -1.
	succeeded := 0.
	total := Smalltalk allClasses inject: 0 into: [ :sum :each | sum + each methodDict size].
	Transcript cr; show: 'Total methods in image: ', total asString.
	[
		self allMethodsDo: 
			[ :eachMethod |
				[ converted := converted + 1. aBlock value: eachMethod. succeeded := succeeded + 1.
				(converted \\ 500 = 0) ifTrue: [ Transcript cr; show: 'Converted ', converted asString, ' methods.' ]
				]
					on: Exception do: [ :err | Transcript cr; show: '	', converted asString, ': ', eachMethod name, ' (', err, ')' ]].
	]
		ensure: [ Transcript cr; show: 'Finished!! ', succeeded asString, ' of ', converted asString, ' operations succeeded!!' ].! !

!OCOMeta2 class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:20'!
applyRule: aRule on: aMatcher
	
	^ aMatcher apply: aRule! !

!OCOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/13/2010 14:34'!
classNamed: aClassOrClassname
	
	^ Smalltalk classNamed: aClassOrClassname asString! !

!OCOMeta2 class methodsFor: 'converting' stamp: 'LT 3/16/2011 14:13:51.508'!
convert: aString as: aRule
	
	^ (self convert: aString as: aRule insideMethod: nil) value! !

!OCOMeta2 class methodsFor: 'converting' stamp: 'lw 3/28/2011 17:51'!
convert: aString as: aRule insideMethod: aCompiledMethod
	"Returns both the matcher and the result as an association."
	
	| matcher result input |
	input := self createInputFrom: aString as: aRule insideMethod: aCompiledMethod.
	matcher := self matcherOn: input value readStream.
	matcher
		currentMethod: aCompiledMethod;
		apply: #empty.
	result := self applyRule: aRule on: matcher.
	matcher apply: #spaces.
	self finalizeMatcher: matcher.
	matcher apply: #end.
	^(input key isNil and: [ matcher respondsTo: #calledFunctions ]) 
		ifTrue: [ matcher calledFunctions -> result ]
		ifFalse: [ input key -> result ]! !

!OCOMeta2 class methodsFor: 'tests' stamp: 'ag 12/15/2010 16:26'!
convertAllMethods
	"Convert all methods in this image."
	
	self allMethodsDoAndReport: [ :eachMethod | 
		self convertCompiledMethod: eachMethod].! !

!OCOMeta2 class methodsFor: 'tests' stamp: 'LT 3/16/2011 14:07:52.228'!
convertAllMethodsOf: aClass
	
	^ aClass methodDict notEmpty
		ifTrue: [ | methods |
			methods := Dictionary new.
			aClass methodDict valuesDo:
				[ :method | | result |
					[ result := self convertCompiledMethod: method ]
						on: Exception do: [ :err | self error: 'Failed to convert ', method printString, ': ', err ].
					methods at: result key put: result value].
			methods]
		ifFalse: [ self error: 'Cannot convert class ', aClass name ]! !

!OCOMeta2 class methodsFor: 'converting' stamp: 'LT 3/16/2011 14:13:42.27'!
convertCompiledMethod: aCompiledMethod
	
	^ (self
		convert: (
			(aCompiledMethod methodClass compilerClass == Compiler)
				ifTrue: [ self sourceOf: aCompiledMethod ]
				ifFalse: [ self decompiledSourceOf: aCompiledMethod ])
		as: #method
		insideMethod: aCompiledMethod) value! !

!OCOMeta2 class methodsFor: 'converting' stamp: 'ag 12/13/2010 16:06'!
convertDoIt: aString
	
	^ self convert: aString as: #doItSnippet! !

!OCOMeta2 class methodsFor: 'converting' stamp: 'ag 12/8/2010 18:19'!
convertMethod: aString
	
	^ self convert: aString as: #method! !

!OCOMeta2 class methodsFor: 'converting' stamp: 'ag 1/19/2011 15:57'!
convertMethod: aStringOrSymbol of: aClassOrClassname
	
	| method |
	method := self method: aStringOrSymbol of: aClassOrClassname.
	^ method
		ifNotNil: [ self convertCompiledMethod: method ]
		ifNil: [  ]! !

!OCOMeta2 class methodsFor: 'tests' stamp: 'ag 12/13/2010 08:44'!
convertRandomMethods: aNumber
	"Match some random methods from the image. Return a String summarizing the result.
	Failed methods are printed to the Transcript."
	
	| runs successes |
	runs := successes := 0.
	aNumber timesRepeat: 
		[ | method |
			method := self randomMethod.
			method ifNotNil: [
				[ runs := runs + 1. S2JParser convertCompiledMethod: method. successes := successes + 1 ]
					on: Error do: [ :err | Transcript cr; cr; show: 'Failed to parse: ', method name, '. ', err ]]].
	^ runs asString, ' runs, ', successes asString, ' successes'! !

!OCOMeta2 class methodsFor: 'converting' stamp: 'ag 12/8/2010 18:08'!
convertStatements: aString
	
	^ self convert: aString as: #statements! !

!OCOMeta2 class methodsFor: 'converting' stamp: 'LT 3/16/2011 14:37:35.181'!
convertTranslatedMethod: aTranslatedMethod
	
	| compiledMethod |
	compiledMethod := aTranslatedMethod squeakObject.
	^ self
		convert: (
			(compiledMethod methodClass compilerClass == Compiler)
				ifTrue: [ self sourceOf: compiledMethod ]
				ifFalse: [ self decompiledSourceOf: compiledMethod ])
		as: #method
		insideMethod: compiledMethod.! !

!OCOMeta2 class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:12'!
createInputFrom: aString as: aRule insideMethod: aCompiledMethod
	
	self subclassResponsibility! !

!OCOMeta2 class methodsFor: 'helpers' stamp: 'ag 2/1/2011 10:31'!
decompiledSourceOf: aCompiledMethod
	
	^ aCompiledMethod decompile decompileString! !

!OCOMeta2 class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:04'!
finalizeMatcher: anOMeta2
	"Do nothing, overwrite if needed to apply anything before applying #end"! !

!OCOMeta2 class methodsFor: 'helpers' stamp: 'ag 1/19/2011 15:59'!
method: aStringOrSymbol of: aClassOrClassname
	
	^ self
		method: aStringOrSymbol
		of: aClassOrClassname 
		ifAbsent: [ self error: 'Method ', aStringOrSymbol asString, ' not found in class ', aClassOrClassname asString ]! !

!OCOMeta2 class methodsFor: 'helpers' stamp: 'ag 1/19/2011 15:59'!
method: aStringOrSymbol of: aClassOrClassname ifAbsent: aBlock
	
	^ ((self classNamed: aClassOrClassname)
		lookupSelector: aStringOrSymbol asSymbol)
			ifNil: [ aBlock value ]! !

!OCOMeta2 class methodsFor: 'helpers' stamp: 'ag 1/10/2011 08:58'!
print: aString to: aFilename
	"Create new file aFilename (or override) and write aString in it"
	
	^ aString squeakToUtf8 putOn: (FileStream forceNewFileNamed: aFilename)! !

!OCOMeta2 class methodsFor: 'helpers' stamp: 'ag 2/1/2011 10:33'!
randomMethod
	
	| class result |
	result := nil.
	[ result isNil ] whileTrue: [
		class := Smalltalk allClasses atRandom.
		class methodDict notEmpty
			ifTrue: [ result := class methodDict atRandom ]].
	^ result! !

!OCOMeta2 class methodsFor: 'helpers' stamp: 'ag 12/8/2010 18:18'!
sourceOf: aCompiledMethod
	
	^ aCompiledMethod getSource asString! !

!OCOMeta2 methodsFor: 'helpers' stamp: 'ag 12/8/2010 22:53'!
H =
	
	[ self halt ]! !

!OCOMeta2 methodsFor: 'accessors' stamp: 'ag 12/22/2010 15:48'!
currentMethod
	
	^ currentMethod! !

!OCOMeta2 methodsFor: 'accessors' stamp: 'ag 12/22/2010 15:48'!
currentMethod: aCompiledMethod
	
	currentMethod := aCompiledMethod! !

!OCOMeta2 methodsFor: 'helpers' stamp: 'ag 12/8/2010 14:35'!
fail =
	
	?[ false ]! !

!OCOMeta2 methodsFor: 'helpers' stamp: 'ag 12/13/2010 12:48'!
nil =
	
	anything:object ?[ object isNil ]
	-> [ object ]! !

!OCOMeta2 methodsFor: 'helpers' stamp: 'ag 12/9/2010 12:16'!
node: aString
	
	^ self node: aString with: {}! !

OCOMeta2 subclass: #OCParser
	instanceVariableNames: 'comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orca-Translator'!

!OCParser commentStamp: 'ag 12/7/2010 23:09' prior: 0!
tokens
	Rules, that read one single element in squeal source-code. They all don't return an S2JNode, all are parsed to the
	according Squeak-object (e.g. Number, Symbol, String).
	Spaces before and after the tokens in the source-code are NOT read!!
	This is because in some cases, tokens must be read exactly, without emitting any spaces.
	The things returned from here must not be converted anymore, especially the <> operator is unnecessary.
	
complex elements
	Bigger parts of squeak source-code. Most return an S2JNode (using #node:with:), which contains further complex elements or object read
	by rules in the tokens-protocol. As convention, the nodes (except for helper-rules like primary and messagePattern) should be named like the rules.
	Each rule is supposed to read spaces before applying itself!! This way, rules from this protocol can be called serially, without
	reading spaces inbetween. However, spaces must be read between single tokens.
	
helpers
	Squeak-methods, that are called from within ometa-rules (or helper-rules).
	OMeta2 return-parts of the rules (righthand of ->) cannot contain multiple expressions (?)...
!

!OCParser class methodsFor: 'converting private' stamp: 'lw 3/28/2011 17:28'!
createInputFrom: aString as: aRule insideMethod: aCompiledMethod
	
	^ nil -> aString! !

!OCParser class methodsFor: 'converting private' stamp: 'ag 12/22/2010 16:07'!
finalizeMatcher: anOMeta2
	
	anOMeta2 apply: #spaces.! !

!OCParser class methodsFor: 'parsing' stamp: 'ag 12/1/2010 11:04'!
parseNumber: aString
	"Parse aString to an instance of Number. Return nil, if parsing failed.
	Return nil also, if a number could be read, but not the whole String was processed.
	(Number readFrom: aString does not fail in that case)."
	
	| stream result |
	stream := ReadStream on: aString.
	result := Number readFrom: stream ifFail: [ nil ].
	stream atEnd ifFalse: [ result := nil ].
	^ result! !

!OCParser methodsFor: 'parse easy' stamp: 'LT 4/5/2011 13:59:18.802'!
array =
	
	$(
		(
			(spaces
				(((($# spaces)? array:array) -> [ array ])
				| nodeNamed(#symbolBaseForArray. 'symbol')
				| literalTokenBase
				):element
			) -> [ element ]
		)*:contents
	ch($))
	-> [ S2JNode array: contents ]! !

!OCParser methodsFor: 'parse complex' stamp: 'lw 2/22/2011 19:18'!
binaryExpression =
	
	(binaryExpression | unaryExpression | primary):receiver
	spaces:comment binaryExpressionMessage:message
	-> [ S2JNode named: 'binaryExpression' withoutNils:
		{ self extractCommentOf: comment. receiver }, message ]! !

!OCParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:09'!
binaryExpressionMessage =
	// Not returning a node, but a simple collection
	
	binarySelector:selector
	(unaryExpression | primary):argument
	-> [ { selector. argument } ]! !

!OCParser methodsFor: 'parse tokens' stamp: 'ag 12/1/2010 13:32'!
binarySelector =
	
	<$| | ((specialCharacter | $-) specialCharacter*)>:selector
	-> [ selector asSymbol ]! !

!OCParser methodsFor: 'parse complex' stamp: 'lw 2/22/2011 19:18'!
block =
	
	<
	ch($[):comment1
		( (ch($:) spaces identifier:argumentName -> [ argumentName ])+:arguments ch($|)?:argumentSeparator )?
		temporaries?:temporaries
		statements?:statements
	ch($]):comment2
	>:originalCode
		
	// Forbidden (and not covered above): Arguments without separator bar, but with statements or temporaries
	?[ argumentSeparator notNil | arguments isNil | ((temporaries isNil or: [temporaries isEmpty]) & (statements isNil or: [statements isEmpty])) ]
	
	-> [ (S2JNode named: 'block' withoutNils: { self extractCommentOf: comment1.
			S2JNode named: 'arguments' withoutNilsNotEmpty: arguments.
			temporaries. statements.
			self extractCommentOf: comment2})
				originalCode: originalCode ]! !

!OCParser methodsFor: 'parse complex' stamp: 'ag 12/13/2010 21:32'!
braceExpression =
	
	ch(${):comment1
		(expression:expr ch($.) -> [ expr ] )*:expressions
		expression?:lastExpression
	ch($}):comment2
	
	-> [ self braceExpressionWith: expressions and: lastExpression ]! !

!OCParser methodsFor: 'helpers' stamp: 'lw 2/22/2011 19:22'!
braceExpressionWith: expressions and: lastExpression
	
	^ S2JNode named: 'braceExpression' withoutNils: 
		((expressions
			ifNotNil: [ expressions ]
			ifNil: [ {} ])
				asOrderedCollection
					add: lastExpression;
					yourself)! !

!OCParser methodsFor: 'parse easy' stamp: 'lw 2/22/2011 18:34'!
byteArray =
	// Byte array can only contain number-objects, don't pack them into nodes
	
	$# ch($[)
		(
			(spaces number:number [ number first ]:byte
			?[ (byte isInteger) & (byte <= 255) & (byte >= 0)] 
			) -> [ byte ]
		)*:contents
	ch($])
	-> [ S2JNode byteArray: contents ]! !

!OCParser methodsFor: 'parse complex' stamp: 'lw 2/22/2011 18:36'!
cascadedExpression =
	// Constructs a node, whose first node is the receiver and all further nodes are messages sent to that receiver
	
	(keywordExpression | binaryExpression | unaryExpression):mainExpression
	(
		ch($;)
		(
		((spaces binarySelector:selector (unaryExpression | primary):argument) -> [ S2JNode binaryExpression: { selector. argument }])
		| (((spaces keyword:selector (binaryExpression | unaryExpression | primary):argument) -> 
				[ selector -> argument])+:selectorsAndArguments -> [ (self keywordMessage: selectorsAndArguments) name: 'keywordExpression' ])
		| (spaces unarySelector:selector -> [ S2JNode unaryExpression: { selector } ])
		):cascade
		-> [ cascade ]
	)+:cascades
	-> [ self cascadedExpression: mainExpression with: cascades ]! !

!OCParser methodsFor: 'helpers' stamp: 'lw 2/22/2011 19:20'!
cascadedExpression: mainExpression with: cascades
	"The receiver of the mainExpression is the receiver of the whole cascade.
	It is the first node, the other nodes are the messages sent to that receiver"
	
	^ S2JNode named: 'cascadedExpression' withoutNils: 
		((cascades
			ifNotNil: [ cascades ]
			ifNil: [ {} ])
				asOrderedCollection
					addFirst: mainExpression;
					addFirst: mainExpression removeFirst;
					yourself)! !

!OCParser methodsFor: 'ometa helpers' stamp: 'ag 11/30/2010 11:01'!
ch :c =
	// This reads a given element and all spaces before it and return the element
	// ch was supposed to mean character, but this can be applied to any object
	// Called like this: ch($=)
	
	spaces:comment exactly(c)
	-> [ comment ]! !

!OCParser methodsFor: 'parse easy' stamp: 'lw 2/22/2011 18:38'!
character =
	// The method in the super class is #char, don't confuse it!!
	
	( ($$ <anything>:value) | (seq('Character space') -> [ $  ]):value )
	-> [ S2JNode character: value asCharacter ]! !

!OCParser methodsFor: 'helpers' stamp: 'ag 1/25/2011 14:43'!
consumedBy: aBlock
	
	| result |
	result := super consumedBy: aBlock.
	result isString
		ifFalse: [ result := result separatedBy: '' ].
	^ result! !

!OCParser methodsFor: 'parse complex' stamp: 'lw 2/22/2011 19:22'!
doItSnippet =
	
	temporaries?:temps
	statements?:statements
	-> [ S2JNode named: 'doItSnippet' withoutNils: { temps. statements } ]! !

!OCParser methodsFor: 'parse complex' stamp: 'lw 4/5/2011 20:41'!
expression =
	
	[ self startCollectingComments ]
	((spaces identifier:identifier (token(':=') | ch($_))) -> [ identifier ])*:variableNames 
	(cascadedExpression | keywordExpression | binaryExpression | unaryExpression | primary):expressionBody
	[ self stopCollectingComments ]:comment
	
	// First child is the expressionBody, further children are names of variables, that are assigned by this expression
	-> [ S2JNode named: 'expression' withoutNils: ({ comment. expressionBody }, variableNames) ]! !

!OCParser methodsFor: 'helpers' stamp: 'lw 2/22/2011 18:39'!
extractCommentOf: anOrderedCollection
	
	| result |
	true ifTrue: [^ nil]. "TODO skip all comments for now..."
	result := ''.
	anOrderedCollection do: [:item |
		item name = 'comment' ifTrue: [
			result := result , item first
			]].
	^ result isEmpty
		ifTrue: [nil]
		ifFalse: [self comment: result]! !

!OCParser methodsFor: 'parse easy' stamp: 'lw 2/22/2011 18:40'!
identifier =
	
	nodeNamed(#identifierBase. 'identifier')
|	(<$_ identifierBase>:decompiledIdentifier -> [ S2JNode identifier: decompiledIdentifier ])! !

!OCParser methodsFor: 'parse tokens' stamp: 'ag 11/30/2010 11:03'!
identifierBase =
	
	<letter letterOrDigit*>! !

!OCParser methodsFor: 'commentTracing' stamp: 'lw 4/5/2011 21:04'!
initialize

	comments := Stack new.
	comments push: S2JNodeNilObject new! !

!OCParser methodsFor: 'parse tokens' stamp: 'ag 11/22/2010 16:34'!
keyword =
	
	<identifierBase $:>:selector
	-> [ selector asSymbol ]! !

!OCParser methodsFor: 'parse complex' stamp: 'lw 2/22/2011 18:41'!
keywordExpression =
	
	(binaryExpression | unaryExpression | primary):receiver
	keywordExpressionMessage:message
	-> [S2JNode keywordExpression: { receiver }, message ]! !

!OCParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:06'!
keywordExpressionMessage =
	
	(((spaces keyword:selector ( binaryExpression | unaryExpression | primary ):argument) -> [ selector -> argument ])+:selectorAndArguments)
	-> [ self keywordMessage: selectorAndArguments ]! !

!OCParser methodsFor: 'helpers' stamp: 'lw 2/22/2011 19:19'!
keywordMessage: selectorAndArgumentNames
	"selectorAndArgumentNames contains associations, the part of the selector and the argument name.
	Resulting S2JNode will have the selector as symbol on the first position and the argumentNames at the other positions."
	
	| selector result |
	selector := ''.
	result := S2JNode named: 'keyword'.
	selectorAndArgumentNames do: [ :each |
		selector := selector, each key.
		result add: each value].
	^ result
		addFirst: selector asSymbol;
		yourself! !

!OCParser methodsFor: 'parse tokens' stamp: 'lw 2/22/2011 18:43'!
literalReservedWord =
	// Copy of reservedWord, with only the static values
	
	<(seq('true') | seq('false') | seq('nil'))>:reservedWord
	&(binarySelector | space | end | $] | $. | $; | $} | $)) // Look ahead to ensure, that this token ends here, don't match e.g. self2, but match self/2
	-> [ S2JNode reservedWord: reservedWord ]! !

!OCParser methodsFor: 'parse easy' stamp: 'LT 4/5/2011 13:59:27.53'!
literalToken =
	// Anything, that can be evaluated to an object without context
	
	literalTokenBase
|	(($# spaces array:array) -> [ array ])! !

!OCParser methodsFor: 'parse tokens' stamp: 'ag 12/16/2010 16:08'!
literalTokenBase =
	// Things, that can be evalutated to an object without any context (array-literals excluded)
	
	literalReservedWord
|	number
|	symbol
|	character
|	string
|	byteArray! !

!OCParser methodsFor: 'parse complex' stamp: 'LT 4/5/2011 14:55:19.442'!
messagePattern =
	
	((spaces keyword:selectorPart spaces identifier:argumentName) -> [ selectorPart -> argumentName ])+:selectorAndArgumentNames
	-> [ self keywordMessage: selectorAndArgumentNames ]
|	spaces binarySelector:selector spaces identifier:argumentName
	-> [ S2JNode binaryExpression: { selector. argumentName } ]	
|	spaces unarySelector:unarySelector
	-> [ S2JNode unaryExpression: { unarySelector } ]! !

!OCParser methodsFor: 'parse complex' stamp: 'lw 4/6/2011 09:24'!
method =
	// Only one temporaries-declaration allowed, but can be before or after primitive-declaration
	
	messagePattern:head
	[ self startCollectingComments ]
	temporaries?:temps
	primitiveDeclaration*:primitives
	temporaries?:secondTemps ( ?[secondTemps isNil]  | (?[temps isNil] [secondTemps]:temps) )
	[ self stopCollectingComments ]:comment
	statements?:statements
	
	-> [ S2JNode named: 'method' withoutNils: { head. comment. temps }, primitives, { statements } ]! !

!OCParser methodsFor: 'ometa helpers' stamp: 'lw 2/22/2011 18:55'!
nodeNamed :aRule :aNodeName =
	// Helper rule to encapsulate the result of a rule into a node
	
	apply(aRule):result
	-> [ S2JNode named: aNodeName asString with: { result } ]! !

!OCParser methodsFor: 'parse easy' stamp: 'lw 2/22/2011 18:48'!
number =
	// Called that way because of super-class-method
	// The string is parsed once, assuring, that
	
	<
		($-? digit+ $r)?
		$-?
		(digit | upper)+
		($. (digit | upper)+)?
		($e ($- | $+)? (digit | upper)+)?
	>:result
	?[ (self class parseNumber: result) notNil ]
	-> [ S2JNode number: (self class parseNumber: result) ]
	
	// An alternative way to evaluate a number...
	| ($# <digit>:value) -> [ S2JNode number: value asNumber ]! !

!OCParser methodsFor: 'parse complex' stamp: 'ag 12/16/2010 23:55'!
primary =
	// something, that evaluates to an object
	
	spaces (literalToken | reservedWord | identifier):result -> [ result ]
|	block
|	braceExpression
|	ch($() expression:expr ch($)) -> [ expr name: 'paranthesizedExpression'; yourself ]! !

!OCParser methodsFor: 'parse complex' stamp: 'lw 2/22/2011 18:54'!
primitiveDeclaration =
	// Reads generally all primitive declarations, there are many of them
	// <primitive: 'a'> <primitive: 2> <primitive: 'a' module: 'b'> <version: 'ab'> <command> etc. etc.
	
	ch($<)
		(
			primitiveDeclarationRule(#keywordExpressionMessage)
			| (space primitiveDeclarationRule(#binaryExpressionMessage))
			| primitiveDeclarationRule(#unaryExpressionMessage)
		):message
	ch($>)
	-> [ S2JNode named: 'primitiveDeclaration' with: { message } ]! !

!OCParser methodsFor: 'ometa helpers' stamp: 'ag 12/16/2010 23:31'!
primitiveDeclarationRule :aRule =
	// Read everything, that is inside the <>-primitive-declaration; write it back on the input stream, followed
	// by input, that will not be matched. Apply the rule and read the fake-input. Return the result after applying the rule.
	
	// This allows things, that are forbidden, like <primive: a> (a is an identifier and has been accepted, because it's also a unarySelector
	
	<
		((
			<spaces (literalToken | unarySelector | binarySelector | keyword)>:input ?[ (input includesSubString: '>') not ]
		) -> [ input ])*
	>:primitiveInput
	[ self apply: aRule withArgs: primitiveInput, '^^' ]:result
	$^ $^
	-> [ result ]! !

!OCParser methodsFor: 'parse easy' stamp: 'lw 2/22/2011 18:50'!
reservedWord =
	
	<(seq('true') | seq('false') | seq('nil') | seq('self') | seq('super') | seq('thisContext') )>:reservedWord
	&(binarySelector | space | end | $] | $. | $; | $} | $)) // Look ahead to ensure, that this token ends here, don't match e.g. self2, but match self/2
	-> [ S2JNode reservedWord: reservedWord ]! !

!OCParser methodsFor: 'parse tokens' stamp: 'LT 4/5/2011 13:40:14.314'!
space =
	// A comment is equivalent to a space-character.
	// spaces are ignored (return nil), but comments result in a special node and are collected
	
	^space -> [ nil ]
	| (($" <(~$" anything)*>:result $") -> [ S2JNode comment: result  ])! !

!OCParser methodsFor: 'parse easy' stamp: 'lw 4/6/2011 09:23'!
spaces =

	space*:whitespaces
	[ comments top addAllWhitoutNils: whitespaces ]! !

!OCParser methodsFor: 'parse tokens' stamp: 'srv 2/16/2011 17:36'!
specialCharacter =
	
	$+ | $* | $/ | $\ | $~ | $< | $> | $= | $@ | $% | $& | $? | $!! | $` | $, | $! !

!OCParser methodsFor: 'commentTracing' stamp: 'lw 4/5/2011 21:04'!
startCollectingComments

	comments push: (S2JNode comments: {})! !

!OCParser methodsFor: 'parse complex' stamp: 'ag 12/13/2010 18:58'!
statements =
	
	(expression?:expr ch($.) -> [ expr ] )*:expressions
	(ch($^)?:returnSign expression:lastExpression ch($.)? ~expression)?
	-> [ self statementsWithExpressions: expressions lastExpression: lastExpression returnSign: returnSign ]! !

!OCParser methodsFor: 'helpers' stamp: 'lw 2/22/2011 18:51'!
statementsWithExpressions: expressions lastExpression: lastExpression returnSign: returnSign
	"Build the contents of a statements-node from the information gathered while parsing 'statements'"
	
	"Rename the last expression, if it was a return-expression"
	lastExpression notNil & returnSign notNil ifTrue: [
		lastExpression name = 'expression'
			ifTrue: [ lastExpression name: 'returnExpression' ]
			ifFalse: [ self error: 'Unexpected node at return-sign: ', lastExpression printString ]].
	expressions
		add: lastExpression;
		reject: [ :each | each isNil ].
	^ S2JNode named: 'statements' withoutNilsNotEmpty: expressions! !

!OCParser methodsFor: 'commentTracing' stamp: 'lw 4/5/2011 21:07'!
stopCollectingComments
	
	^ comments pop ifEmpty: [ nil ]! !

!OCParser methodsFor: 'parse easy' stamp: 'lw 2/22/2011 18:52'!
string =
	// Called that way because of super-class-method
	
	$' ((~$' anything) | (($' $') -> [ $' ]))*:values $'
	-> [ S2JNode string: (values asOrderedCollection inject: '' into: [ :a :b | a, b asString ]) ]! !

!OCParser methodsFor: 'parse easy' stamp: 'lw 4/5/2011 21:11'!
symbol =
	
	$# spaces (symbolBase | (string:stringSymbol -> [ stringSymbol first ])):value 
	-> [ S2JNode symbol: value asSymbol ] 
	! !

!OCParser methodsFor: 'parse tokens' stamp: 'ag 12/13/2010 21:45'!
symbolBase =
	// This does not return a symbol, just consume input. Inside of array, symbols can be represented without
	// the #-character
	
	binarySelector
|	<keyword+ identifierBase>
|	<keyword+>
|	identifierBase
|	($: | $. | ($[ $]) | ${ | $} | $] | $^):result -> [ result asSymbol ]! !

!OCParser methodsFor: 'parse tokens' stamp: 'ag 12/16/2010 16:09'!
symbolBaseForArray =
	
	(~literalReservedWord
	(
		symbolBase
		| $[
	):result)
	-> [ result asSymbol ]! !

!OCParser methodsFor: 'parse complex' stamp: 'lw 2/22/2011 18:53'!
temporaries =
	
	ch($|)
		(spaces identifier:identifier -> [ identifier ])*:variableNames
	ch($|)
	-> [ S2JNode temporaries: variableNames ]! !

!OCParser methodsFor: 'parse complex' stamp: 'lw 2/22/2011 18:58'!
unaryExpression =
	
	(unaryExpression | primary):receiver unaryExpressionMessage:message
	-> [ S2JNode unaryExpression: {receiver. message} ]! !

!OCParser methodsFor: 'parse complex' stamp: 'ag 12/7/2010 12:07'!
unaryExpressionMessage =
	
	spaces unarySelector:message
	-> [ message ]! !

!OCParser methodsFor: 'parse tokens' stamp: 'ag 12/2/2010 11:51'!
unarySelector =
	
	identifierBase:selector ~$:
	-> [ selector asSymbol ]! !
